package com.example.administrator.wingcool_gt9_apk;

import android.app.Activity;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.content.res.Resources;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.hardware.usb.UsbConstants;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbEndpoint;
import android.hardware.usb.UsbInterface;
import android.hardware.usb.UsbManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.view.ViewPager;
import android.support.v7.app.AppCompatActivity;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.View;
import android.view.animation.Animation;
import android.view.animation.TranslateAnimation;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.common.server.converter.StringToIntConverter;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.RandomAccessFile;
import java.io.Reader;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 *
 */

public class Config extends AppCompatActivity
        //implements OpenDevicesReceiver.OpenDevicesListener, View.OnClickListener , ViewPager.OnPageChangeListener, AdapterView.OnItemSelectedListener{
        implements OpenDevicesReceiver.OpenDevicesListener, View.OnClickListener , ViewPager.OnPageChangeListener{

    private static final int CONNECTED_SUCCESS = 0;
    private static final int RECEIVER_MESSAGE_SUCCESS = 1;
    private static final int SEND_MESSAGE_SUCCESS = 2;
    private static final int DEBUG_MESSAGE_SUCCESS = 3;
    private static final int DEBUG_MESSAGE_ERROR = 4;

    private static final String USB_ACTION = "com.host2device";
    private static final String ACTION_USB_PERMISSION = "com.host2device.USB_PERMISSION";
    private ExecutorService mThreadPool;
    private UsbManager mUsbManager;
    private OpenDevicesReceiver cfgOpenDevicesReceiver;
    private UsbDeviceConnection mUsbDeviceConnection;

    private UsbEndpoint mUsbEndpointOut;
    private UsbEndpoint mUsbEndpointIn;
    private Button mReadCfg;
    private Button mSendCfg;
    private byte[] mBytes = new byte[1024];
    private byte[] mSendData = new byte[1024];
    private String[] mConfigShow = new String[400];

    private Context mAlertContext;

    String value;

    private boolean isNeedFindDevice  = true;

    private int bottonMode = 0;

    private UsbInterface mUsbInterface;
    private StringBuffer mStringBuffer = new StringBuffer();
    private Context mContext;

    private Button search_button;
    private TextView edit_search;
    private EditText edit_text;

    private EditText editname;
    //private EditText editdetail;
    private Button btnsave;
    private Context mSaveCfgContext;

    private TextView mShow;
    private TextView tvVenderID;

    //View Sample 定义
    private CheckBox cbAllDrivingEn,cbDualFreq;
    private EditText edtFreqAFactor,edtFreqBFactor;
    private EditText edtPannelBitFreq,edtDuration;  //2 bytes
    private EditText edtFreqA,edtFreqB;
    private EditText edtDumpShift;
    private EditText edtSubFrameDrvNum;
    private Spinner spinDrvOutputR,spinDACGain;
    private Spinner spinPGAC,spinPGAR,spinRxVcmi,spinPGAGain;
    private Spinner spinBoostTime,spinVoltage,spinAlterCount;
    private CheckBox cbExtoscen;
    private boolean PGAGainSelected = false;  //判断是否为刚进去时触发onItemSelected的标志
    private TextWatcher twBitFreq,twDuration,twFreqAFactor,twFreqBFactor,twFreqA,twFreqB;

    //View Module Switch 定义
    private CheckBox cbX2Y,cbSito;
    private Spinner spinStretchRank,spinInterrupt;
    private CheckBox cbMonitorConsistencyConflictEn,cbFirstFilterDis;
    private CheckBox cbDiffDivideBy2or4,cbWaterSpeedLimitEn;
    private CheckBox cbShapeEn,cbWaterProofDis;
    private CheckBox cbLcdPlusMinusEn,cbESDEn;
    private CheckBox cbX2X,cbY2Y;
    private CheckBox cbINTWakeup;

    //View Normal Setting 定义
    private EditText edtConfigVersion,edtTouchNumber;
    private EditText edtShakeCnt;
    private EditText edtFirstFilter,edtNormalFilter;
    private EditText edtNoiseReduction;
    private EditText edtScreenTouchLv,edtScreenLeaveLv;
    private EditText edtLowPowerControl;
    private Spinner spinRefreshRate;
    private EditText edtXThreshold,edtYThreshold;
    private EditText edtSpaceUpDown,edtSpaceLeftRight;
    private EditText edtStretchR0,edtStretchR1,edtStretchR2,edtStretchRM;
    private EditText edtMiniFilter;
    private EditText edtChargingLevelUp;
    private EditText edtLcdPlusMinusValue,edtConThreshold;
    private EditText edtShapeRestrain,edtShapeContrl;
    private EditText edtWaterFrameTime,edtWaterUpdateTime;
    private EditText edtSlideInEdgeConfig,edtSlideOutEdgeConfig;
    private EditText edtCombineDis,edtSplitSet;
    private EditText edtSitoDiffRefLevel;

    //View Channel Setting 定义
    private EditText edtXOutputMax,edtYOutputMax;
    private EditText edtDrvGroupAnumber,edtDrvGroupBnumber;
    private EditText edtSenGroupANumber,edtSenGroupBNumber;
    private EditText edtSensorCH0,edtSensorCH1,edtSensorCH2,edtSensorCH3,edtSensorCH4,edtSensorCH5,edtSensorCH6,edtSensorCH7,edtSensorCH8,edtSensorCH9;
    private EditText edtSensorCH10,edtSensorCH11,edtSensorCH12,edtSensorCH13,edtSensorCH14,edtSensorCH15,edtSensorCH16,edtSensorCH17,edtSensorCH18,edtSensorCH19;
    private EditText edtSensorCH20,edtSensorCH21,edtSensorCH22,edtSensorCH23,edtSensorCH24,edtSensorCH25,edtSensorCH26,edtSensorCH27,edtSensorCH28,edtSensorCH29;
    private EditText edtSensorStart,edtSensorEnd;
    private Button btnSensorRev,btnAllSensorChannels;
    private EditText edtDriverCH0,edtDriverCH1,edtDriverCH2,edtDriverCH3,edtDriverCH4,edtDriverCH5,edtDriverCH6,edtDriverCH7,edtDriverCH8,edtDriverCH9;
    private EditText edtDriverCH10,edtDriverCH11,edtDriverCH12,edtDriverCH13,edtDriverCH14,edtDriverCH15,edtDriverCH16,edtDriverCH17,edtDriverCH18,edtDriverCH19;
    private EditText edtDriverCH20,edtDriverCH21,edtDriverCH22,edtDriverCH23,edtDriverCH24,edtDriverCH25,edtDriverCH26,edtDriverCH27,edtDriverCH28,edtDriverCH29;
    private EditText edtDriverCH30,edtDriverCH31,edtDriverCH32,edtDriverCH33,edtDriverCH34,edtDriverCH35,edtDriverCH36,edtDriverCH37,edtDriverCH38,edtDriverCH39;
    private EditText edtDriverCH40,edtDriverCH41;
    private EditText edtDriverStart,edtDriverEnd;
    private Button btnDriverRev,btnAllDriverChannels;
    private byte bSensorNumber,bDriverNumber;

    //View Pen Setting 定义
    private CheckBox cbPenEn,cbOnlyFingerEn;
    private EditText edtPenLowSize,edtPenHighSize;
    private EditText edtRectsumPLowL,edtRectsumPHighL;
    private EditText edtRectsumFLowL;
    private EditText edtPRectMaxDiffLimit,edtPRectAreaLimit;
    private EditText edtFLeavelevel,edtPTouchHighlevel;
    private Spinner spinFingerRestrainPen;

    //View Plam Restrain 定义
    private CheckBox cbAllPlamRestrain;
    private EditText edtLargeTouch;
    private EditText edtExpanNumOutX,edtExpanNumOutY;
    private EditText edtExpanNumInX,edtExpanNumInY;
    private EditText edtSingleRectTopSignNum,edtAllRectTopSignSum;
    private CheckBox cbWaterLargeRestrainEn;

    //View Hopping Setting 定义
    private CheckBox cbHoppingEn;
    private CheckBox cbRangeExt;
    private EditText edtFreqStart,edtFreqEnd;
    private EditText edtDetectStayTimes,edtDetectConfirmTimes;
    private CheckBox cbDisForceRef,cbDelayHopping;
    private EditText edtFastHopLimit,edtHopThreshold,edtNoiseMinTh,edtSensorGroup;
    private EditText edtSeg1Normalize,edtSeg1Factor;
    private EditText edtMainClockAjdust;
    private EditText edtSeg2Normalize,edtSeg2Factor;
    private EditText edtSeg3Normalize,edtSeg3Factor;
    private EditText edtSeg4Normalize,edtSeg4Factor;
    private EditText edtSeg5Normalize,edtSeg5Factor;
    private EditText edtSeg6Normalize;
    private EditText edtHopFreqAddr;
    private EditText edtHopDetectTimes;

    //View Cfg Ram 定义
    private EditText mCfg8050,mCfg8051,mCfg8052,mCfg8053,mCfg8054,mCfg8055,mCfg8056,mCfg8057;
    private EditText mCfg8058,mCfg8059,mCfg805A,mCfg805B,mCfg805C,mCfg805D,mCfg805E,mCfg805F;

    private EditText mCfg8060,mCfg8061,mCfg8062,mCfg8063,mCfg8064,mCfg8065,mCfg8066,mCfg8067;
    private EditText mCfg8068,mCfg8069,mCfg806A,mCfg806B,mCfg806C,mCfg806D,mCfg806E,mCfg806F;

    private EditText mCfg8070,mCfg8071,mCfg8072,mCfg8073,mCfg8074,mCfg8075,mCfg8076,mCfg8077;
    private EditText mCfg8078,mCfg8079,mCfg807A,mCfg807B,mCfg807C,mCfg807D,mCfg807E,mCfg807F;

    private EditText mCfg8080,mCfg8081,mCfg8082,mCfg8083,mCfg8084,mCfg8085,mCfg8086,mCfg8087;
    private EditText mCfg8088,mCfg8089,mCfg808A,mCfg808B,mCfg808C,mCfg808D,mCfg808E,mCfg808F;

    private EditText mCfg8090,mCfg8091,mCfg8092,mCfg8093,mCfg8094,mCfg8095,mCfg8096,mCfg8097;
    private EditText mCfg8098,mCfg8099,mCfg809A,mCfg809B,mCfg809C,mCfg809D,mCfg809E,mCfg809F;

    private EditText mCfg80A0,mCfg80A1,mCfg80A2,mCfg80A3,mCfg80A4,mCfg80A5,mCfg80A6,mCfg80A7;
    private EditText mCfg80A8,mCfg80A9,mCfg80AA,mCfg80AB,mCfg80AC,mCfg80AD,mCfg80AE,mCfg80AF;

    private EditText mCfg80B0,mCfg80B1,mCfg80B2,mCfg80B3,mCfg80B4,mCfg80B5,mCfg80B6,mCfg80B7;
    private EditText mCfg80B8,mCfg80B9,mCfg80BA,mCfg80BB,mCfg80BC,mCfg80BD,mCfg80BE,mCfg80BF;

    private EditText mCfg80C0,mCfg80C1,mCfg80C2,mCfg80C3,mCfg80C4,mCfg80C5,mCfg80C6,mCfg80C7;
    private EditText mCfg80C8,mCfg80C9,mCfg80CA,mCfg80CB,mCfg80CC,mCfg80CD,mCfg80CE,mCfg80CF;

    private EditText mCfg80D0,mCfg80D1,mCfg80D2,mCfg80D3,mCfg80D4,mCfg80D5,mCfg80D6,mCfg80D7;
    private EditText mCfg80D8,mCfg80D9,mCfg80DA,mCfg80DB,mCfg80DC,mCfg80DD,mCfg80DE,mCfg80DF;

    private EditText mCfg80E0,mCfg80E1,mCfg80E2,mCfg80E3,mCfg80E4,mCfg80E5,mCfg80E6,mCfg80E7;
    private EditText mCfg80E8,mCfg80E9,mCfg80EA,mCfg80EB,mCfg80EC,mCfg80ED,mCfg80EE,mCfg80EF;

    private EditText mCfg80F0,mCfg80F1,mCfg80F2,mCfg80F3,mCfg80F4,mCfg80F5,mCfg80F6,mCfg80F7;
    private EditText mCfg80F8,mCfg80F9,mCfg80FA,mCfg80FB,mCfg80FC,mCfg80FD,mCfg80FE,mCfg80FF;

    private EditText mCfg8100,mCfg8101,mCfg8102,mCfg8103,mCfg8104,mCfg8105,mCfg8106,mCfg8107;
    private EditText mCfg8108,mCfg8109,mCfg810A,mCfg810B,mCfg810C,mCfg810D,mCfg810E,mCfg810F;

    private EditText mCfg8110,mCfg8111,mCfg8112,mCfg8113,mCfg8114,mCfg8115,mCfg8116,mCfg8117;
    private EditText mCfg8118,mCfg8119,mCfg811A,mCfg811B,mCfg811C,mCfg811D,mCfg811E,mCfg811F;

    private EditText mCfg8120,mCfg8121,mCfg8122,mCfg8123,mCfg8124,mCfg8125,mCfg8126,mCfg8127;
    private EditText mCfg8128,mCfg8129,mCfg812A,mCfg812B,mCfg812C,mCfg812D,mCfg812E,mCfg812F;

    private EditText mCfg8130,mCfg8131,mCfg8132,mCfg8133,mCfg8134,mCfg8135,mCfg8136,mCfg8137;
    private EditText mCfg8138,mCfg8139,mCfg813A,mCfg813B,mCfg813C,mCfg813D,mCfg813E,mCfg813F;

    private EditText mCfgBF7B,mCfgBF7C,mCfgBF7D,mCfgBF7E,mCfgBF7F;

    private EditText mCfgBF80,mCfgBF81,mCfgBF82,mCfgBF83,mCfgBF84,mCfgBF85,mCfgBF86,mCfgBF87;
    private EditText mCfgBF88,mCfgBF89,mCfgBF8A,mCfgBF8B,mCfgBF8C,mCfgBF8D,mCfgBF8E,mCfgBF8F;

    private EditText mCfgBF90,mCfgBF91,mCfgBF92,mCfgBF93,mCfgBF94,mCfgBF95,mCfgBF96,mCfgBF97;
    private EditText mCfgBF98,mCfgBF99,mCfgBF9A,mCfgBF9B,mCfgBF9C,mCfgBF9D,mCfgBF9E,mCfgBF9F;

    private EditText mCfgBFA0,mCfgBFA1,mCfgBFA2,mCfgBFA3,mCfgBFA4,mCfgBFA5,mCfgBFA6,mCfgBFA7;
    private EditText mCfgBFA8,mCfgBFA9,mCfgBFAA,mCfgBFAB,mCfgBFAC,mCfgBFAD,mCfgBFAE,mCfgBFAF;

    private EditText mCfgBFB0,mCfgBFB1,mCfgBFB2,mCfgBFB3,mCfgBFB4,mCfgBFB5,mCfgBFB6,mCfgBFB7;
    private EditText mCfgBFB8,mCfgBFB9,mCfgBFBA,mCfgBFBB,mCfgBFBC,mCfgBFBD,mCfgBFBE,mCfgBFBF;

    private EditText mCfgBFC0,mCfgBFC1,mCfgBFC2,mCfgBFC3,mCfgBFC4,mCfgBFC5,mCfgBFC6,mCfgBFC7;
    private EditText mCfgBFC8,mCfgBFC9,mCfgBFCA,mCfgBFCB,mCfgBFCC,mCfgBFCD,mCfgBFCE,mCfgBFCF;

    private EditText mCfgBFD0,mCfgBFD1,mCfgBFD2,mCfgBFD3,mCfgBFD4,mCfgBFD5,mCfgBFD6,mCfgBFD7;
    private EditText mCfgBFD8,mCfgBFD9,mCfgBFDA,mCfgBFDB,mCfgBFDC,mCfgBFDD,mCfgBFDE,mCfgBFDF;

    private EditText mCfgBFE0,mCfgBFE1,mCfgBFE2,mCfgBFE3,mCfgBFE4,mCfgBFE5,mCfgBFE6,mCfgBFE7;
    private EditText mCfgBFE8,mCfgBFE9,mCfgBFEA,mCfgBFEB,mCfgBFEC,mCfgBFED,mCfgBFEE,mCfgBFEF;

    private EditText mCfgBFF0,mCfgBFF1,mCfgBFF2,mCfgBFF3,mCfgBFF4,mCfgBFF5,mCfgBFF6,mCfgBFF7;
    private EditText mCfgBFF8,mCfgBFF9,mCfgBFFA;

    private ViewPager vpagerCfg;
    private ImageView img_cursor;
    private TextView tvNormal;
    private TextView tvTxRX;
    private TextView tvModuleSwitch;
    private TextView tvOther;
    private TextView tvSelfSetting;
    private TextView tvKeySetting;
    private TextView tvLowSignalSetting;
    private TextView tvExConfig;
    private TextView tvCfgRam;

    private ArrayList<View> listViews;
    View viewnormal;
    View viewtxrx;
    View viewmoduleswitch;
    View viewother;
    View viewselfsetting;
    View viewexconfig;
    View viewcfgram;
    private int offset = 0;//移动条图片的偏移量
    private int currIndex = 6;//当前页面的编号
    private int bmpWidth;// 移动条图片的长度
    private int one = 0; //移动条滑动一页的距离
    private int two = 0; //滑动条移动两页的距离
    private int three = 0; //滑动条移动三页的距离
    private int four = 0; //滑动条移动四页的距离
    private int five = 0; //滑动条移动五页的距离
    private int six = 0; //滑动条移动六页的距离
    private int seven = 0; //滑动条移动七页的距离
    //private int eight = 0; //滑动条移动八页的距离
    //private int nine = 0; //滑动条移动九页的距离
    private int iChooseVPager = 0; //当前停在哪个vpager

    private byte mSendGetGt9ConfigData[]={
            0x03,0x00,0x0f,(byte)0x80,0x50,0x00,0x3f,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    };

    Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {

            StringBuilder stringBuilder = new StringBuilder("");
            StringBuffer resultSb = new StringBuffer();
            // for (int i = 1; i < mBytes.length; i++) {
            int checksum = 0 ;
            switch (msg.what) {
                case CONNECTED_SUCCESS://车机和手机连接成功
                    //mError.setText("");
                    mReadCfg.setEnabled(true);

                    break;

                case RECEIVER_MESSAGE_SUCCESS://成功接受到数据
                    //mSendCfg.setEnabled(true);
                    //String hv = null;

                    for (int i = 0; i < 189; i++) {

                        if (i == 0 || i == 64 || i == 128)
                        {
                            continue;
                        }
                        int v = mBytes[i] & 0xFF;
                        checksum =checksum+ v;
                        String hv = Integer.toHexString(v);
                        stringBuilder.append(hv);
                        stringBuilder.append(",");
                    }
                     if(checksum % 256 == 0)  //校验和正确
                     {
                         mShow.setText("Cfg Checksum is correct!");
                     }
                     else {
                         mShow.setText("Cfg Checksum is error!");
                     }

                    //String d_value =Arrays.toString(mBytes);
                    //String d_value =Arrays.hv.toString();
                    //mMessage.setText( stringBuilder.toString() );//输出显示
                    //edit_search.setText(uri.getPath().toString());
                    // mLog.setText(mStringBuffer.toString());
                    break;

                case SEND_MESSAGE_SUCCESS://成功发送数据
                    //mMessage.setText("");
                    break;

                case DEBUG_MESSAGE_SUCCESS://成功发送数据
                    //StringBuilder stringBuilder = new StringBuilder("");
                   // StringBuffer resultSb = new StringBuffer();

                    checksum = 0 ;
                    for (int i = 0; i < 216; i++) {

                        int v = mSendData[i] & 0xFF;
                        checksum =checksum+ v;
                        //byte v = mSendData[i];
                        String hv = Integer.toHexString(v);
                        //String hv = Byte.toString(v);
                        stringBuilder.append(hv);
                        stringBuilder.append(",");
                    }
                    //mShow.setText(stringBuilder.toString());
                    //mShow.setText(value);
                    break;
                case DEBUG_MESSAGE_ERROR://成功发送数据
                    //mShow.setText("ERROR");
                    //mError.setText("ERROR");
                    break;

            }
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_config);
        mAlertContext = Config.this;
        ConstantsActivity.activityList.add(this);
        //switchLanguage(ConstantsActivity.langae);
        init();
    }

    //核心设置的代码
    protected void switchLanguage(String language) {
        Resources resources = getResources();
        Configuration config = resources.getConfiguration();
        DisplayMetrics dm = resources.getDisplayMetrics();
        switch (language) {
            case "zh":
                config.locale = Locale.CHINESE;
                resources.updateConfiguration(config, dm);
                break;
            case "en":
                config.locale = Locale.ENGLISH;
                resources.updateConfiguration(config, dm);
                break;
            default:
                config.locale = Locale.US;
                resources.updateConfiguration(config, dm);
                break;
        }
    }

    private void init() {
        initView();
        initViewPager();
        //initSampleSpin();
        //initModuleSwitchSpin();
        //initNormalSettingSpin();
        //initChannelSettingSpin();
        //initPenSettingSpin();
        //initPlamRestrainSpin();
        //initHoppingSettingSpin();
        initCfgShow();
        initListener();
        initData();
        openDevices();
    }

    private void initView() {
        mReadCfg = (Button) findViewById(R.id.readcfg);
        mSendCfg = (Button) findViewById(R.id.sendcfg);
        mShow = (TextView) findViewById(R.id.show);

        search_button = (Button) findViewById(R.id.searchbutton);
        edit_search = (TextView) findViewById(R.id.editsearch);
        edit_text = (EditText) findViewById(R.id.editsearch);

        search_button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //ActivityCompat.requestPermissions(  Config.this, new String[]{android
                //        .Manifest.permission.READ_EXTERNAL_STORAGE}, 2);
                Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
                intent.setType("*/*");//设置类型，我这里是任意类型，任意后缀的可以这样写。
                intent.addCategory(Intent.CATEGORY_OPENABLE);
                startActivityForResult(intent, 1);
            }
        });

        //editdetail = (EditText) findViewById(R.id.message);
        editname = (EditText) findViewById(R.id.editname);
        btnsave = (Button) findViewById(R.id.savecfg);
        //btnread = (Button) findViewById(R.id.btnread);
        tvVenderID = (TextView) findViewById(R.id.venderid);

        btnsave.setOnClickListener(this);

        mSaveCfgContext = getApplicationContext();

    }

    private void initViewPager() {
        vpagerCfg = (ViewPager) findViewById(R.id.vpagercfg);

        tvNormal = (TextView) findViewById(R.id.tvnormal);
        tvTxRX = (TextView) findViewById(R.id.tvtxrx);
        tvModuleSwitch = (TextView) findViewById(R.id.tvmoduleswitch);
        tvOther = (TextView) findViewById(R.id.tvother);
        tvSelfSetting = (TextView) findViewById(R.id.tvselfsetting);
        tvExConfig = (TextView) findViewById(R.id.tvexconfig);
        tvCfgRam = (TextView) findViewById(R.id.tvcfgram);

        img_cursor = (ImageView) findViewById(R.id.img_cursor);

        //下划线动画的相关设置：
        bmpWidth = BitmapFactory.decodeResource(getResources(), R.mipmap.line).getWidth();// 获取图片宽度
        DisplayMetrics dm = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(dm);
        int screenW = dm.widthPixels;// 获取分辨率宽度
        //offset = (screenW / 3 - bmpWidth) / 2;// 计算偏移量
        offset = (screenW / 7 - bmpWidth) / 2;// 计算偏移量
        Matrix matrix = new Matrix();
        matrix.postTranslate(offset, 0);
        img_cursor.setImageMatrix(matrix);// 设置动画初始位置
        //移动的距离
        one = offset * 2 + bmpWidth;// 移动一页的偏移量,比如1->2,或者2->3
        two = one * 2;// 移动两页的偏移量,比如1直接跳3
        three = one * 3;// 移动两页的偏移量,比如1直接跳3
        four = one * 4;// 移动两页的偏移量,比如1直接跳3
        five = one * 5;// 移动两页的偏移量,比如1直接跳3
        six = one * 6;// 移动两页的偏移量,比如1直接跳3
        seven = one * 7;// 移动两页的偏移量,比如1直接跳3
        //eight = one * 8;// 移动两页的偏移量,比如1直接跳3
        //nine = one * 9;// 移动两页的偏移量,比如1直接跳3

        Animation animation = null;
        animation = new TranslateAnimation(one * currIndex, six, 0, 0);  //currIndex初始化是7
        animation.setFillAfter(true);// true表示图片停在动画结束位置
        animation.setDuration(300); //设置动画时间为300毫秒
        img_cursor.startAnimation(animation);//开始动画

        //往ViewPager填充View，同时设置点击事件与页面切换事件
        listViews = new ArrayList<View>();

        //LayoutInflater mInflater = getLayoutInflater();
        viewnormal = View.inflate(this,R.layout.view_normal, null);
        viewtxrx = View.inflate(this,R.layout.view_txrx, null);
        viewmoduleswitch = View.inflate(this,R.layout.view_module_switch, null);
        viewother = View.inflate(this,R.layout.view_other, null);
        viewselfsetting = View.inflate(this,R.layout.view_self_setting, null);
        viewexconfig = View.inflate(this,R.layout.view_ex_config, null);
        viewcfgram = View.inflate(this,R.layout.view_cfg_ram, null);

        //listViews.add(mInflater.inflate(R.layout.view_one, null, false));
        //listViews.add(mInflater.inflate(R.layout.view_two, null, false));
        //listViews.add(mInflater.inflate(R.layout.view_three, null, false));

        listViews.add(viewnormal);
        listViews.add(viewtxrx);
        listViews.add(viewmoduleswitch);
        listViews.add(viewother);
        listViews.add(viewselfsetting);
        listViews.add(viewexconfig);
        listViews.add(viewcfgram);
        vpagerCfg.setAdapter(new MyPagerAdapter(listViews));
        vpagerCfg.setCurrentItem(6);          //设置ViewPager当前页，从8开始算，跳到最后ram页

        tvNormal.setOnClickListener(this);
        tvTxRX.setOnClickListener(this);
        tvModuleSwitch.setOnClickListener(this);
        tvOther.setOnClickListener(this);
        tvSelfSetting.setOnClickListener(this);
        tvExConfig.setOnClickListener(this);
        tvCfgRam.setOnClickListener(this);

        vpagerCfg.addOnPageChangeListener(this);
    }

    //===============================各view中的元素初始化开始===============================================//
    /*
    private void initSampleSpin() {
        cbAllDrivingEn = viewnormal.findViewById(R.id.alldrivingen);
        cbDualFreq = viewnormal.findViewById(R.id.dualfreq);
        edtFreqAFactor = viewnormal.findViewById(R.id.freqafactor);
        edtFreqBFactor = viewnormal.findViewById(R.id.freqbfactor);
        edtPannelBitFreq = viewnormal.findViewById(R.id.bitfreq);
        edtDuration = viewnormal.findViewById(R.id.duration);
        edtFreqA = viewnormal.findViewById(R.id.freqa);
        edtFreqB = viewnormal.findViewById(R.id.freqb);
        twBitFreq = new TextWatcher(){
            int ibitfreq = 0;
            float fduration = 0;
            float ffactortemp;
            int ifactortemp;
            int ifreq;

            @Override
            public void onTextChanged(CharSequence s, int start, int before,int count) {
                edtDuration.removeTextChangedListener(twDuration);
                try {
                    ibitfreq = Integer.parseInt(s.toString(),10);
                } catch (Exception ex) {
                    ibitfreq = 1;
                }
                fduration = (float) (1000000.0 / ibitfreq);
                CharSequence csduration = Float.toString(fduration);
                //删除.后面超过两位的数字
                if (csduration.toString().contains(".")) {
                    if (csduration.length() - 1 - csduration.toString().indexOf(".") > 2) {
                        csduration = csduration.toString().subSequence(0,
                                csduration.toString().indexOf(".") + 3);
                        edtDuration.setText(csduration);
                        //edtDuration.setSelection(csduration.length());
                    }
                }

                //如果.在起始位置,则起始位置自动补0
                if (csduration.toString().trim().substring(0).equals(".")) {
                    csduration = "0" + csduration;
                    edtDuration.setText(csduration);
                    //edtDuration.setSelection(2);
                }

                //如果起始位置为0并且第二位跟的不是".",则无法后续输入
                if (csduration.toString().startsWith("0")
                        && csduration.toString().trim().length() > 1) {
                    if (!csduration.toString().substring(1, 2).equals(".")) {
                        edtDuration.setText(csduration.subSequence(0, 1));
                        //edtDuration.setSelection(1);
                        return;
                    }
                }

                edtDuration.setText(csduration.toString());
                ffactortemp = (float)(ibitfreq / 57.2205);
                ifactortemp = (int)ffactortemp;
                ffactortemp = (float) (ifactortemp * 57.2205);
                ibitfreq = (int)ffactortemp;
                ifreq = Integer.parseInt(edtFreqAFactor.getText().toString(),10) * ibitfreq;
                edtFreqA.setText(Integer.toString(ifreq));
                ifreq = Integer.parseInt(edtFreqBFactor.getText().toString(),10) * ibitfreq;
                edtFreqB.setText(Integer.toString(ifreq));

                edtPannelBitFreq.setSelection(s.length());
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                edtDuration.addTextChangedListener(twDuration);
            }
        };

        twDuration = new TextWatcher(){
            int ibitfreq = 0;
            float fduration = 0;
            float ffactortemp;
            int ifactortemp;
            int ifreq;

            @Override
            public void onTextChanged(CharSequence s, int start, int before,int count) {
                if (bottonMode == 0) {
                    edtPannelBitFreq.removeTextChangedListener(twBitFreq);
                    try {
                        //删除.后面超过两位的数字
                        if (s.toString().contains(".")) {
                            if (s.length() - 1 - s.toString().indexOf(".") > 2) {
                                s = s.toString().subSequence(0, s.toString().indexOf(".") + 3);
                                edtDuration.setText(s);
                                edtDuration.setSelection(s.length());
                            }
                        }

                        //如果.在起始位置,则起始位置自动补0
                        if (s.toString().trim().substring(0).equals(".")) {
                            s = "0" + s;
                            edtDuration.setText(s);
                            edtDuration.setSelection(2);
                        }

                        //如果起始位置为0并且第二位跟的不是".",则无法后续输入
                        if (s.toString().startsWith("0")
                                && s.toString().trim().length() > 1) {
                            if (!s.toString().substring(1, 2).equals(".")) {
                                edtDuration.setText(s.subSequence(0, 1));
                                edtDuration.setSelection(1);
                                return;
                            }
                        }

                        fduration = Float.parseFloat(s.toString());
                    } catch (Exception ex) {
                        fduration = 1;
                    }
                    ibitfreq = (int) (1000000 / fduration);
                    edtPannelBitFreq.setText(Integer.toString(ibitfreq));
                    ffactortemp = (float) (ibitfreq / 57.2205);
                    ifactortemp = (int) ffactortemp;
                    ffactortemp = (float) (ifactortemp * 57.2205);
                    ibitfreq = (int) ffactortemp;
                    ifreq = Integer.parseInt(edtFreqAFactor.getText().toString(), 10) * ibitfreq;
                    edtFreqA.setText(Integer.toString(ifreq));
                    ifreq = Integer.parseInt(edtFreqBFactor.getText().toString(), 10) * ibitfreq;
                    edtFreqB.setText(Integer.toString(ifreq));
                }
                bottonMode = 0;
            }
        };

        edtPannelBitFreq.addTextChangedListener(twBitFreq);
        edtDuration.addTextChangedListener(twDuration);

        twFreqAFactor = new TextWatcher(){
            int ibitfreq = 0;
            float ffactortemp;
            int ifactortemp;
            int ifreq;

            @Override
            public void onTextChanged(CharSequence s, int start, int before,int count) {
                //edtFreqA.removeTextChangedListener(twFreqA);
                try {
                    ifactortemp = Integer.parseInt(s.toString(),10);
                } catch (Exception ex) {
                    ifactortemp = 0;
                }
                ibitfreq = Integer.parseInt(edtPannelBitFreq.getText().toString(),10);
                ffactortemp = (float)(ibitfreq / 57.2205);
                ifactortemp = (int)ffactortemp;
                ffactortemp = (float) (ifactortemp * 57.2205);
                ibitfreq = (int)ffactortemp;
                ifreq = ifactortemp * ibitfreq;
                edtFreqA.setText(Integer.toString(ifreq));
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                //edtFreqA.addTextChangedListener(twFreqA);
            }
        };

        edtFreqAFactor.addTextChangedListener(twFreqAFactor);
        //edtFreqA.addTextChangedListener(twFreqA);

        twFreqBFactor = new TextWatcher(){
            int ibitfreq = 0;
            float ffactortemp;
            int ifactortemp;
            int ifreq;

            @Override
            public void onTextChanged(CharSequence s, int start, int before,int count) {
                //edtFreqB.removeTextChangedListener(twFreqB);
                try {
                    ifactortemp = Integer.parseInt(s.toString(),10);
                } catch (Exception ex) {
                    ifactortemp = 0;
                }
                ibitfreq = Integer.parseInt(edtPannelBitFreq.getText().toString(),10);
                ffactortemp = (float)(ibitfreq / 57.2205);
                ifactortemp = (int)ffactortemp;
                ffactortemp = (float) (ifactortemp * 57.2205);
                ibitfreq = (int)ffactortemp;
                ifreq = ifactortemp * ibitfreq;
                edtFreqB.setText(Integer.toString(ifreq));
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                //edtFreqB.addTextChangedListener(twFreqB);
            }
        };

        edtFreqBFactor.addTextChangedListener(twFreqBFactor);
        //edtFreqB.addTextChangedListener(twFreqB);

        edtDumpShift = viewnormal.findViewById(R.id.dumpshift);
        edtSubFrameDrvNum = viewnormal.findViewById(R.id.subframedrvnum);
        spinDrvOutputR = viewnormal.findViewById(R.id.drvoutputr);
        spinDACGain = viewnormal.findViewById(R.id.dacgain);
        spinPGAC = viewnormal.findViewById(R.id.pgac);
        spinPGAR = viewnormal.findViewById(R.id.pgar);
        spinRxVcmi = viewnormal.findViewById(R.id.rxvcmi);
        spinPGAGain = viewnormal.findViewById(R.id.pgagainspin);
        spinPGAGain.setOnItemSelectedListener(this);
        spinBoostTime = viewnormal.findViewById(R.id.boosttime);
        spinVoltage = viewnormal.findViewById(R.id.voltage);
        spinAlterCount = viewnormal.findViewById(R.id.altercount);
        cbExtoscen = viewnormal.findViewById(R.id.extoscen);
    }
    */
    private void initModuleSwitchSpin() {
        cbX2Y = viewtxrx.findViewById(R.id.x2y);
        cbSito = viewtxrx.findViewById(R.id.sito);
        spinStretchRank = viewtxrx.findViewById(R.id.stretchrank);
        spinInterrupt = viewtxrx.findViewById(R.id.interrupt);
        cbMonitorConsistencyConflictEn = viewtxrx.findViewById(R.id.mccen);
        cbFirstFilterDis = viewtxrx.findViewById(R.id.firstfilterdis);
        cbDiffDivideBy2or4 = viewtxrx.findViewById(R.id.diffdivideby2or4);
        cbWaterSpeedLimitEn = viewtxrx.findViewById(R.id.waterspeedlimiten);
        cbShapeEn = viewtxrx.findViewById(R.id.shapeen);
        cbWaterProofDis = viewtxrx.findViewById(R.id.waterproofdis);
        cbLcdPlusMinusEn = viewtxrx.findViewById(R.id.lcdplusminusen);
        cbESDEn = viewtxrx.findViewById(R.id.esden);
        cbX2X = viewtxrx.findViewById(R.id.x2x);
        cbY2Y = viewtxrx.findViewById(R.id.y2y);
        cbINTWakeup = viewtxrx.findViewById(R.id.intwakeup);
    }
    /*
    private void initNormalSettingSpin(){
        edtConfigVersion = viewmoduleswitch.findViewById(R.id.configversion);
        edtTouchNumber = viewmoduleswitch.findViewById(R.id.touchnumber);
        edtShakeCnt = viewmoduleswitch.findViewById(R.id.shakecnt);
        edtFirstFilter = viewmoduleswitch.findViewById(R.id.firstfilter);
        edtNormalFilter = viewmoduleswitch.findViewById(R.id.normalfilter);
        edtNoiseReduction = viewmoduleswitch.findViewById(R.id.noisereduction);
        edtScreenTouchLv = viewmoduleswitch.findViewById(R.id.touchlevel);
        edtScreenLeaveLv = viewmoduleswitch.findViewById(R.id.leavelevel);
        edtLowPowerControl = viewmoduleswitch.findViewById(R.id.lowpowercontrol);
        spinRefreshRate = viewmoduleswitch.findViewById(R.id.refreshrate);
        edtXThreshold = viewmoduleswitch.findViewById(R.id.xthreshold);
        edtYThreshold = viewmoduleswitch.findViewById(R.id.ythreshold);
        edtSpaceUpDown = viewmoduleswitch.findViewById(R.id.spaceupdown);
        edtSpaceLeftRight = viewmoduleswitch.findViewById(R.id.spaceleftright);
        edtStretchR0 = viewmoduleswitch.findViewById(R.id.stretchr0);
        edtStretchR1 = viewmoduleswitch.findViewById(R.id.stretchr1);
        edtStretchR2 = viewmoduleswitch.findViewById(R.id.stretchr2);
        edtStretchRM = viewmoduleswitch.findViewById(R.id.stretchrm);
        edtMiniFilter = viewmoduleswitch.findViewById(R.id.minifilter);
        edtChargingLevelUp = viewmoduleswitch.findViewById(R.id.charginglevelup);
        edtLcdPlusMinusValue = viewmoduleswitch.findViewById(R.id.lcdplusminusvalue);
        edtConThreshold = viewmoduleswitch.findViewById(R.id.conthreshold);
        edtShapeRestrain = viewmoduleswitch.findViewById(R.id.shaperestrain);
        edtShapeContrl = viewmoduleswitch.findViewById(R.id.shapecontrl);
        edtWaterFrameTime = viewmoduleswitch.findViewById(R.id.waterframetime);
        edtWaterUpdateTime = viewmoduleswitch.findViewById(R.id.waterupdatetime);
        edtSlideInEdgeConfig = viewmoduleswitch.findViewById(R.id.slideinedgeconfig);
        edtSlideOutEdgeConfig = viewmoduleswitch.findViewById(R.id.slideoutedgeconfig);
        edtCombineDis = viewmoduleswitch.findViewById(R.id.combinedis);
        edtSplitSet = viewmoduleswitch.findViewById(R.id.splitset);
        edtSitoDiffRefLevel = viewmoduleswitch.findViewById(R.id.sitodiffreflevel);
    }
    */
    /*
    private void initChannelSettingSpin(){
        edtXOutputMax = viewtxrx.findViewById(R.id.xoutputmax);
        edtYOutputMax = viewtxrx.findViewById(R.id.youtputmax);
        edtDrvGroupAnumber = viewtxrx.findViewById(R.id.drvgroupanum);
        edtDrvGroupBnumber = viewtxrx.findViewById(R.id.drvgroupbnum);
        edtSenGroupANumber = viewtxrx.findViewById(R.id.sengroupanum);
        edtSenGroupBNumber = viewtxrx.findViewById(R.id.sengroupbnum);
        edtSensorCH0 = viewtxrx.findViewById(R.id.sensorch0);
        edtSensorCH1 = viewtxrx.findViewById(R.id.sensorch1);
        edtSensorCH2 = viewtxrx.findViewById(R.id.sensorch2);
        edtSensorCH3 = viewtxrx.findViewById(R.id.sensorch3);
        edtSensorCH4 = viewtxrx.findViewById(R.id.sensorch4);
        edtSensorCH5 = viewtxrx.findViewById(R.id.sensorch5);
        edtSensorCH6 = viewtxrx.findViewById(R.id.sensorch6);
        edtSensorCH7 = viewtxrx.findViewById(R.id.sensorch7);
        edtSensorCH8 = viewtxrx.findViewById(R.id.sensorch8);
        edtSensorCH9 = viewtxrx.findViewById(R.id.sensorch9);
        edtSensorCH10 = viewtxrx.findViewById(R.id.sensorch10);
        edtSensorCH11 = viewtxrx.findViewById(R.id.sensorch11);
        edtSensorCH12 = viewtxrx.findViewById(R.id.sensorch12);
        edtSensorCH13 = viewtxrx.findViewById(R.id.sensorch13);
        edtSensorCH14 = viewtxrx.findViewById(R.id.sensorch14);
        edtSensorCH15 = viewtxrx.findViewById(R.id.sensorch15);
        edtSensorCH16 = viewtxrx.findViewById(R.id.sensorch16);
        edtSensorCH17 = viewtxrx.findViewById(R.id.sensorch17);
        edtSensorCH18 = viewtxrx.findViewById(R.id.sensorch18);
        edtSensorCH19 = viewtxrx.findViewById(R.id.sensorch19);
        edtSensorCH20 = viewtxrx.findViewById(R.id.sensorch20);
        edtSensorCH21 = viewtxrx.findViewById(R.id.sensorch21);
        edtSensorCH22 = viewtxrx.findViewById(R.id.sensorch22);
        edtSensorCH23 = viewtxrx.findViewById(R.id.sensorch23);
        edtSensorCH24 = viewtxrx.findViewById(R.id.sensorch24);
        edtSensorCH25 = viewtxrx.findViewById(R.id.sensorch25);
        edtSensorCH26 = viewtxrx.findViewById(R.id.sensorch26);
        edtSensorCH27 = viewtxrx.findViewById(R.id.sensorch27);
        edtSensorCH28 = viewtxrx.findViewById(R.id.sensorch28);
        edtSensorCH29 = viewtxrx.findViewById(R.id.sensorch29);
        edtSensorStart = viewtxrx.findViewById(R.id.sensorstart);
        edtSensorEnd = viewtxrx.findViewById(R.id.sensorend);
        btnSensorRev = viewtxrx.findViewById(R.id.btnsensorrev);
        btnSensorRev.setOnClickListener(this);
        btnAllSensorChannels = viewtxrx.findViewById(R.id.allsensorchannels);
        btnAllSensorChannels.setOnClickListener(this);

        edtDriverCH0 = viewtxrx.findViewById(R.id.driverch0);
        edtDriverCH1 = viewtxrx.findViewById(R.id.driverch1);
        edtDriverCH2 = viewtxrx.findViewById(R.id.driverch2);
        edtDriverCH3 = viewtxrx.findViewById(R.id.driverch3);
        edtDriverCH4 = viewtxrx.findViewById(R.id.driverch4);
        edtDriverCH5 = viewtxrx.findViewById(R.id.driverch5);
        edtDriverCH6 = viewtxrx.findViewById(R.id.driverch6);
        edtDriverCH7 = viewtxrx.findViewById(R.id.driverch7);
        edtDriverCH8 = viewtxrx.findViewById(R.id.driverch8);
        edtDriverCH9 = viewtxrx.findViewById(R.id.driverch9);
        edtDriverCH10 = viewtxrx.findViewById(R.id.driverch10);
        edtDriverCH11 = viewtxrx.findViewById(R.id.driverch11);
        edtDriverCH12 = viewtxrx.findViewById(R.id.driverch12);
        edtDriverCH13 = viewtxrx.findViewById(R.id.driverch13);
        edtDriverCH14 = viewtxrx.findViewById(R.id.driverch14);
        edtDriverCH15 = viewtxrx.findViewById(R.id.driverch15);
        edtDriverCH16 = viewtxrx.findViewById(R.id.driverch16);
        edtDriverCH17 = viewtxrx.findViewById(R.id.driverch17);
        edtDriverCH18 = viewtxrx.findViewById(R.id.driverch18);
        edtDriverCH19 = viewtxrx.findViewById(R.id.driverch19);
        edtDriverCH20 = viewtxrx.findViewById(R.id.driverch20);
        edtDriverCH21 = viewtxrx.findViewById(R.id.driverch21);
        edtDriverCH22 = viewtxrx.findViewById(R.id.driverch22);
        edtDriverCH23 = viewtxrx.findViewById(R.id.driverch23);
        edtDriverCH24 = viewtxrx.findViewById(R.id.driverch24);
        edtDriverCH25 = viewtxrx.findViewById(R.id.driverch25);
        edtDriverCH26 = viewtxrx.findViewById(R.id.driverch26);
        edtDriverCH27 = viewtxrx.findViewById(R.id.driverch27);
        edtDriverCH28 = viewtxrx.findViewById(R.id.driverch28);
        edtDriverCH29 = viewtxrx.findViewById(R.id.driverch29);
        edtDriverCH30 = viewtxrx.findViewById(R.id.driverch30);
        edtDriverCH31 = viewtxrx.findViewById(R.id.driverch31);
        edtDriverCH32 = viewtxrx.findViewById(R.id.driverch32);
        edtDriverCH33 = viewtxrx.findViewById(R.id.driverch33);
        edtDriverCH34 = viewtxrx.findViewById(R.id.driverch34);
        edtDriverCH35 = viewtxrx.findViewById(R.id.driverch35);
        edtDriverCH36 = viewtxrx.findViewById(R.id.driverch36);
        edtDriverCH37 = viewtxrx.findViewById(R.id.driverch37);
        edtDriverCH38 = viewtxrx.findViewById(R.id.driverch38);
        edtDriverCH39 = viewtxrx.findViewById(R.id.driverch39);
        edtDriverCH40 = viewtxrx.findViewById(R.id.driverch40);
        edtDriverCH41 = viewtxrx.findViewById(R.id.driverch41);
        edtDriverStart = viewtxrx.findViewById(R.id.driverstart);
        edtDriverEnd = viewtxrx.findViewById(R.id.driverend);
        btnDriverRev = viewtxrx.findViewById(R.id.btndriverrev);
        btnDriverRev.setOnClickListener(this);
        btnAllDriverChannels = viewtxrx.findViewById(R.id.alldriverchannels);
        btnAllDriverChannels.setOnClickListener(this);
    }
    */
    private void initPlamRestrainSpin(){
        cbAllPlamRestrain = viewselfsetting.findViewById(R.id.allplamrestrain);
        edtLargeTouch = viewselfsetting.findViewById(R.id.largetouch);
        edtExpanNumOutX = viewselfsetting.findViewById(R.id.expannumoutx);
        edtExpanNumOutY = viewselfsetting.findViewById(R.id.expannumouty);
        edtExpanNumInX = viewselfsetting.findViewById(R.id.expannuminx);
        edtExpanNumInY = viewselfsetting.findViewById(R.id.expannuminy);
        edtSingleRectTopSignNum = viewselfsetting.findViewById(R.id.singlerecttopsignnum);
        edtAllRectTopSignSum = viewselfsetting.findViewById(R.id.allrecttopsignsum);
        cbWaterLargeRestrainEn = viewselfsetting.findViewById(R.id.waterlargerestrainen);
    }

    private void initHoppingSettingSpin(){
        cbHoppingEn = viewexconfig.findViewById(R.id.hoppingen);
        cbRangeExt = viewexconfig.findViewById(R.id.rangeext);
        edtFreqStart = viewexconfig.findViewById(R.id.freqstart);
        edtFreqEnd = viewexconfig.findViewById(R.id.freqend);
        edtDetectStayTimes = viewexconfig.findViewById(R.id.detectstaytimes);
        edtDetectConfirmTimes = viewexconfig.findViewById(R.id.detectconfirmtimes);
        cbDisForceRef = viewexconfig.findViewById(R.id.disforceref);
        cbDelayHopping = viewexconfig.findViewById(R.id.delayhopping);
        edtFastHopLimit = viewexconfig.findViewById(R.id.fasthoplimit);
        edtHopThreshold = viewexconfig.findViewById(R.id.hopthreshold);
        edtNoiseMinTh = viewexconfig.findViewById(R.id.noiseminth);
        edtSensorGroup = viewexconfig.findViewById(R.id.sensorgroup);
        edtSeg1Normalize = viewexconfig.findViewById(R.id.seg1normalize);
        edtSeg1Factor = viewexconfig.findViewById(R.id.seg1factor);
        edtMainClockAjdust = viewexconfig.findViewById(R.id.mainclockajdust);
        edtSeg2Normalize = viewexconfig.findViewById(R.id.seg2normalize);
        edtSeg2Factor = viewexconfig.findViewById(R.id.seg2factor);
        edtSeg3Normalize = viewexconfig.findViewById(R.id.seg3normalize);
        edtSeg3Factor = viewexconfig.findViewById(R.id.seg3factor);
        edtSeg4Normalize = viewexconfig.findViewById(R.id.seg4normalize);
        edtSeg4Factor = viewexconfig.findViewById(R.id.seg4factor);
        edtSeg5Normalize = viewexconfig.findViewById(R.id.seg5normalize);
        edtSeg5Factor = viewexconfig.findViewById(R.id.seg5factor);
        edtSeg6Normalize = viewexconfig.findViewById(R.id.seg6normalize);
        edtHopFreqAddr = viewexconfig.findViewById(R.id.hopfreqaddr);
        edtHopDetectTimes = viewexconfig.findViewById(R.id.hopdetecttimes);
    }

    //Cfg Ram 定义
    private void initCfgShow() {
        mCfg8050 = viewcfgram.findViewById(R.id.cfg8050);
        mCfg8051 = viewcfgram.findViewById(R.id.cfg8051);
        mCfg8052 = viewcfgram.findViewById(R.id.cfg8052);
        mCfg8053 = viewcfgram.findViewById(R.id.cfg8053);
        mCfg8054 = viewcfgram.findViewById(R.id.cfg8054);
        mCfg8055 = viewcfgram.findViewById(R.id.cfg8055);
        mCfg8056 = viewcfgram.findViewById(R.id.cfg8056);
        mCfg8057 = viewcfgram.findViewById(R.id.cfg8057);
        mCfg8058 = viewcfgram.findViewById(R.id.cfg8058);
        mCfg8059 = viewcfgram.findViewById(R.id.cfg8059);
        mCfg805A = viewcfgram.findViewById(R.id.cfg805A);
        mCfg805B = viewcfgram.findViewById(R.id.cfg805B);
        mCfg805C = viewcfgram.findViewById(R.id.cfg805C);
        mCfg805D = viewcfgram.findViewById(R.id.cfg805D);
        mCfg805E = viewcfgram.findViewById(R.id.cfg805E);
        mCfg805F = viewcfgram.findViewById(R.id.cfg805F);

        mCfg8060 = viewcfgram.findViewById(R.id.cfg8060);
        mCfg8061 = viewcfgram.findViewById(R.id.cfg8061);
        mCfg8062 = viewcfgram.findViewById(R.id.cfg8062);
        mCfg8063 = viewcfgram.findViewById(R.id.cfg8063);
        mCfg8064 = viewcfgram.findViewById(R.id.cfg8064);
        mCfg8065 = viewcfgram.findViewById(R.id.cfg8065);
        mCfg8066 = viewcfgram.findViewById(R.id.cfg8066);
        mCfg8067 = viewcfgram.findViewById(R.id.cfg8067);
        mCfg8068 = viewcfgram.findViewById(R.id.cfg8068);
        mCfg8069 = viewcfgram.findViewById(R.id.cfg8069);
        mCfg806A = viewcfgram.findViewById(R.id.cfg806A);
        mCfg806B = viewcfgram.findViewById(R.id.cfg806B);
        mCfg806C = viewcfgram.findViewById(R.id.cfg806C);
        mCfg806D = viewcfgram.findViewById(R.id.cfg806D);
        mCfg806E = viewcfgram.findViewById(R.id.cfg806E);
        mCfg806F = viewcfgram.findViewById(R.id.cfg806F);

        mCfg8070 = viewcfgram.findViewById(R.id.cfg8070);
        mCfg8071 = viewcfgram.findViewById(R.id.cfg8071);
        mCfg8072 = viewcfgram.findViewById(R.id.cfg8072);
        mCfg8073 = viewcfgram.findViewById(R.id.cfg8073);
        mCfg8074 = viewcfgram.findViewById(R.id.cfg8074);
        mCfg8075 = viewcfgram.findViewById(R.id.cfg8075);
        mCfg8076 = viewcfgram.findViewById(R.id.cfg8076);
        mCfg8077 = viewcfgram.findViewById(R.id.cfg8077);
        mCfg8078 = viewcfgram.findViewById(R.id.cfg8078);
        mCfg8079 = viewcfgram.findViewById(R.id.cfg8079);
        mCfg807A = viewcfgram.findViewById(R.id.cfg807A);
        mCfg807B = viewcfgram.findViewById(R.id.cfg807B);
        mCfg807C = viewcfgram.findViewById(R.id.cfg807C);
        mCfg807D = viewcfgram.findViewById(R.id.cfg807D);
        mCfg807E = viewcfgram.findViewById(R.id.cfg807E);
        mCfg807F = viewcfgram.findViewById(R.id.cfg807F);

        mCfg8080 = viewcfgram.findViewById(R.id.cfg8080);
        mCfg8081 = viewcfgram.findViewById(R.id.cfg8081);
        mCfg8082 = viewcfgram.findViewById(R.id.cfg8082);
        mCfg8083 = viewcfgram.findViewById(R.id.cfg8083);
        mCfg8084 = viewcfgram.findViewById(R.id.cfg8084);
        mCfg8085 = viewcfgram.findViewById(R.id.cfg8085);
        mCfg8086 = viewcfgram.findViewById(R.id.cfg8086);
        mCfg8087 = viewcfgram.findViewById(R.id.cfg8087);
        mCfg8088 = viewcfgram.findViewById(R.id.cfg8088);
        mCfg8089 = viewcfgram.findViewById(R.id.cfg8089);
        mCfg808A = viewcfgram.findViewById(R.id.cfg808A);
        mCfg808B = viewcfgram.findViewById(R.id.cfg808B);
        mCfg808C = viewcfgram.findViewById(R.id.cfg808C);
        mCfg808D = viewcfgram.findViewById(R.id.cfg808D);
        mCfg808E = viewcfgram.findViewById(R.id.cfg808E);
        mCfg808F = viewcfgram.findViewById(R.id.cfg808F);

        mCfg8090 = viewcfgram.findViewById(R.id.cfg8090);
        mCfg8091 = viewcfgram.findViewById(R.id.cfg8091);
        mCfg8092 = viewcfgram.findViewById(R.id.cfg8092);
        mCfg8093 = viewcfgram.findViewById(R.id.cfg8093);
        mCfg8094 = viewcfgram.findViewById(R.id.cfg8094);
        mCfg8095 = viewcfgram.findViewById(R.id.cfg8095);
        mCfg8096 = viewcfgram.findViewById(R.id.cfg8096);
        mCfg8097 = viewcfgram.findViewById(R.id.cfg8097);
        mCfg8098 = viewcfgram.findViewById(R.id.cfg8098);
        mCfg8099 = viewcfgram.findViewById(R.id.cfg8099);
        mCfg809A = viewcfgram.findViewById(R.id.cfg809A);
        mCfg809B = viewcfgram.findViewById(R.id.cfg809B);
        mCfg809C = viewcfgram.findViewById(R.id.cfg809C);
        mCfg809D = viewcfgram.findViewById(R.id.cfg809D);
        mCfg809E = viewcfgram.findViewById(R.id.cfg809E);
        mCfg809F = viewcfgram.findViewById(R.id.cfg809F);

        mCfg80A0 = viewcfgram.findViewById(R.id.cfg80A0);
        mCfg80A1 = viewcfgram.findViewById(R.id.cfg80A1);
        mCfg80A2 = viewcfgram.findViewById(R.id.cfg80A2);
        mCfg80A3 = viewcfgram.findViewById(R.id.cfg80A3);
        mCfg80A4 = viewcfgram.findViewById(R.id.cfg80A4);
        mCfg80A5 = viewcfgram.findViewById(R.id.cfg80A5);
        mCfg80A6 = viewcfgram.findViewById(R.id.cfg80A6);
        mCfg80A7 = viewcfgram.findViewById(R.id.cfg80A7);
        mCfg80A8 = viewcfgram.findViewById(R.id.cfg80A8);
        mCfg80A9 = viewcfgram.findViewById(R.id.cfg80A9);
        mCfg80AA = viewcfgram.findViewById(R.id.cfg80AA);
        mCfg80AB = viewcfgram.findViewById(R.id.cfg80AB);
        mCfg80AC = viewcfgram.findViewById(R.id.cfg80AC);
        mCfg80AD = viewcfgram.findViewById(R.id.cfg80AD);
        mCfg80AE = viewcfgram.findViewById(R.id.cfg80AE);
        mCfg80AF = viewcfgram.findViewById(R.id.cfg80AF);

        mCfg80B0 = viewcfgram.findViewById(R.id.cfg80B0);
        mCfg80B1 = viewcfgram.findViewById(R.id.cfg80B1);
        mCfg80B2 = viewcfgram.findViewById(R.id.cfg80B2);
        mCfg80B3 = viewcfgram.findViewById(R.id.cfg80B3);
        mCfg80B4 = viewcfgram.findViewById(R.id.cfg80B4);
        mCfg80B5 = viewcfgram.findViewById(R.id.cfg80B5);
        mCfg80B6 = viewcfgram.findViewById(R.id.cfg80B6);
        mCfg80B7 = viewcfgram.findViewById(R.id.cfg80B7);
        mCfg80B8 = viewcfgram.findViewById(R.id.cfg80B8);
        mCfg80B9 = viewcfgram.findViewById(R.id.cfg80B9);
        mCfg80BA = viewcfgram.findViewById(R.id.cfg80BA);
        mCfg80BB = viewcfgram.findViewById(R.id.cfg80BB);
        mCfg80BC = viewcfgram.findViewById(R.id.cfg80BC);
        mCfg80BD = viewcfgram.findViewById(R.id.cfg80BD);
        mCfg80BE = viewcfgram.findViewById(R.id.cfg80BE);
        mCfg80BF = viewcfgram.findViewById(R.id.cfg80BF);

        mCfg80C0 = viewcfgram.findViewById(R.id.cfg80C0);
        mCfg80C1 = viewcfgram.findViewById(R.id.cfg80C1);
        mCfg80C2 = viewcfgram.findViewById(R.id.cfg80C2);
        mCfg80C3 = viewcfgram.findViewById(R.id.cfg80C3);
        mCfg80C4 = viewcfgram.findViewById(R.id.cfg80C4);
        mCfg80C5 = viewcfgram.findViewById(R.id.cfg80C5);
        mCfg80C6 = viewcfgram.findViewById(R.id.cfg80C6);
        mCfg80C7 = viewcfgram.findViewById(R.id.cfg80C7);
        mCfg80C8 = viewcfgram.findViewById(R.id.cfg80C8);
        mCfg80C9 = viewcfgram.findViewById(R.id.cfg80C9);
        mCfg80CA = viewcfgram.findViewById(R.id.cfg80CA);
        mCfg80CB = viewcfgram.findViewById(R.id.cfg80CB);
        mCfg80CC = viewcfgram.findViewById(R.id.cfg80CC);
        mCfg80CD = viewcfgram.findViewById(R.id.cfg80CD);
        mCfg80CE = viewcfgram.findViewById(R.id.cfg80CE);
        mCfg80CF = viewcfgram.findViewById(R.id.cfg80CF);

        mCfg80D0 = viewcfgram.findViewById(R.id.cfg80D0);
        mCfg80D1 = viewcfgram.findViewById(R.id.cfg80D1);
        mCfg80D2 = viewcfgram.findViewById(R.id.cfg80D2);
        mCfg80D3 = viewcfgram.findViewById(R.id.cfg80D3);
        mCfg80D4 = viewcfgram.findViewById(R.id.cfg80D4);
        mCfg80D5 = viewcfgram.findViewById(R.id.cfg80D5);
        mCfg80D6 = viewcfgram.findViewById(R.id.cfg80D6);
        mCfg80D7 = viewcfgram.findViewById(R.id.cfg80D7);
        mCfg80D8 = viewcfgram.findViewById(R.id.cfg80D8);
        mCfg80D9 = viewcfgram.findViewById(R.id.cfg80D9);
        mCfg80DA = viewcfgram.findViewById(R.id.cfg80DA);
        mCfg80DB = viewcfgram.findViewById(R.id.cfg80DB);
        mCfg80DC = viewcfgram.findViewById(R.id.cfg80DC);
        mCfg80DD = viewcfgram.findViewById(R.id.cfg80DD);
        mCfg80DE = viewcfgram.findViewById(R.id.cfg80DE);
        mCfg80DF = viewcfgram.findViewById(R.id.cfg80DF);

        mCfg80E0 = viewcfgram.findViewById(R.id.cfg80E0);
        mCfg80E1 = viewcfgram.findViewById(R.id.cfg80E1);
        mCfg80E2 = viewcfgram.findViewById(R.id.cfg80E2);
        mCfg80E3 = viewcfgram.findViewById(R.id.cfg80E3);
        mCfg80E4 = viewcfgram.findViewById(R.id.cfg80E4);
        mCfg80E5 = viewcfgram.findViewById(R.id.cfg80E5);
        mCfg80E6 = viewcfgram.findViewById(R.id.cfg80E6);
        mCfg80E7 = viewcfgram.findViewById(R.id.cfg80E7);
        mCfg80E8 = viewcfgram.findViewById(R.id.cfg80E8);
        mCfg80E9 = viewcfgram.findViewById(R.id.cfg80E9);
        mCfg80EA = viewcfgram.findViewById(R.id.cfg80EA);
        mCfg80EB = viewcfgram.findViewById(R.id.cfg80EB);
        mCfg80EC = viewcfgram.findViewById(R.id.cfg80EC);
        mCfg80ED = viewcfgram.findViewById(R.id.cfg80ED);
        mCfg80EE = viewcfgram.findViewById(R.id.cfg80EE);
        mCfg80EF = viewcfgram.findViewById(R.id.cfg80EF);

        mCfg80F0 = viewcfgram.findViewById(R.id.cfg80F0);
        mCfg80F1 = viewcfgram.findViewById(R.id.cfg80F1);
        mCfg80F2 = viewcfgram.findViewById(R.id.cfg80F2);
        mCfg80F3 = viewcfgram.findViewById(R.id.cfg80F3);
        mCfg80F4 = viewcfgram.findViewById(R.id.cfg80F4);
        mCfg80F5 = viewcfgram.findViewById(R.id.cfg80F5);
        mCfg80F6 = viewcfgram.findViewById(R.id.cfg80F6);
        mCfg80F7 = viewcfgram.findViewById(R.id.cfg80F7);
        mCfg80F8 = viewcfgram.findViewById(R.id.cfg80F8);
        mCfg80F9 = viewcfgram.findViewById(R.id.cfg80F9);
        mCfg80FA = viewcfgram.findViewById(R.id.cfg80FA);
        mCfg80FB = viewcfgram.findViewById(R.id.cfg80FB);
        mCfg80FC = viewcfgram.findViewById(R.id.cfg80FC);
        mCfg80FD = viewcfgram.findViewById(R.id.cfg80FD);
        mCfg80FE = viewcfgram.findViewById(R.id.cfg80FE);
        mCfg80FF = viewcfgram.findViewById(R.id.cfg80FF);

        mCfg8100 = viewcfgram.findViewById(R.id.cfg8100);
        mCfg8101 = viewcfgram.findViewById(R.id.cfg8101);
        mCfg8102 = viewcfgram.findViewById(R.id.cfg8102);
        mCfg8103 = viewcfgram.findViewById(R.id.cfg8103);
        mCfg8104 = viewcfgram.findViewById(R.id.cfg8104);
        mCfg8105 = viewcfgram.findViewById(R.id.cfg8105);
        mCfg8106 = viewcfgram.findViewById(R.id.cfg8106);
        mCfg8107 = viewcfgram.findViewById(R.id.cfg8107);
        mCfg8108 = viewcfgram.findViewById(R.id.cfg8108);
        mCfg8109 = viewcfgram.findViewById(R.id.cfg8109);
        mCfg810A = viewcfgram.findViewById(R.id.cfg810A);
        mCfg810B = viewcfgram.findViewById(R.id.cfg810B);
        mCfg810C = viewcfgram.findViewById(R.id.cfg810C);
        mCfg810D = viewcfgram.findViewById(R.id.cfg810D);
        mCfg810E = viewcfgram.findViewById(R.id.cfg810E);
        mCfg810F = viewcfgram.findViewById(R.id.cfg810F);

        mCfg8110 = viewcfgram.findViewById(R.id.cfg8110);
        mCfg8111 = viewcfgram.findViewById(R.id.cfg8111);
        mCfg8112 = viewcfgram.findViewById(R.id.cfg8112);
        mCfg8113 = viewcfgram.findViewById(R.id.cfg8113);
        mCfg8114 = viewcfgram.findViewById(R.id.cfg8114);
        mCfg8115 = viewcfgram.findViewById(R.id.cfg8115);
        mCfg8116 = viewcfgram.findViewById(R.id.cfg8116);
        mCfg8117 = viewcfgram.findViewById(R.id.cfg8117);
        mCfg8118 = viewcfgram.findViewById(R.id.cfg8118);
        mCfg8119 = viewcfgram.findViewById(R.id.cfg8119);
        mCfg811A = viewcfgram.findViewById(R.id.cfg811A);
        mCfg811B = viewcfgram.findViewById(R.id.cfg811B);
        mCfg811C = viewcfgram.findViewById(R.id.cfg811C);
        mCfg811D = viewcfgram.findViewById(R.id.cfg811D);
        mCfg811E = viewcfgram.findViewById(R.id.cfg811E);
        mCfg811F = viewcfgram.findViewById(R.id.cfg811F);

        mCfg8120 = viewcfgram.findViewById(R.id.cfg8120);
        mCfg8121 = viewcfgram.findViewById(R.id.cfg8121);
        mCfg8122 = viewcfgram.findViewById(R.id.cfg8122);
        mCfg8123 = viewcfgram.findViewById(R.id.cfg8123);
        mCfg8124 = viewcfgram.findViewById(R.id.cfg8124);
        mCfg8125 = viewcfgram.findViewById(R.id.cfg8125);
        mCfg8126 = viewcfgram.findViewById(R.id.cfg8126);
        mCfg8127 = viewcfgram.findViewById(R.id.cfg8127);
        mCfg8128 = viewcfgram.findViewById(R.id.cfg8128);
        mCfg8129 = viewcfgram.findViewById(R.id.cfg8129);
        mCfg812A = viewcfgram.findViewById(R.id.cfg812A);
        mCfg812B = viewcfgram.findViewById(R.id.cfg812B);
        mCfg812C = viewcfgram.findViewById(R.id.cfg812C);
        mCfg812D = viewcfgram.findViewById(R.id.cfg812D);
        mCfg812E = viewcfgram.findViewById(R.id.cfg812E);
        mCfg812F = viewcfgram.findViewById(R.id.cfg812F);

        mCfg8130 = viewcfgram.findViewById(R.id.cfg8130);
        mCfg8131 = viewcfgram.findViewById(R.id.cfg8131);
        mCfg8132 = viewcfgram.findViewById(R.id.cfg8132);
        mCfg8133 = viewcfgram.findViewById(R.id.cfg8133);
        mCfg8134 = viewcfgram.findViewById(R.id.cfg8134);
        mCfg8135 = viewcfgram.findViewById(R.id.cfg8135);
        mCfg8136 = viewcfgram.findViewById(R.id.cfg8136);
        mCfg8137 = viewcfgram.findViewById(R.id.cfg8137);
        mCfg8138 = viewcfgram.findViewById(R.id.cfg8138);
        mCfg8139 = viewcfgram.findViewById(R.id.cfg8139);
        mCfg813A = viewcfgram.findViewById(R.id.cfg813A);
        mCfg813B = viewcfgram.findViewById(R.id.cfg813B);
        mCfg813C = viewcfgram.findViewById(R.id.cfg813C);
        mCfg813D = viewcfgram.findViewById(R.id.cfg813D);
        mCfg813E = viewcfgram.findViewById(R.id.cfg813E);
        mCfg813F = viewcfgram.findViewById(R.id.cfg813F);

        mCfgBF7B = viewcfgram.findViewById(R.id.cfgBF7B);
        mCfgBF7C = viewcfgram.findViewById(R.id.cfgBF7C);
        mCfgBF7D = viewcfgram.findViewById(R.id.cfgBF7D);
        mCfgBF7E = viewcfgram.findViewById(R.id.cfgBF7E);
        mCfgBF7F = viewcfgram.findViewById(R.id.cfgBF7F);

        mCfgBF80 = viewcfgram.findViewById(R.id.cfgBF80);
        mCfgBF81 = viewcfgram.findViewById(R.id.cfgBF81);
        mCfgBF82 = viewcfgram.findViewById(R.id.cfgBF82);
        mCfgBF83 = viewcfgram.findViewById(R.id.cfgBF83);
        mCfgBF84 = viewcfgram.findViewById(R.id.cfgBF84);
        mCfgBF85 = viewcfgram.findViewById(R.id.cfgBF85);
        mCfgBF86 = viewcfgram.findViewById(R.id.cfgBF86);
        mCfgBF87 = viewcfgram.findViewById(R.id.cfgBF87);
        mCfgBF88 = viewcfgram.findViewById(R.id.cfgBF88);
        mCfgBF89 = viewcfgram.findViewById(R.id.cfgBF89);
        mCfgBF8A = viewcfgram.findViewById(R.id.cfgBF8A);
        mCfgBF8B = viewcfgram.findViewById(R.id.cfgBF8B);
        mCfgBF8C = viewcfgram.findViewById(R.id.cfgBF8C);
        mCfgBF8D = viewcfgram.findViewById(R.id.cfgBF8D);
        mCfgBF8E = viewcfgram.findViewById(R.id.cfgBF8E);
        mCfgBF8F = viewcfgram.findViewById(R.id.cfgBF8F);

        mCfgBF90 = viewcfgram.findViewById(R.id.cfgBF90);
        mCfgBF91 = viewcfgram.findViewById(R.id.cfgBF91);
        mCfgBF92 = viewcfgram.findViewById(R.id.cfgBF92);
        mCfgBF93 = viewcfgram.findViewById(R.id.cfgBF93);
        mCfgBF94 = viewcfgram.findViewById(R.id.cfgBF94);
        mCfgBF95 = viewcfgram.findViewById(R.id.cfgBF95);
        mCfgBF96 = viewcfgram.findViewById(R.id.cfgBF96);
        mCfgBF97 = viewcfgram.findViewById(R.id.cfgBF97);
        mCfgBF98 = viewcfgram.findViewById(R.id.cfgBF98);
        mCfgBF99 = viewcfgram.findViewById(R.id.cfgBF99);
        mCfgBF9A = viewcfgram.findViewById(R.id.cfgBF9A);
        mCfgBF9B = viewcfgram.findViewById(R.id.cfgBF9B);
        mCfgBF9C = viewcfgram.findViewById(R.id.cfgBF9C);
        mCfgBF9D = viewcfgram.findViewById(R.id.cfgBF9D);
        mCfgBF9E = viewcfgram.findViewById(R.id.cfgBF9E);
        mCfgBF9F = viewcfgram.findViewById(R.id.cfgBF9F);

        mCfgBFA0 = viewcfgram.findViewById(R.id.cfgBFA0);
        mCfgBFA1 = viewcfgram.findViewById(R.id.cfgBFA1);
        mCfgBFA2 = viewcfgram.findViewById(R.id.cfgBFA2);
        mCfgBFA3 = viewcfgram.findViewById(R.id.cfgBFA3);
        mCfgBFA4 = viewcfgram.findViewById(R.id.cfgBFA4);
        mCfgBFA5 = viewcfgram.findViewById(R.id.cfgBFA5);
        mCfgBFA6 = viewcfgram.findViewById(R.id.cfgBFA6);
        mCfgBFA7 = viewcfgram.findViewById(R.id.cfgBFA7);
        mCfgBFA8 = viewcfgram.findViewById(R.id.cfgBFA8);
        mCfgBFA9 = viewcfgram.findViewById(R.id.cfgBFA9);
        mCfgBFAA = viewcfgram.findViewById(R.id.cfgBFAA);
        mCfgBFAB = viewcfgram.findViewById(R.id.cfgBFAB);
        mCfgBFAC = viewcfgram.findViewById(R.id.cfgBFAC);
        mCfgBFAD = viewcfgram.findViewById(R.id.cfgBFAD);
        mCfgBFAE = viewcfgram.findViewById(R.id.cfgBFAE);
        mCfgBFAF = viewcfgram.findViewById(R.id.cfgBFAF);

        mCfgBFB0 = viewcfgram.findViewById(R.id.cfgBFB0);
        mCfgBFB1 = viewcfgram.findViewById(R.id.cfgBFB1);
        mCfgBFB2 = viewcfgram.findViewById(R.id.cfgBFB2);
        mCfgBFB3 = viewcfgram.findViewById(R.id.cfgBFB3);
        mCfgBFB4 = viewcfgram.findViewById(R.id.cfgBFB4);
        mCfgBFB5 = viewcfgram.findViewById(R.id.cfgBFB5);
        mCfgBFB6 = viewcfgram.findViewById(R.id.cfgBFB6);
        mCfgBFB7 = viewcfgram.findViewById(R.id.cfgBFB7);
        mCfgBFB8 = viewcfgram.findViewById(R.id.cfgBFB8);
        mCfgBFB9 = viewcfgram.findViewById(R.id.cfgBFB9);
        mCfgBFBA = viewcfgram.findViewById(R.id.cfgBFBA);
        mCfgBFBB = viewcfgram.findViewById(R.id.cfgBFBB);
        mCfgBFBC = viewcfgram.findViewById(R.id.cfgBFBC);
        mCfgBFBD = viewcfgram.findViewById(R.id.cfgBFBD);
        mCfgBFBE = viewcfgram.findViewById(R.id.cfgBFBE);
        mCfgBFBF = viewcfgram.findViewById(R.id.cfgBFBF);

        mCfgBFC0 = viewcfgram.findViewById(R.id.cfgBFC0);
        mCfgBFC1 = viewcfgram.findViewById(R.id.cfgBFC1);
        mCfgBFC2 = viewcfgram.findViewById(R.id.cfgBFC2);
        mCfgBFC3 = viewcfgram.findViewById(R.id.cfgBFC3);
        mCfgBFC4 = viewcfgram.findViewById(R.id.cfgBFC4);
        mCfgBFC5 = viewcfgram.findViewById(R.id.cfgBFC5);
        mCfgBFC6 = viewcfgram.findViewById(R.id.cfgBFC6);
        mCfgBFC7 = viewcfgram.findViewById(R.id.cfgBFC7);
        mCfgBFC8 = viewcfgram.findViewById(R.id.cfgBFC8);
        mCfgBFC9 = viewcfgram.findViewById(R.id.cfgBFC9);
        mCfgBFCA = viewcfgram.findViewById(R.id.cfgBFCA);
        mCfgBFCB = viewcfgram.findViewById(R.id.cfgBFCB);
        mCfgBFCC = viewcfgram.findViewById(R.id.cfgBFCC);
        mCfgBFCD = viewcfgram.findViewById(R.id.cfgBFCD);
        mCfgBFCE = viewcfgram.findViewById(R.id.cfgBFCE);
        mCfgBFCF = viewcfgram.findViewById(R.id.cfgBFCF);

        mCfgBFD0 = viewcfgram.findViewById(R.id.cfgBFD0);
        mCfgBFD1 = viewcfgram.findViewById(R.id.cfgBFD1);
        mCfgBFD2 = viewcfgram.findViewById(R.id.cfgBFD2);
        mCfgBFD3 = viewcfgram.findViewById(R.id.cfgBFD3);
        mCfgBFD4 = viewcfgram.findViewById(R.id.cfgBFD4);
        mCfgBFD5 = viewcfgram.findViewById(R.id.cfgBFD5);
        mCfgBFD6 = viewcfgram.findViewById(R.id.cfgBFD6);
        mCfgBFD7 = viewcfgram.findViewById(R.id.cfgBFD7);
        mCfgBFD8 = viewcfgram.findViewById(R.id.cfgBFD8);
        mCfgBFD9 = viewcfgram.findViewById(R.id.cfgBFD9);
        mCfgBFDA = viewcfgram.findViewById(R.id.cfgBFDA);
        mCfgBFDB = viewcfgram.findViewById(R.id.cfgBFDB);
        mCfgBFDC = viewcfgram.findViewById(R.id.cfgBFDC);
        mCfgBFDD = viewcfgram.findViewById(R.id.cfgBFDD);
        mCfgBFDE = viewcfgram.findViewById(R.id.cfgBFDE);
        mCfgBFDF = viewcfgram.findViewById(R.id.cfgBFDF);

        mCfgBFE0 = viewcfgram.findViewById(R.id.cfgBFE0);
        mCfgBFE1 = viewcfgram.findViewById(R.id.cfgBFE1);
        mCfgBFE2 = viewcfgram.findViewById(R.id.cfgBFE2);
        mCfgBFE3 = viewcfgram.findViewById(R.id.cfgBFE3);
        mCfgBFE4 = viewcfgram.findViewById(R.id.cfgBFE4);
        mCfgBFE5 = viewcfgram.findViewById(R.id.cfgBFE5);
        mCfgBFE6 = viewcfgram.findViewById(R.id.cfgBFE6);
        mCfgBFE7 = viewcfgram.findViewById(R.id.cfgBFE7);
        mCfgBFE8 = viewcfgram.findViewById(R.id.cfgBFE8);
        mCfgBFE9 = viewcfgram.findViewById(R.id.cfgBFE9);
        mCfgBFEA = viewcfgram.findViewById(R.id.cfgBFEA);
        mCfgBFEB = viewcfgram.findViewById(R.id.cfgBFEB);
        mCfgBFEC = viewcfgram.findViewById(R.id.cfgBFEC);
        mCfgBFED = viewcfgram.findViewById(R.id.cfgBFED);
        mCfgBFEE = viewcfgram.findViewById(R.id.cfgBFEE);
        mCfgBFEF = viewcfgram.findViewById(R.id.cfgBFEF);

        mCfgBFF0 = viewcfgram.findViewById(R.id.cfgBFF0);
        mCfgBFF1 = viewcfgram.findViewById(R.id.cfgBFF1);
        mCfgBFF2 = viewcfgram.findViewById(R.id.cfgBFF2);
        mCfgBFF3 = viewcfgram.findViewById(R.id.cfgBFF3);
        mCfgBFF4 = viewcfgram.findViewById(R.id.cfgBFF4);
        mCfgBFF5 = viewcfgram.findViewById(R.id.cfgBFF5);
        mCfgBFF6 = viewcfgram.findViewById(R.id.cfgBFF6);
        mCfgBFF7 = viewcfgram.findViewById(R.id.cfgBFF7);
        mCfgBFF8 = viewcfgram.findViewById(R.id.cfgBFF8);
        mCfgBFF9 = viewcfgram.findViewById(R.id.cfgBFF9);
        mCfgBFFA = viewcfgram.findViewById(R.id.cfgBFFA);
    }
    //===============================各view中的元素初始化结束===============================================//
    /*
    @Override
    public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
        switch (parent.getId()){
            case R.id.pgagainspin:
                if(PGAGainSelected){
                    Toast.makeText(mContext,"您的选择是：" + parent.getItemAtPosition(position).toString(),
                            Toast.LENGTH_SHORT).show();
                }else PGAGainSelected = true;
                break;

           default:
                break;
        }
    }

    @Override
    public void onNothingSelected(AdapterView<?> parent) {

    }
    */
    public List<String> loadFile(String fileName){
        List<String> lists = new ArrayList<>();
        try {
            File file = new File(fileName);
            InputStream instream = new FileInputStream(file);
            if (instream != null) {
                InputStreamReader inputreader
                        = new InputStreamReader(instream, "UTF-8");//UTF-8
                BufferedReader buffreader = new BufferedReader(inputreader);
                String line = "";
                while ((line = buffreader.readLine()) != null) {
                    lists.add(line);
                }
                instream.close();
                //editdetail.setText(buffreader.toString()); //buffer.toString())就是读出的内容字符
                //mShow.setText(inputreader.toString());
            }
        } catch (Exception e) {
            //Log.e(TAG, "****Load " + fileName + " Error****");
        }
        return lists;
    }

    protected void onActivityResult ( int requestCode, int resultCode, Intent data){
        if (resultCode == Activity.RESULT_OK) {
            if (requestCode == 1) {
                Uri uri = data.getData();
                //Toast.makeText(this, "文件路径：" + uri.getPath().toString(), Toast.LENGTH_SHORT).show();
                edit_search.setText(uri.getPath().toString());
                //loadFile(uri.getPath().toString());
                ActivityCompat.requestPermissions(  Config.this, new String[]{android
                        .Manifest.permission.WRITE_EXTERNAL_STORAGE}, 2);

                StringBuffer buffer = new StringBuffer();
                try {
                    FileInputStream fis = new FileInputStream(uri.getPath().toString());
                    InputStreamReader isr = new InputStreamReader(fis,"UTF-8");//文件编码Unicode,UTF-8,ASCII,GB2312,Big5
                    Reader in = new BufferedReader(isr);
                    int ch;
                    while ((ch = in.read()) > -1) {
                        buffer.append((char)ch);
                    }
                    in.close();
                    String configString;
                    configString = buffer.toString();
                    //mShow.setText(configString.toString());

                    //value = value.trim();  //去除空格
                    configString = configString.replaceAll("0x", ""); //0x转换为没有
                    //editdetail.setText(configString.toString()); //buffer.toString())就是读出的内容字符

                    String[] stringCfgArr = configString.split(",");
                    //byte bcfgarr[] = new byte[188];

                    //for (byte i = 0; i < 186; i++){
                    //    mBytes[i] = (byte) Integer.parseInt(stringCfgArr[i]);
                    //}

                    int showid = 0;

                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;
                    mBytes[showid] = (byte) Integer.parseInt(stringCfgArr[showid], 16);
                    showid++;

                    ReadCfgSample(mBytes);
                    ReadCfgModuleSwitch(mBytes);
                    ReadCfgNormalSetting(mBytes);
                    ReadCfgChannelSetting(mBytes);
                    ReadCfgPenSetting(mBytes);
                    ReadCfgPlamRestrain(mBytes);
                    ReadCfgHoppingSetting(mBytes);
                    ReadCfgRam(stringCfgArr);
                } catch (IOException e) {
                    //editdetail.setText("文件不存在!");
                }

                /*
                File file = new File(uri.getPath());
                String str = null;
                try {
                    InputStream is = new FileInputStream(file);
                    InputStreamReader input = new InputStreamReader(is, "UTF-8");
                    BufferedReader reader = new BufferedReader(input);
                    while ((str = reader.readLine()) != null) {
                        editdetail.setText(str);
                        //editdetail.append("\n");
                    }

                } catch (FileNotFoundException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                } catch (IOException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
                */
            }
        }

    }

    private void initListener() {
        mReadCfg.setOnClickListener(this);
        mSendCfg.setOnClickListener(this);
    }


    //byte[] mGt9PScFileData = new byte[197 * 1024 + 512];
    private void initData() {
        mContext = getApplicationContext();
        mReadCfg.setEnabled(false);    //

        mSendCfg.setEnabled(false);

        btnsave.setEnabled(false);

        mThreadPool = Executors.newFixedThreadPool(5);

        mUsbManager = (UsbManager) getSystemService(Context.USB_SERVICE);


        /*
        ActivityCompat.requestPermissions(  Config.this, new String[]{android
                .Manifest.permission.WRITE_EXTERNAL_STORAGE}, 1);   //申请权限，android6.0以上系统首次使用必须添加

        StringBuffer buffer = new StringBuffer();
        StringBuilder scfilestringbuilder = new StringBuilder("");
        if (Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)) {

            try {
                InputStream fis = getResources().openRawResource(R.raw.gt7288_2019091201);
                //gt9110h_config_20181108
                fis.read(mGt9PScFileData);

                //config.close();
                fis.close();

            } catch (FileNotFoundException e) {
                e.printStackTrace();
                // mMessage.setText("文件没被发现");
                //Update_log = "文件没被发现";
                mHandler.sendEmptyMessage(DEBUG_MESSAGE_ERROR);

            }
            catch (IOException e) {
                e.printStackTrace();
                // mMessage.setText("IOException");
                //Update_log = "IOException";
                mHandler.sendEmptyMessage(DEBUG_MESSAGE_ERROR);
            }

        }
        else{
            // mMessage.setText("SD卡不可读写!");
            //Update_log = "SD卡不可读写!";
            mHandler.sendEmptyMessage(DEBUG_MESSAGE_ERROR);
        }

        for (int i = 0; i < mGt9PScFileData.length; i++)
        {
            mGt9PScFileData[i] -= 1;
        }

        String strGt9PScFileData = new String(mGt9PScFileData);

        int i = 0;
        */
    }

    /**
     * 打开设备 , 让车机和手机端连起来
     */
    private void openDevices() {

        //列举设备(手机)
        cfgOpenDevicesReceiver = new OpenDevicesReceiver(this);
        mThreadPool.execute(new Runnable() {
            @Override
            public void run() {
            SystemClock.sleep(1000);
            PendingIntent pendingIntent = PendingIntent.getBroadcast(mContext, 0, new Intent(ACTION_USB_PERMISSION), 0);
            IntentFilter intentFilter = new IntentFilter(USB_ACTION);

            registerReceiver(cfgOpenDevicesReceiver, intentFilter);
        while(isNeedFindDevice) {
            SystemClock.sleep(100);
            HashMap<String, UsbDevice> deviceList = mUsbManager.getDeviceList();
            if (deviceList != null) {
                for (UsbDevice usbDevice : deviceList.values()) {
                    int productId = usbDevice.getProductId();
                    int vendorId = usbDevice.getVendorId();
                    if ((productId == 0x0616 && vendorId == 0x27C0)
                            ||(productId == 0x0818 && vendorId == 0x27C0)
                            ||(productId == 0x0001 && vendorId == 0x222A))  //奕力的PID和VID
                    {
                        //这里说明下,这里的377 , 7205是我这台机子上独有,因为我这上面有多台设备,所以我在这里
                        //判断了下.只有一台设备的无需这一步.
                        //mUsbManager.requestPermission(usbDevice, pendingIntent);
                        //SystemClock.sleep(100);
                        if (mUsbManager.hasPermission(usbDevice)) {
                                    initDevice();

                                } else {
                                    mUsbManager.requestPermission(usbDevice, pendingIntent);
                                    break;
                                }
                                break;
                            }
                        }
                    } else {
                        //mError.setText("请连接USB");
                    }
                    // }
                }
            }   //ThreadPool
        });   //ThreadPool
    }

    /**
     * 初始化设备(手机) , 当手机进入Accessory模式后 , 手机的PID会变为Google定义的2个常量值其中的一个 ,
     */
    private void initDevice() {

        HashMap<String, UsbDevice> deviceList = mUsbManager.getDeviceList();
        Collection<UsbDevice> values = deviceList.values();
        if (!values.isEmpty()) {
            for (UsbDevice usbDevice : values) {
                int productId = usbDevice.getProductId();
                if (productId == 0x0818 || productId == 0x0001 || productId == 0x0616) {  //0x0001是奕力的PID
                    if (mUsbManager.hasPermission(usbDevice)) {
                        UsbInterface usbInterface = usbDevice.getInterface(1);

                        for (int i = 0; i < usbInterface.getEndpointCount(); i++) {
                            UsbEndpoint ep = usbInterface.getEndpoint(i);

                            //if (ep.getType() == UsbConstants.USB_ENDPOINT_XFER_BULK) {
                            if (ep.getDirection() == UsbConstants.USB_DIR_OUT) {
                                //mUsbEndpointIn = ep;
                                mUsbEndpointOut = ep;
                            } else {
                                //mUsbEndpointOut = ep;
                                mUsbEndpointIn = ep;
                            }
                            //}
                            //else{
                            // mHandler.sendEmptyMessage(CONNECTED_SUCCESS);
                            //}
                        }

                        if ((null == mUsbEndpointIn) || (null == mUsbEndpointOut)) {
                            mUsbDeviceConnection = mUsbManager.openDevice(usbDevice);
                            if (mUsbDeviceConnection!=null) {
                                int i = mUsbDeviceConnection.controlTransfer(0x00, 0x09,
                                        0x002, 0, null, 0, 100);
                                SystemClock.sleep(1000);
                                if (i >= 0) {
                                    //mHandler.sendEmptyMessage(DEBUG_MESSAGE_SUCCESS);
                                } else {
                                    //mHandler.sendEmptyMessage(DEBUG_MESSAGE_ERROR);
                                }
                            }
                        } else {
                            isNeedFindDevice = false;
                            mUsbInterface = usbInterface;
                            mUsbDeviceConnection = mUsbManager.openDevice(usbDevice);
                            mUsbDeviceConnection.claimInterface(mUsbInterface, true);
                            if(null != mUsbEndpointIn){
                                mHandler.sendEmptyMessage(CONNECTED_SUCCESS);
                            }
                        }

                    }
                    else {
                        mUsbManager.requestPermission(usbDevice, PendingIntent.getBroadcast(mContext, 0, new Intent(""), 0));
                    }
                }
            }
        } else {
            // finish();
        }
    }


    //=====================================读取CFG到各个View开始===================================//
    public void ReadCfgSample(byte[] mBytes){
        int temp;

        cbAllDrivingEn.setChecked(false);
        if ((mBytes[27] & 0x80) == 0x80){
            cbAllDrivingEn.setChecked(true);
        }
        cbDualFreq.setChecked(false);
        if ((mBytes[28] & 0x20) == 0x20){
            cbDualFreq.setChecked(true);
        }
        edtFreqAFactor.setText(Integer.toString(mBytes[30] & 0xFF));
        edtFreqBFactor.setText(Integer.toString(mBytes[31] & 0xFF));

        temp = (int)((mBytes[32] & 0xFF) + mBytes[33] * 256);
        edtPannelBitFreq.setText(Integer.toString(temp & 0xFFFF));

        //edtDuration
        spinDACGain.setSelection(mBytes[36] & 0x07);
        spinDrvOutputR.setSelection((mBytes[36] & 0x18) >> 3);
        spinPGAGain.setSelection(mBytes[37] & 0x07);
        spinRxVcmi.setSelection((mBytes[37] & 0x18) >> 3);
        spinPGAR.setSelection((mBytes[37] & 0x60) >> 5);
        spinPGAC.setSelection((mBytes[37] & 0x80) >> 7);
        edtDumpShift.setText(Integer.toString(mBytes[38] & 0x0F));
        edtSubFrameDrvNum.setText(Integer.toString((mBytes[39] & 0x7C) >> 2));
        spinVoltage.setSelection(mBytes[92] & 0x07);
        spinBoostTime.setSelection((mBytes[92] & 0x70) >> 4);
        cbExtoscen.setChecked(false);
        if ((mBytes[93] & 0x80) == 0x80){
            cbExtoscen.setChecked(true);
        }
        spinAlterCount.setSelection(mBytes[94] & 0x03);
    }

    public void ReadCfgModuleSwitch(byte[] mBytes){
        cbSito.setChecked(false);
        if ((mBytes[6] & 0x04) == 0x04){
            cbSito.setChecked(true);
        }
        cbX2Y.setChecked(false);
        if ((mBytes[6] & 0x08) == 0x08){
            cbX2Y.setChecked(true);
        }

        spinInterrupt.setSelection(mBytes[6] & 0x03);
        spinStretchRank.setSelection((mBytes[6] & 0x30) >> 4);

        cbDiffDivideBy2or4.setChecked(false);
        if ((mBytes[7] & 0x04) == 0x04){
            cbDiffDivideBy2or4.setChecked(true);
        }
        cbFirstFilterDis.setChecked(false);
        if ((mBytes[7] & 0x20) == 0x20){
            cbFirstFilterDis.setChecked(true);
        }
        cbMonitorConsistencyConflictEn.setChecked(false);
        if ((mBytes[7] & 0x40) == 0x40){
            cbMonitorConsistencyConflictEn.setChecked(true);
        }
        cbWaterSpeedLimitEn.setChecked(false);
        if ((mBytes[91] & 0x01) == 0x01){
            cbWaterSpeedLimitEn.setChecked(true);
        }
        cbShapeEn.setChecked(false);
        if ((mBytes[91] & 0x04) == 0x04){
            cbShapeEn.setChecked(true);
        }
        cbWaterProofDis.setChecked(false);
        if ((mBytes[91] & 0x08) == 0x08){
            cbWaterProofDis.setChecked(true);
        }
        cbLcdPlusMinusEn.setChecked(false);
        if ((mBytes[91] & 0x10) == 0x10){
            cbLcdPlusMinusEn.setChecked(true);
        }
        cbX2X.setChecked(false);
        if ((mBytes[104] & 0x01) == 0x01){
            cbX2X.setChecked(true);
        }
        cbY2Y.setChecked(false);
        if ((mBytes[104] & 0x02) == 0x02){
            cbY2Y.setChecked(true);
        }
        cbESDEn.setChecked(false);
        if ((mBytes[104] & 0x10) == 0x10){
            cbESDEn.setChecked(true);
        }
        cbINTWakeup.setChecked(false);
        if ((mBytes[104] & 0x20) == 0x20){
            cbINTWakeup.setChecked(true);
        }
    }

    public void ReadCfgNormalSetting(byte[] mBytes){
        String hv;
        edtConfigVersion.setText(Integer.toString(mBytes[0] & 0xFF));
        edtTouchNumber.setText(Integer.toString(mBytes[5] & 0x0F));

        hv = Integer.toHexString(mBytes[8] & 0xFF);
        if (hv.length() < 2){
            hv = "0" + hv;
        }
        edtShakeCnt.setText(hv);

        edtNormalFilter.setText(Integer.toString(mBytes[9] & 0x3F));
        edtFirstFilter.setText(Integer.toString((mBytes[9] & 0xFF) >> 6));
        edtNoiseReduction.setText(Integer.toString(mBytes[11] & 0x0F));
        edtScreenTouchLv.setText(Integer.toString(mBytes[12] & 0xFF));
        edtScreenLeaveLv.setText(Integer.toString(mBytes[13] & 0xFF));
        edtLowPowerControl.setText(Integer.toString(mBytes[14] & 0x0F));
        spinRefreshRate.setSelection(mBytes[15] & 0x0F);
        edtXThreshold.setText(Integer.toString(mBytes[16] & 0xFF));
        edtYThreshold.setText(Integer.toString(mBytes[17] & 0xFF));

        hv = Integer.toHexString(mBytes[20] & 0xFF);
        if (hv.length() < 2){
            hv = "0" + hv;
        }
        edtSpaceUpDown.setText(hv);
        hv = Integer.toHexString(mBytes[21] & 0xFF);
        if (hv.length() < 2){
            hv = "0" + hv;
        }
        edtSpaceLeftRight.setText(hv);

        edtMiniFilter.setText(Integer.toString(mBytes[22] & 0x0F));
        edtStretchR0.setText(Integer.toString(mBytes[23] & 0xFF));
        edtStretchR1.setText(Integer.toString(mBytes[24] & 0xFF));
        edtStretchR2.setText(Integer.toString(mBytes[25] & 0xFF));
        edtStretchRM.setText(Integer.toString(mBytes[26] & 0xFF));
        edtChargingLevelUp.setText(Integer.toString(mBytes[49] & 0xFF));
        edtLcdPlusMinusValue.setText(Integer.toString(mBytes[58] & 0xFF));
        edtShapeRestrain.setText(Integer.toString(mBytes[87] & 0x7F));
        edtConThreshold.setText(Integer.toString(mBytes[88] & 0xFF));
        edtWaterFrameTime.setText(Integer.toString(mBytes[89] & 0xFF));
        edtWaterUpdateTime.setText(Integer.toString(mBytes[90] & 0xFF));
        edtSlideInEdgeConfig.setText(Integer.toString(mBytes[96] & 0xFF));
        edtSlideOutEdgeConfig.setText(Integer.toString(mBytes[97] & 0xFF));
        edtShapeContrl.setText(Integer.toString(mBytes[105] & 0x1F));
        edtCombineDis.setText(Integer.toString(mBytes[106] & 0x0F));
        edtSplitSet.setText(Integer.toString(mBytes[107] & 0xFF));
        edtSitoDiffRefLevel.setText(Integer.toString(mBytes[110] & 0xFF));
    }

    public void ReadCfgChannelSetting(byte[] mBytes){
        int temp;

        temp = (int)((mBytes[1] & 0xFF) + mBytes[2] * 256);
        edtXOutputMax.setText(Integer.toString(temp & 0xFFFF));
        temp = (int)((mBytes[3] & 0xFF) + mBytes[4] * 256);
        edtYOutputMax.setText(Integer.toString(temp & 0xFFFF));

        edtDrvGroupAnumber.setText(Integer.toString(mBytes[27] & 0x1F));
        edtDrvGroupBnumber.setText(Integer.toString(mBytes[28] & 0x1F));
        bDriverNumber = (byte)((mBytes[27] & 0x1F) + (mBytes[28] & 0x1F));

        edtSenGroupANumber.setText(Integer.toString(mBytes[29] & 0x0F));
        edtSenGroupBNumber.setText(Integer.toString((mBytes[29] & 0xF0) >> 4));
        bSensorNumber = (byte)((mBytes[29] & 0x0F) + ((mBytes[29] & 0xF0) >> 4));

        edtSensorCH0.setText(Integer.toString(mBytes[112] & 0xFF));
        edtSensorCH1.setText(Integer.toString(mBytes[113] & 0xFF));
        edtSensorCH2.setText(Integer.toString(mBytes[114] & 0xFF));
        edtSensorCH3.setText(Integer.toString(mBytes[115] & 0xFF));
        edtSensorCH4.setText(Integer.toString(mBytes[116] & 0xFF));
        edtSensorCH5.setText(Integer.toString(mBytes[117] & 0xFF));
        edtSensorCH6.setText(Integer.toString(mBytes[118] & 0xFF));
        edtSensorCH7.setText(Integer.toString(mBytes[119] & 0xFF));
        edtSensorCH8.setText(Integer.toString(mBytes[120] & 0xFF));
        edtSensorCH9.setText(Integer.toString(mBytes[121] & 0xFF));
        edtSensorCH10.setText(Integer.toString(mBytes[122] & 0xFF));
        edtSensorCH11.setText(Integer.toString(mBytes[123] & 0xFF));
        edtSensorCH12.setText(Integer.toString(mBytes[124] & 0xFF));
        edtSensorCH13.setText(Integer.toString(mBytes[125] & 0xFF));
        edtSensorCH14.setText(Integer.toString(mBytes[126] & 0xFF));
        edtSensorCH15.setText(Integer.toString(mBytes[127] & 0xFF));
        edtSensorCH16.setText(Integer.toString(mBytes[128] & 0xFF));
        edtSensorCH17.setText(Integer.toString(mBytes[129] & 0xFF));
        edtSensorCH18.setText(Integer.toString(mBytes[130] & 0xFF));
        edtSensorCH19.setText(Integer.toString(mBytes[131] & 0xFF));
        edtSensorCH20.setText(Integer.toString(mBytes[132] & 0xFF));
        edtSensorCH21.setText(Integer.toString(mBytes[133] & 0xFF));
        edtSensorCH22.setText(Integer.toString(mBytes[134] & 0xFF));
        edtSensorCH23.setText(Integer.toString(mBytes[135] & 0xFF));
        edtSensorCH24.setText(Integer.toString(mBytes[136] & 0xFF));
        edtSensorCH25.setText(Integer.toString(mBytes[137] & 0xFF));
        edtSensorCH26.setText(Integer.toString(mBytes[138] & 0xFF));
        edtSensorCH27.setText(Integer.toString(mBytes[139] & 0xFF));
        edtSensorCH28.setText(Integer.toString(mBytes[140] & 0xFF));
        edtSensorCH29.setText(Integer.toString(mBytes[141] & 0xFF));

        edtDriverCH0.setText(Integer.toString(mBytes[142] & 0xFF));
        edtDriverCH1.setText(Integer.toString(mBytes[143] & 0xFF));
        edtDriverCH2.setText(Integer.toString(mBytes[144] & 0xFF));
        edtDriverCH3.setText(Integer.toString(mBytes[145] & 0xFF));
        edtDriverCH4.setText(Integer.toString(mBytes[146] & 0xFF));
        edtDriverCH5.setText(Integer.toString(mBytes[147] & 0xFF));
        edtDriverCH6.setText(Integer.toString(mBytes[148] & 0xFF));
        edtDriverCH7.setText(Integer.toString(mBytes[149] & 0xFF));
        edtDriverCH8.setText(Integer.toString(mBytes[150] & 0xFF));
        edtDriverCH9.setText(Integer.toString(mBytes[151] & 0xFF));
        edtDriverCH10.setText(Integer.toString(mBytes[152] & 0xFF));
        edtDriverCH11.setText(Integer.toString(mBytes[153] & 0xFF));
        edtDriverCH12.setText(Integer.toString(mBytes[154] & 0xFF));
        edtDriverCH13.setText(Integer.toString(mBytes[155] & 0xFF));
        edtDriverCH14.setText(Integer.toString(mBytes[156] & 0xFF));
        edtDriverCH15.setText(Integer.toString(mBytes[157] & 0xFF));
        edtDriverCH16.setText(Integer.toString(mBytes[158] & 0xFF));
        edtDriverCH17.setText(Integer.toString(mBytes[159] & 0xFF));
        edtDriverCH18.setText(Integer.toString(mBytes[160] & 0xFF));
        edtDriverCH19.setText(Integer.toString(mBytes[161] & 0xFF));
        edtDriverCH20.setText(Integer.toString(mBytes[162] & 0xFF));
        edtDriverCH21.setText(Integer.toString(mBytes[163] & 0xFF));
        edtDriverCH22.setText(Integer.toString(mBytes[164] & 0xFF));
        edtDriverCH23.setText(Integer.toString(mBytes[165] & 0xFF));
        edtDriverCH24.setText(Integer.toString(mBytes[166] & 0xFF));
        edtDriverCH25.setText(Integer.toString(mBytes[167] & 0xFF));
        edtDriverCH26.setText(Integer.toString(mBytes[168] & 0xFF));
        edtDriverCH27.setText(Integer.toString(mBytes[169] & 0xFF));
        edtDriverCH28.setText(Integer.toString(mBytes[170] & 0xFF));
        edtDriverCH29.setText(Integer.toString(mBytes[171] & 0xFF));
        edtDriverCH30.setText(Integer.toString(mBytes[172] & 0xFF));
        edtDriverCH31.setText(Integer.toString(mBytes[173] & 0xFF));
        edtDriverCH32.setText(Integer.toString(mBytes[174] & 0xFF));
        edtDriverCH33.setText(Integer.toString(mBytes[175] & 0xFF));
        edtDriverCH34.setText(Integer.toString(mBytes[176] & 0xFF));
        edtDriverCH35.setText(Integer.toString(mBytes[177] & 0xFF));
        edtDriverCH36.setText(Integer.toString(mBytes[178] & 0xFF));
        edtDriverCH37.setText(Integer.toString(mBytes[179] & 0xFF));
        edtDriverCH38.setText(Integer.toString(mBytes[180] & 0xFF));
        edtDriverCH39.setText(Integer.toString(mBytes[181] & 0xFF));
        edtDriverCH40.setText(Integer.toString(mBytes[182] & 0xFF));
        edtDriverCH41.setText(Integer.toString(mBytes[183] & 0xFF));
    }

    public void ReadCfgPenSetting(byte[] mBytes){
        cbPenEn.setChecked(false);
        if ((mBytes[7] & 0x02) == 2){
            cbPenEn.setChecked(true);
        }
        cbOnlyFingerEn.setChecked(false);
        if ((mBytes[7] & 0x08) == 8){
            cbOnlyFingerEn.setChecked(true);
        }
        edtPenLowSize.setText(Integer.toString(mBytes[40] & 0xFF));
        edtPenHighSize.setText(Integer.toString(mBytes[41] & 0xFF));
        edtRectsumPLowL.setText(Integer.toString(mBytes[42] & 0xFF));
        edtRectsumPHighL.setText(Integer.toString(mBytes[43] & 0xFF));
        edtRectsumFLowL.setText(Integer.toString(mBytes[44] & 0xFF));
        edtPRectMaxDiffLimit.setText(Integer.toString(mBytes[45] & 0xFF));
        edtPRectAreaLimit.setText(Integer.toString(mBytes[46] & 0xFF));
        spinFingerRestrainPen.setSelection((mBytes[104] & 0xC0) >> 6);
        edtFLeavelevel.setText(Integer.toString(mBytes[108] & 0xFF));
        edtPTouchHighlevel.setText(Integer.toString(mBytes[111] & 0xFF));
    }

    public void ReadCfgPlamRestrain(byte[] mBytes){
        cbAllPlamRestrain.setChecked(false);
        if ((mBytes[6] & 0x40) == 0x40){
            cbAllPlamRestrain.setChecked(true);
        }

        edtLargeTouch.setText(Integer.toString(mBytes[10] & 0xFF));
        edtExpanNumOutX.setText(Integer.toString((mBytes[34] & 0xF0) >> 4));
        edtExpanNumOutY.setText(Integer.toString(mBytes[34] & 0x0F));
        edtExpanNumInX.setText(Integer.toString((mBytes[35] & 0xF0) >> 4));
        edtExpanNumInY.setText(Integer.toString(mBytes[35] & 0x0F));
        edtSingleRectTopSignNum.setText(Integer.toString(mBytes[47] & 0xFF));
        edtAllRectTopSignSum.setText(Integer.toString(mBytes[48] & 0xFF));

        cbWaterLargeRestrainEn.setChecked(false);
        if ((mBytes[91] & 0x02) == 0x02){
            cbWaterLargeRestrainEn.setChecked(true);
        }
    }

    public void ReadCfgHoppingSetting(byte[] mBytes){
        edtFreqStart.setText(Integer.toString(mBytes[51] & 0xFF));
        edtFreqEnd.setText(Integer.toString(mBytes[52] & 0xFF));
        edtDetectStayTimes.setText(Integer.toString((mBytes[53] & 0xC0) >> 6));
        edtDetectConfirmTimes.setText(Integer.toString(mBytes[53] & 0x3F));

        cbHoppingEn.setChecked(false);
        if ((mBytes[54] & 0x80) == 0x80){
            cbHoppingEn.setChecked(true);
        }
        cbRangeExt.setChecked(false);
        if ((mBytes[54] & 0x40) == 0x40){
            cbRangeExt.setChecked(true);
        }
        cbDisForceRef.setChecked(false);
        if ((mBytes[54] & 0x20) == 0x20){
            cbDisForceRef.setChecked(true);
        }
        cbDelayHopping.setChecked(false);
        if ((mBytes[54] & 0x10) == 0x10){
            cbDelayHopping.setChecked(true);
        }
        edtFastHopLimit.setText(Integer.toString((mBytes[55] & 0xF0) >> 4));
        edtHopThreshold.setText(Integer.toString(mBytes[55] & 0x0F));
        edtNoiseMinTh.setText(Integer.toString(mBytes[57] & 0xFF));
        edtSensorGroup.setText(Integer.toString(mBytes[59] & 0xFF));
        edtSeg1Normalize.setText(Integer.toString(mBytes[60] & 0xFF));
        edtSeg1Factor.setText(Integer.toString(mBytes[61] & 0xFF));
        edtMainClockAjdust.setText(Integer.toString(mBytes[62] & 0xFF));
        edtSeg2Normalize.setText(Integer.toString(mBytes[63] & 0xFF));
        edtSeg2Factor.setText(Integer.toString(mBytes[64] & 0xFF));
        edtSeg3Normalize.setText(Integer.toString(mBytes[66] & 0xFF));
        edtSeg3Factor.setText(Integer.toString(mBytes[67] & 0xFF));
        edtSeg4Normalize.setText(Integer.toString(mBytes[69] & 0xFF));
        edtSeg4Factor.setText(Integer.toString(mBytes[70] & 0xFF));
        edtSeg5Normalize.setText(Integer.toString(mBytes[72] & 0xFF));
        edtSeg5Factor.setText(Integer.toString(mBytes[73] & 0xFF));
        edtSeg6Normalize.setText(Integer.toString(mBytes[75] & 0xFF));
        //edtHopFreqAddr.setText("C6E6");
        edtHopDetectTimes.setText(Integer.toString((mBytes[105] & 0xE0) >> 5));
    }

    public void ReadCfgRam(String[] mConfigShow){
        int showid = 0;

        mCfg8050.setText(mConfigShow[showid++]);
        mCfg8051.setText(mConfigShow[showid++]);
        mCfg8052.setText(mConfigShow[showid++]);
        mCfg8053.setText(mConfigShow[showid++]);
        mCfg8054.setText(mConfigShow[showid++]);
        mCfg8055.setText(mConfigShow[showid++]);
        mCfg8056.setText(mConfigShow[showid++]);
        mCfg8057.setText(mConfigShow[showid++]);
        mCfg8058.setText(mConfigShow[showid++]);
        mCfg8059.setText(mConfigShow[showid++]);
        mCfg805A.setText(mConfigShow[showid++]);
        mCfg805B.setText(mConfigShow[showid++]);
        mCfg805C.setText(mConfigShow[showid++]);
        mCfg805D.setText(mConfigShow[showid++]);
        mCfg805E.setText(mConfigShow[showid++]);
        mCfg805F.setText(mConfigShow[showid++]);

        mCfg8060.setText(mConfigShow[showid++]);
        mCfg8061.setText(mConfigShow[showid++]);
        mCfg8062.setText(mConfigShow[showid++]);
        mCfg8063.setText(mConfigShow[showid++]);
        mCfg8064.setText(mConfigShow[showid++]);
        mCfg8065.setText(mConfigShow[showid++]);
        mCfg8066.setText(mConfigShow[showid++]);
        mCfg8067.setText(mConfigShow[showid++]);
        mCfg8068.setText(mConfigShow[showid++]);
        mCfg8069.setText(mConfigShow[showid++]);
        mCfg806A.setText(mConfigShow[showid++]);
        mCfg806B.setText(mConfigShow[showid++]);
        mCfg806C.setText(mConfigShow[showid++]);
        mCfg806D.setText(mConfigShow[showid++]);
        mCfg806E.setText(mConfigShow[showid++]);
        mCfg806F.setText(mConfigShow[showid++]);

        mCfg8070.setText(mConfigShow[showid++]);
        mCfg8071.setText(mConfigShow[showid++]);
        mCfg8072.setText(mConfigShow[showid++]);
        mCfg8073.setText(mConfigShow[showid++]);
        mCfg8074.setText(mConfigShow[showid++]);
        mCfg8075.setText(mConfigShow[showid++]);
        mCfg8076.setText(mConfigShow[showid++]);
        mCfg8077.setText(mConfigShow[showid++]);
        mCfg8078.setText(mConfigShow[showid++]);
        mCfg8079.setText(mConfigShow[showid++]);
        mCfg807A.setText(mConfigShow[showid++]);
        mCfg807B.setText(mConfigShow[showid++]);
        mCfg807C.setText(mConfigShow[showid++]);
        mCfg807D.setText(mConfigShow[showid++]);
        mCfg807E.setText(mConfigShow[showid++]);
        mCfg807F.setText(mConfigShow[showid++]);

        mCfg8080.setText(mConfigShow[showid++]);
        mCfg8081.setText(mConfigShow[showid++]);
        mCfg8082.setText(mConfigShow[showid++]);
        mCfg8083.setText(mConfigShow[showid++]);
        mCfg8084.setText(mConfigShow[showid++]);
        mCfg8085.setText(mConfigShow[showid++]);
        mCfg8086.setText(mConfigShow[showid++]);
        mCfg8087.setText(mConfigShow[showid++]);
        mCfg8088.setText(mConfigShow[showid++]);
        mCfg8089.setText(mConfigShow[showid++]);
        mCfg808A.setText(mConfigShow[showid++]);
        mCfg808B.setText(mConfigShow[showid++]);
        mCfg808C.setText(mConfigShow[showid++]);
        mCfg808D.setText(mConfigShow[showid++]);
        mCfg808E.setText(mConfigShow[showid++]);
        mCfg808F.setText(mConfigShow[showid++]);

        mCfg8090.setText(mConfigShow[showid++]);
        mCfg8091.setText(mConfigShow[showid++]);
        mCfg8092.setText(mConfigShow[showid++]);
        mCfg8093.setText(mConfigShow[showid++]);
        mCfg8094.setText(mConfigShow[showid++]);
        mCfg8095.setText(mConfigShow[showid++]);
        mCfg8096.setText(mConfigShow[showid++]);
        mCfg8097.setText(mConfigShow[showid++]);
        mCfg8098.setText(mConfigShow[showid++]);
        mCfg8099.setText(mConfigShow[showid++]);
        mCfg809A.setText(mConfigShow[showid++]);
        mCfg809B.setText(mConfigShow[showid++]);
        mCfg809C.setText(mConfigShow[showid++]);
        mCfg809D.setText(mConfigShow[showid++]);
        mCfg809E.setText(mConfigShow[showid++]);
        mCfg809F.setText(mConfigShow[showid++]);

        mCfg80A0.setText(mConfigShow[showid++]);
        mCfg80A1.setText(mConfigShow[showid++]);
        mCfg80A2.setText(mConfigShow[showid++]);
        mCfg80A3.setText(mConfigShow[showid++]);
        mCfg80A4.setText(mConfigShow[showid++]);
        mCfg80A5.setText(mConfigShow[showid++]);
        mCfg80A6.setText(mConfigShow[showid++]);
        mCfg80A7.setText(mConfigShow[showid++]);
        mCfg80A8.setText(mConfigShow[showid++]);
        mCfg80A9.setText(mConfigShow[showid++]);
        mCfg80AA.setText(mConfigShow[showid++]);
        mCfg80AB.setText(mConfigShow[showid++]);
        mCfg80AC.setText(mConfigShow[showid++]);
        mCfg80AD.setText(mConfigShow[showid++]);
        mCfg80AE.setText(mConfigShow[showid++]);
        mCfg80AF.setText(mConfigShow[showid++]);

        mCfg80B0.setText(mConfigShow[showid++]);
        mCfg80B1.setText(mConfigShow[showid++]);
        mCfg80B2.setText(mConfigShow[showid++]);
        mCfg80B3.setText(mConfigShow[showid++]);
        mCfg80B4.setText(mConfigShow[showid++]);
        mCfg80B5.setText(mConfigShow[showid++]);
        mCfg80B6.setText(mConfigShow[showid++]);
        mCfg80B7.setText(mConfigShow[showid++]);
        mCfg80B8.setText(mConfigShow[showid++]);
        mCfg80B9.setText(mConfigShow[showid++]);
        mCfg80BA.setText(mConfigShow[showid++]);
        mCfg80BB.setText(mConfigShow[showid++]);
        mCfg80BC.setText(mConfigShow[showid++]);
        mCfg80BD.setText(mConfigShow[showid++]);
        mCfg80BE.setText(mConfigShow[showid++]);
        mCfg80BF.setText(mConfigShow[showid++]);

        mCfg80C0.setText(mConfigShow[showid++]);
        mCfg80C1.setText(mConfigShow[showid++]);
        mCfg80C2.setText(mConfigShow[showid++]);
        mCfg80C3.setText(mConfigShow[showid++]);
        mCfg80C4.setText(mConfigShow[showid++]);
        mCfg80C5.setText(mConfigShow[showid++]);
        mCfg80C6.setText(mConfigShow[showid++]);
        mCfg80C7.setText(mConfigShow[showid++]);
        mCfg80C8.setText(mConfigShow[showid++]);
        mCfg80C9.setText(mConfigShow[showid++]);
        mCfg80CA.setText(mConfigShow[showid++]);
        mCfg80CB.setText(mConfigShow[showid++]);
        mCfg80CC.setText(mConfigShow[showid++]);
        mCfg80CD.setText(mConfigShow[showid++]);
        mCfg80CE.setText(mConfigShow[showid++]);
        mCfg80CF.setText(mConfigShow[showid++]);

        mCfg80D0.setText(mConfigShow[showid++]);
        mCfg80D1.setText(mConfigShow[showid++]);
        mCfg80D2.setText(mConfigShow[showid++]);
        mCfg80D3.setText(mConfigShow[showid++]);
        mCfg80D4.setText(mConfigShow[showid++]);
        mCfg80D5.setText(mConfigShow[showid++]);
        mCfg80D6.setText(mConfigShow[showid++]);
        mCfg80D7.setText(mConfigShow[showid++]);
        mCfg80D8.setText(mConfigShow[showid++]);
        mCfg80D9.setText(mConfigShow[showid++]);
        mCfg80DA.setText(mConfigShow[showid++]);
        mCfg80DB.setText(mConfigShow[showid++]);
        mCfg80DC.setText(mConfigShow[showid++]);
        mCfg80DD.setText(mConfigShow[showid++]);
        mCfg80DE.setText(mConfigShow[showid++]);
        mCfg80DF.setText(mConfigShow[showid++]);

        mCfg80E0.setText(mConfigShow[showid++]);
        mCfg80E1.setText(mConfigShow[showid++]);
        mCfg80E2.setText(mConfigShow[showid++]);
        mCfg80E3.setText(mConfigShow[showid++]);
        mCfg80E4.setText(mConfigShow[showid++]);
        mCfg80E5.setText(mConfigShow[showid++]);
        mCfg80E6.setText(mConfigShow[showid++]);
        mCfg80E7.setText(mConfigShow[showid++]);
        mCfg80E8.setText(mConfigShow[showid++]);
        mCfg80E9.setText(mConfigShow[showid++]);
        mCfg80EA.setText(mConfigShow[showid++]);
        mCfg80EB.setText(mConfigShow[showid++]);
        mCfg80EC.setText(mConfigShow[showid++]);
        mCfg80ED.setText(mConfigShow[showid++]);
        mCfg80EE.setText(mConfigShow[showid++]);
        mCfg80EF.setText(mConfigShow[showid++]);

        mCfg80F0.setText(mConfigShow[showid++]);
        mCfg80F1.setText(mConfigShow[showid++]);
        mCfg80F2.setText(mConfigShow[showid++]);
        mCfg80F3.setText(mConfigShow[showid++]);
        mCfg80F4.setText(mConfigShow[showid++]);
        mCfg80F5.setText(mConfigShow[showid++]);
        mCfg80F6.setText(mConfigShow[showid++]);
        mCfg80F7.setText(mConfigShow[showid++]);
        mCfg80F8.setText(mConfigShow[showid++]);
        mCfg80F9.setText(mConfigShow[showid++]);
        mCfg80FA.setText(mConfigShow[showid++]);
        mCfg80FB.setText(mConfigShow[showid++]);
        mCfg80FC.setText(mConfigShow[showid++]);
        mCfg80FD.setText(mConfigShow[showid++]);
        mCfg80FE.setText(mConfigShow[showid++]);
        mCfg80FF.setText(mConfigShow[showid++]);

        mCfg8100.setText(mConfigShow[showid++]);
        mCfg8101.setText(mConfigShow[showid++]);
        mCfg8102.setText(mConfigShow[showid++]);
        mCfg8103.setText(mConfigShow[showid++]);
        mCfg8104.setText(mConfigShow[showid++]);
        mCfg8105.setText(mConfigShow[showid++]);
        mCfg8106.setText(mConfigShow[showid++]);
        mCfg8107.setText(mConfigShow[showid++]);
        mCfg8108.setText(mConfigShow[showid++]);
        mCfg8109.setText(mConfigShow[showid++]);
        mCfg810A.setText(mConfigShow[showid++]);
        mCfg810B.setText(mConfigShow[showid++]);
        mCfg810C.setText(mConfigShow[showid++]);
        mCfg810D.setText(mConfigShow[showid++]);
        mCfg810E.setText(mConfigShow[showid++]);
        mCfg810F.setText(mConfigShow[showid++]);

        mCfg8110.setText(mConfigShow[showid++]);
        mCfg8111.setText(mConfigShow[showid++]);
        mCfg8112.setText(mConfigShow[showid++]);
        mCfg8113.setText(mConfigShow[showid++]);
        mCfg8114.setText(mConfigShow[showid++]);
        mCfg8115.setText(mConfigShow[showid++]);
        mCfg8116.setText(mConfigShow[showid++]);
        mCfg8117.setText(mConfigShow[showid++]);
        mCfg8118.setText(mConfigShow[showid++]);
        mCfg8119.setText(mConfigShow[showid++]);
        mCfg811A.setText(mConfigShow[showid++]);
        mCfg811B.setText(mConfigShow[showid++]);
        mCfg811C.setText(mConfigShow[showid++]);
        mCfg811D.setText(mConfigShow[showid++]);
        mCfg811E.setText(mConfigShow[showid++]);
        mCfg811F.setText(mConfigShow[showid++]);

        mCfg8120.setText(mConfigShow[showid++]);
        mCfg8121.setText(mConfigShow[showid++]);
        mCfg8122.setText(mConfigShow[showid++]);
        mCfg8123.setText(mConfigShow[showid++]);
        mCfg8124.setText(mConfigShow[showid++]);
        mCfg8125.setText(mConfigShow[showid++]);
        mCfg8126.setText(mConfigShow[showid++]);
        mCfg8127.setText(mConfigShow[showid++]);
        mCfg8128.setText(mConfigShow[showid++]);
        mCfg8129.setText(mConfigShow[showid++]);
        mCfg812A.setText(mConfigShow[showid++]);
        mCfg812B.setText(mConfigShow[showid++]);
        mCfg812C.setText(mConfigShow[showid++]);
        mCfg812D.setText(mConfigShow[showid++]);
        mCfg812E.setText(mConfigShow[showid++]);
        mCfg812F.setText(mConfigShow[showid++]);

        mCfg8130.setText(mConfigShow[showid++]);
        mCfg8131.setText(mConfigShow[showid++]);
        mCfg8132.setText(mConfigShow[showid++]);
        mCfg8133.setText(mConfigShow[showid++]);
        mCfg8134.setText(mConfigShow[showid++]);
        mCfg8135.setText(mConfigShow[showid++]);
        mCfg8136.setText(mConfigShow[showid++]);
        mCfg8137.setText(mConfigShow[showid++]);
        mCfg8138.setText(mConfigShow[showid++]);
        mCfg8139.setText(mConfigShow[showid++]);
        mCfg813A.setText(mConfigShow[showid++]);
        mCfg813B.setText(mConfigShow[showid++]);
        mCfg813C.setText(mConfigShow[showid++]);
        mCfg813D.setText(mConfigShow[showid++]);
        mCfg813E.setText(mConfigShow[showid++]);
        //mCfg813F.setText(mConfigShow[showid++]);

        mCfgBF7B.setText(mConfigShow[showid++]);
        mCfgBF7C.setText(mConfigShow[showid++]);
        mCfgBF7D.setText(mConfigShow[showid++]);
        mCfgBF7E.setText(mConfigShow[showid++]);
        mCfgBF7F.setText(mConfigShow[showid++]);

        mCfgBF80.setText(mConfigShow[showid++]);
        mCfgBF81.setText(mConfigShow[showid++]);
        mCfgBF82.setText(mConfigShow[showid++]);
        mCfgBF83.setText(mConfigShow[showid++]);
        mCfgBF84.setText(mConfigShow[showid++]);
        mCfgBF85.setText(mConfigShow[showid++]);
        mCfgBF86.setText(mConfigShow[showid++]);
        mCfgBF87.setText(mConfigShow[showid++]);
        mCfgBF88.setText(mConfigShow[showid++]);
        mCfgBF89.setText(mConfigShow[showid++]);
        mCfgBF8A.setText(mConfigShow[showid++]);
        mCfgBF8B.setText(mConfigShow[showid++]);
        mCfgBF8C.setText(mConfigShow[showid++]);
        mCfgBF8D.setText(mConfigShow[showid++]);
        mCfgBF8E.setText(mConfigShow[showid++]);
        mCfgBF8F.setText(mConfigShow[showid++]);

        mCfgBF90.setText(mConfigShow[showid++]);
        mCfgBF91.setText(mConfigShow[showid++]);
        mCfgBF92.setText(mConfigShow[showid++]);
        mCfgBF93.setText(mConfigShow[showid++]);
        mCfgBF94.setText(mConfigShow[showid++]);
        mCfgBF95.setText(mConfigShow[showid++]);
        mCfgBF96.setText(mConfigShow[showid++]);
        mCfgBF97.setText(mConfigShow[showid++]);
        mCfgBF98.setText(mConfigShow[showid++]);
        mCfgBF99.setText(mConfigShow[showid++]);
        mCfgBF9A.setText(mConfigShow[showid++]);
        mCfgBF9B.setText(mConfigShow[showid++]);
        mCfgBF9C.setText(mConfigShow[showid++]);
        mCfgBF9D.setText(mConfigShow[showid++]);
        mCfgBF9E.setText(mConfigShow[showid++]);
        mCfgBF9F.setText(mConfigShow[showid++]);

        mCfgBFA0.setText(mConfigShow[showid++]);
        mCfgBFA1.setText(mConfigShow[showid++]);
        mCfgBFA2.setText(mConfigShow[showid++]);
        mCfgBFA3.setText(mConfigShow[showid++]);
        mCfgBFA4.setText(mConfigShow[showid++]);
        mCfgBFA5.setText(mConfigShow[showid++]);
        mCfgBFA6.setText(mConfigShow[showid++]);
        mCfgBFA7.setText(mConfigShow[showid++]);
        mCfgBFA8.setText(mConfigShow[showid++]);
        mCfgBFA9.setText(mConfigShow[showid++]);
        mCfgBFAA.setText(mConfigShow[showid++]);
        mCfgBFAB.setText(mConfigShow[showid++]);
        mCfgBFAC.setText(mConfigShow[showid++]);
        mCfgBFAD.setText(mConfigShow[showid++]);
        mCfgBFAE.setText(mConfigShow[showid++]);
        mCfgBFAF.setText(mConfigShow[showid++]);

        mCfgBFB0.setText(mConfigShow[showid++]);
        mCfgBFB1.setText(mConfigShow[showid++]);
        mCfgBFB2.setText(mConfigShow[showid++]);
        mCfgBFB3.setText(mConfigShow[showid++]);
        mCfgBFB4.setText(mConfigShow[showid++]);
        mCfgBFB5.setText(mConfigShow[showid++]);
        mCfgBFB6.setText(mConfigShow[showid++]);
        mCfgBFB7.setText(mConfigShow[showid++]);
        mCfgBFB8.setText(mConfigShow[showid++]);
        mCfgBFB9.setText(mConfigShow[showid++]);
        mCfgBFBA.setText(mConfigShow[showid++]);
        mCfgBFBB.setText(mConfigShow[showid++]);
        mCfgBFBC.setText(mConfigShow[showid++]);
        mCfgBFBD.setText(mConfigShow[showid++]);
        mCfgBFBE.setText(mConfigShow[showid++]);
        mCfgBFBF.setText(mConfigShow[showid++]);

        mCfgBFC0.setText(mConfigShow[showid++]);
        mCfgBFC1.setText(mConfigShow[showid++]);
        mCfgBFC2.setText(mConfigShow[showid++]);
        mCfgBFC3.setText(mConfigShow[showid++]);
        mCfgBFC4.setText(mConfigShow[showid++]);
        mCfgBFC5.setText(mConfigShow[showid++]);
        mCfgBFC6.setText(mConfigShow[showid++]);
        mCfgBFC7.setText(mConfigShow[showid++]);
        mCfgBFC8.setText(mConfigShow[showid++]);
        mCfgBFC9.setText(mConfigShow[showid++]);
        mCfgBFCA.setText(mConfigShow[showid++]);
        mCfgBFCB.setText(mConfigShow[showid++]);
        mCfgBFCC.setText(mConfigShow[showid++]);
        mCfgBFCD.setText(mConfigShow[showid++]);
        mCfgBFCE.setText(mConfigShow[showid++]);
        mCfgBFCF.setText(mConfigShow[showid++]);

        mCfgBFD0.setText(mConfigShow[showid++]);
        mCfgBFD1.setText(mConfigShow[showid++]);
        mCfgBFD2.setText(mConfigShow[showid++]);
        mCfgBFD3.setText(mConfigShow[showid++]);
        mCfgBFD4.setText(mConfigShow[showid++]);
        mCfgBFD5.setText(mConfigShow[showid++]);
        mCfgBFD6.setText(mConfigShow[showid++]);
        mCfgBFD7.setText(mConfigShow[showid++]);
        mCfgBFD8.setText(mConfigShow[showid++]);
        mCfgBFD9.setText(mConfigShow[showid++]);
        mCfgBFDA.setText(mConfigShow[showid++]);
        mCfgBFDB.setText(mConfigShow[showid++]);
        mCfgBFDC.setText(mConfigShow[showid++]);
        mCfgBFDD.setText(mConfigShow[showid++]);
        mCfgBFDE.setText(mConfigShow[showid++]);
        mCfgBFDF.setText(mConfigShow[showid++]);

        mCfgBFE0.setText(mConfigShow[showid++]);
        mCfgBFE1.setText(mConfigShow[showid++]);
        mCfgBFE2.setText(mConfigShow[showid++]);
        mCfgBFE3.setText(mConfigShow[showid++]);
        mCfgBFE4.setText(mConfigShow[showid++]);
        mCfgBFE5.setText(mConfigShow[showid++]);
        mCfgBFE6.setText(mConfigShow[showid++]);
        mCfgBFE7.setText(mConfigShow[showid++]);
        mCfgBFE8.setText(mConfigShow[showid++]);
        mCfgBFE9.setText(mConfigShow[showid++]);
        mCfgBFEA.setText(mConfigShow[showid++]);
        mCfgBFEB.setText(mConfigShow[showid++]);
        mCfgBFEC.setText(mConfigShow[showid++]);
        mCfgBFED.setText(mConfigShow[showid++]);
        mCfgBFEE.setText(mConfigShow[showid++]);
        mCfgBFEF.setText(mConfigShow[showid++]);

        mCfgBFF0.setText(mConfigShow[showid++]);
        mCfgBFF1.setText(mConfigShow[showid++]);
        mCfgBFF2.setText(mConfigShow[showid++]);
        mCfgBFF3.setText(mConfigShow[showid++]);
        mCfgBFF4.setText(mConfigShow[showid++]);
        mCfgBFF5.setText(mConfigShow[showid++]);
        mCfgBFF6.setText(mConfigShow[showid++]);
        mCfgBFF7.setText(mConfigShow[showid++]);
        mCfgBFF8.setText(mConfigShow[showid++]);
        mCfgBFF9.setText(mConfigShow[showid++]);
        mCfgBFFA.setText(mConfigShow[showid++]);
    }
    //=====================================读取CFG到各个View结束===================================//

    //======================================合并配置开始===========================================//
    public void CombineCfg(){

        for (int i = 0; i < 186; i++){
            mBytes[i] = 0;
        }

        mBytes[0] = (byte)Integer.parseInt(edtConfigVersion.getText().toString(),10);
        mBytes[1] = (byte)(Integer.parseInt(edtXOutputMax.getText().toString(),10) & 0x00ff);
        mBytes[2] = (byte)(Integer.parseInt(edtXOutputMax.getText().toString(),10) >> 8);
        mBytes[3] = (byte)(Integer.parseInt(edtYOutputMax.getText().toString(),10) & 0x00ff);
        mBytes[4] = (byte)(Integer.parseInt(edtYOutputMax.getText().toString(),10) >> 8);
        mBytes[5] = (byte)(Integer.parseInt(edtTouchNumber.getText().toString(),10) & 0x0f);
        //mBytes[6]
        mBytes[6] = (byte)spinInterrupt.getSelectedItemPosition();
        if (cbSito.isChecked()){
            mBytes[6] += 4;
        }
        if (cbX2Y.isChecked()){
            mBytes[6] += 8;
        }
        mBytes[6] += (byte)(spinStretchRank.getSelectedItemPosition() * 16);
        if (cbAllPlamRestrain.isChecked()){
            mBytes[6] += 64;
        }


        if (cbPenEn.isChecked()){
            mBytes[7] += 2;
        }
        if (cbDiffDivideBy2or4.isChecked()){
            mBytes[7] += 4;
        }
        if (cbOnlyFingerEn.isChecked()){
            mBytes[7] += 8;
        }
        if (cbFirstFilterDis.isChecked()){
            mBytes[7] += 32;
        }
        if (cbMonitorConsistencyConflictEn.isChecked()){
            mBytes[7] += 64;
        }
        mBytes[8] = (byte)Integer.parseInt(edtShakeCnt.getText().toString(),16);
        mBytes[9] = (byte)(Integer.parseInt(edtNormalFilter.getText().toString(),10) +
                Integer.parseInt(edtFirstFilter.getText().toString(),10) * 64);
        mBytes[10] = (byte)Integer.parseInt(edtLargeTouch.getText().toString(),10);
        mBytes[11] = (byte)(Integer.parseInt(edtNoiseReduction.getText().toString(),10) & 0x0f);
        mBytes[12] = (byte)Integer.parseInt(edtScreenTouchLv.getText().toString(),10);
        mBytes[13] = (byte)Integer.parseInt(edtScreenLeaveLv.getText().toString(),10);
        mBytes[14] = (byte)(Integer.parseInt(edtLowPowerControl.getText().toString(),10) & 0x0f);
        mBytes[15] = (byte)(spinRefreshRate.getSelectedItemPosition());
        mBytes[16] = (byte)Integer.parseInt(edtXThreshold.getText().toString(),10);
        mBytes[17] = (byte)Integer.parseInt(edtYThreshold.getText().toString(),10);
        //mBytes[18]
        //mBytes[19]
        mBytes[20] = (byte)Integer.parseInt(edtSpaceUpDown.getText().toString(),16);
        mBytes[21] = (byte)Integer.parseInt(edtSpaceLeftRight.getText().toString(),16);
        mBytes[22] = (byte)(Integer.parseInt(edtMiniFilter.getText().toString(),10) & 0x0f);
        mBytes[23] = (byte)Integer.parseInt(edtStretchR0.getText().toString(),10);
        mBytes[24] = (byte)Integer.parseInt(edtStretchR1.getText().toString(),10);
        mBytes[25] = (byte)Integer.parseInt(edtStretchR2.getText().toString(),10);
        mBytes[26] = (byte)Integer.parseInt(edtStretchRM.getText().toString(),10);
        //mBytes[27]
        mBytes[27] = (byte)Integer.parseInt(edtDrvGroupAnumber.getText().toString(),10);
        if (cbAllDrivingEn.isChecked()){
            mBytes[27] += 128;
        }
        //mBytes[28]
        mBytes[28] = (byte)Integer.parseInt(edtDrvGroupBnumber.getText().toString(),10);
        if (cbDualFreq.isChecked()){
            mBytes[28] += 32;
        }
        mBytes[29] = (byte)(Integer.parseInt(edtSenGroupANumber.getText().toString(),10) +
                Integer.parseInt(edtSenGroupBNumber.getText().toString(),10) * 16);
        mBytes[30] = (byte)Integer.parseInt(edtFreqAFactor.getText().toString(),10);
        mBytes[31] = (byte)Integer.parseInt(edtFreqBFactor.getText().toString(),10);
        mBytes[32] = (byte)(Integer.parseInt(edtPannelBitFreq.getText().toString(),10) & 0x00ff);
        mBytes[33] = (byte)(Integer.parseInt(edtPannelBitFreq.getText().toString(),10) >> 8);
        mBytes[34] = (byte)((Integer.parseInt(edtExpanNumOutY.getText().toString(),10) & 0x0f) +
                Integer.parseInt(edtExpanNumOutX.getText().toString(),10) * 16);
        mBytes[35] = (byte)((Integer.parseInt(edtExpanNumInY.getText().toString(),10) & 0x0f) +
                Integer.parseInt(edtExpanNumInX.getText().toString(),10) * 16);
        mBytes[36] = (byte)(spinDACGain.getSelectedItemPosition() +
                spinDrvOutputR.getSelectedItemPosition() * 8);
        mBytes[37] = (byte)(spinPGAGain.getSelectedItemPosition() +
                spinRxVcmi.getSelectedItemPosition() * 8 +
                spinPGAR.getSelectedItemPosition() * 32 +
                spinPGAC.getSelectedItemPosition() * 128);
        mBytes[38] = (byte)(Integer.parseInt(edtDumpShift.getText().toString(),10) & 0x0f);
        mBytes[39] = (byte)(Integer.parseInt(edtSubFrameDrvNum.getText().toString(),10) << 2);
        mBytes[40] = (byte)Integer.parseInt(edtPenLowSize.getText().toString(),10);
        mBytes[41] = (byte)Integer.parseInt(edtPenHighSize.getText().toString(),10);
        mBytes[42] = (byte)Integer.parseInt(edtRectsumPLowL.getText().toString(),10);
        mBytes[43] = (byte)Integer.parseInt(edtRectsumPHighL.getText().toString(),10);
        mBytes[44] = (byte)Integer.parseInt(edtRectsumFLowL.getText().toString(),10);
        mBytes[45] = (byte)Integer.parseInt(edtPRectMaxDiffLimit.getText().toString(),10);
        mBytes[46] = (byte)Integer.parseInt(edtPRectAreaLimit.getText().toString(),10);
        mBytes[47] = (byte)Integer.parseInt(edtSingleRectTopSignNum.getText().toString(),10);
        mBytes[48] = (byte)Integer.parseInt(edtAllRectTopSignSum.getText().toString(),10);
        mBytes[49] = (byte)Integer.parseInt(edtChargingLevelUp.getText().toString(),10);
        //mBytes[50]
        mBytes[51] = (byte)Integer.parseInt(edtFreqStart.getText().toString(),10);
        mBytes[52] = (byte)Integer.parseInt(edtFreqEnd.getText().toString(),10);
        mBytes[53] = (byte)(Integer.parseInt(edtDetectConfirmTimes.getText().toString(),10) +
                Integer.parseInt(edtDetectStayTimes.getText().toString(),10) * 64);
        //mBytes[54]
        if (cbDelayHopping.isChecked()){
            mBytes[54] = 16;
        }
        if (cbDisForceRef.isChecked()){
            mBytes[54] += 32;
        }
        if (cbRangeExt.isChecked()){
            mBytes[54] += 64;
        }
        if (cbHoppingEn.isChecked()){
            mBytes[54] += 128;
        }
        mBytes[55] = (byte)(Integer.parseInt(edtHopThreshold.getText().toString(),10) +
                Integer.parseInt(edtFastHopLimit.getText().toString(),10) * 16);
        //mBytes[56]
        mBytes[57] = (byte)Integer.parseInt(edtNoiseMinTh.getText().toString(),10);
        mBytes[58] = (byte)Integer.parseInt(edtLcdPlusMinusValue.getText().toString(),10);
        mBytes[59] = (byte)Integer.parseInt(edtSensorGroup.getText().toString(),10);
        mBytes[60] = (byte)Integer.parseInt(edtSeg1Normalize.getText().toString(),10);
        mBytes[61] = (byte)Integer.parseInt(edtSeg1Factor.getText().toString(),10);
        mBytes[62] = (byte)Integer.parseInt(edtMainClockAjdust.getText().toString(),10);
        mBytes[63] = (byte)Integer.parseInt(edtSeg2Normalize.getText().toString(),10);
        mBytes[64] = (byte)Integer.parseInt(edtSeg2Factor.getText().toString(),10);
        //mBytes[65]
        mBytes[66] = (byte)Integer.parseInt(edtSeg3Normalize.getText().toString(),10);
        mBytes[67] = (byte)Integer.parseInt(edtSeg3Factor.getText().toString(),10);
        //mBytes[68]
        mBytes[69] = (byte)Integer.parseInt(edtSeg4Normalize.getText().toString(),10);
        mBytes[70] = (byte)Integer.parseInt(edtSeg4Factor.getText().toString(),10);
        //mBytes[71]
        mBytes[72] = (byte)Integer.parseInt(edtSeg5Normalize.getText().toString(),10);
        mBytes[73] = (byte)Integer.parseInt(edtSeg5Factor.getText().toString(),10);
        //mBytes[74]
        mBytes[75] = (byte)Integer.parseInt(edtSeg6Normalize.getText().toString(),10);


        mBytes[87] = (byte)(Integer.parseInt(edtShapeRestrain.getText().toString(),10) & 0x7f);
        mBytes[88] = (byte)Integer.parseInt(edtConThreshold.getText().toString(),10);
        mBytes[89] = (byte)Integer.parseInt(edtWaterFrameTime.getText().toString(),10);
        mBytes[90] = (byte)Integer.parseInt(edtWaterUpdateTime.getText().toString(),10);
        //mBytes[91]
        if (cbWaterSpeedLimitEn.isChecked()){
            mBytes[91] = 1;
        }
        if (cbWaterLargeRestrainEn.isChecked()){
            mBytes[91] += 2;
        }
        if (cbShapeEn.isChecked()){
            mBytes[91] += 4;
        }
        if (cbWaterProofDis.isChecked()){
            mBytes[91] += 8;
        }
        if (cbLcdPlusMinusEn.isChecked()){
            mBytes[91] += 16;
        }
        //mBytes[92]
        mBytes[92] = (byte)(spinVoltage.getSelectedItemPosition() +
                spinBoostTime.getSelectedItemPosition() * 16);
        if (cbExtoscen.isChecked()){
            mBytes[93] = (byte)128;
        }
        mBytes[94] = (byte)spinAlterCount.getSelectedItemPosition();
        //mBytes[95]
        mBytes[96] = (byte)Integer.parseInt(edtSlideInEdgeConfig.getText().toString(),10);
        mBytes[97] = (byte)Integer.parseInt(edtSlideOutEdgeConfig.getText().toString(),10);
        //mBytes[98]
        //mBytes[99]
        //mBytes[100]
        //mBytes[101]
        //mBytes[102]
        //mBytes[103]
        //mBytes[104]
        if (cbX2X.isChecked()){
            mBytes[104] = 1;
        }
        if (cbY2Y.isChecked()){
            mBytes[104] += 2;
        }
        if (cbESDEn.isChecked()){
            mBytes[104] += 16;
        }
        if (cbINTWakeup.isChecked()){
            mBytes[104] += 32;
        }
        mBytes[104] += (byte)(spinFingerRestrainPen.getSelectedItemPosition() * 64);
        mBytes[105] = (byte)(Integer.parseInt(edtShapeContrl.getText().toString(),10) +
                Integer.parseInt(edtHopDetectTimes.getText().toString(),10) * 32);
        mBytes[106] = (byte)(Integer.parseInt(edtCombineDis.getText().toString(),16) & 0x0f);
        mBytes[107] = (byte)Integer.parseInt(edtSplitSet.getText().toString(),16);
        mBytes[108] = (byte)Integer.parseInt(edtFLeavelevel.getText().toString(),10);
        //mBytes[109]
        mBytes[110] = (byte)Integer.parseInt(edtSitoDiffRefLevel.getText().toString(),10);
        mBytes[111] = (byte)Integer.parseInt(edtPTouchHighlevel.getText().toString(),10);
        mBytes[112] = (byte)Integer.parseInt(edtSensorCH0.getText().toString(),10);
        mBytes[113] = (byte)Integer.parseInt(edtSensorCH1.getText().toString(),10);
        mBytes[114] = (byte)Integer.parseInt(edtSensorCH2.getText().toString(),10);
        mBytes[115] = (byte)Integer.parseInt(edtSensorCH3.getText().toString(),10);
        mBytes[116] = (byte)Integer.parseInt(edtSensorCH4.getText().toString(),10);
        mBytes[117] = (byte)Integer.parseInt(edtSensorCH5.getText().toString(),10);
        mBytes[118] = (byte)Integer.parseInt(edtSensorCH6.getText().toString(),10);
        mBytes[119] = (byte)Integer.parseInt(edtSensorCH7.getText().toString(),10);
        mBytes[120] = (byte)Integer.parseInt(edtSensorCH8.getText().toString(),10);
        mBytes[121] = (byte)Integer.parseInt(edtSensorCH9.getText().toString(),10);
        mBytes[122] = (byte)Integer.parseInt(edtSensorCH10.getText().toString(),10);
        mBytes[123] = (byte)Integer.parseInt(edtSensorCH11.getText().toString(),10);
        mBytes[124] = (byte)Integer.parseInt(edtSensorCH12.getText().toString(),10);
        mBytes[125] = (byte)Integer.parseInt(edtSensorCH13.getText().toString(),10);
        mBytes[126] = (byte)Integer.parseInt(edtSensorCH14.getText().toString(),10);
        mBytes[127] = (byte)Integer.parseInt(edtSensorCH15.getText().toString(),10);
        mBytes[128] = (byte)Integer.parseInt(edtSensorCH16.getText().toString(),10);
        mBytes[129] = (byte)Integer.parseInt(edtSensorCH17.getText().toString(),10);
        mBytes[130] = (byte)Integer.parseInt(edtSensorCH18.getText().toString(),10);
        mBytes[131] = (byte)Integer.parseInt(edtSensorCH19.getText().toString(),10);
        mBytes[132] = (byte)Integer.parseInt(edtSensorCH20.getText().toString(),10);
        mBytes[133] = (byte)Integer.parseInt(edtSensorCH21.getText().toString(),10);
        mBytes[134] = (byte)Integer.parseInt(edtSensorCH22.getText().toString(),10);
        mBytes[135] = (byte)Integer.parseInt(edtSensorCH23.getText().toString(),10);
        mBytes[136] = (byte)Integer.parseInt(edtSensorCH24.getText().toString(),10);
        mBytes[137] = (byte)Integer.parseInt(edtSensorCH25.getText().toString(),10);
        mBytes[138] = (byte)Integer.parseInt(edtSensorCH26.getText().toString(),10);
        mBytes[139] = (byte)Integer.parseInt(edtSensorCH27.getText().toString(),10);
        mBytes[140] = (byte)Integer.parseInt(edtSensorCH28.getText().toString(),10);
        mBytes[141] = (byte)Integer.parseInt(edtSensorCH29.getText().toString(),10);
        mBytes[142] = (byte)Integer.parseInt(edtDriverCH0.getText().toString(),10);
        mBytes[143] = (byte)Integer.parseInt(edtDriverCH1.getText().toString(),10);
        mBytes[144] = (byte)Integer.parseInt(edtDriverCH2.getText().toString(),10);
        mBytes[145] = (byte)Integer.parseInt(edtDriverCH3.getText().toString(),10);
        mBytes[146] = (byte)Integer.parseInt(edtDriverCH4.getText().toString(),10);
        mBytes[147] = (byte)Integer.parseInt(edtDriverCH5.getText().toString(),10);
        mBytes[148] = (byte)Integer.parseInt(edtDriverCH6.getText().toString(),10);
        mBytes[149] = (byte)Integer.parseInt(edtDriverCH7.getText().toString(),10);
        mBytes[150] = (byte)Integer.parseInt(edtDriverCH8.getText().toString(),10);
        mBytes[151] = (byte)Integer.parseInt(edtDriverCH9.getText().toString(),10);
        mBytes[152] = (byte)Integer.parseInt(edtDriverCH10.getText().toString(),10);
        mBytes[153] = (byte)Integer.parseInt(edtDriverCH11.getText().toString(),10);
        mBytes[154] = (byte)Integer.parseInt(edtDriverCH12.getText().toString(),10);
        mBytes[155] = (byte)Integer.parseInt(edtDriverCH13.getText().toString(),10);
        mBytes[156] = (byte)Integer.parseInt(edtDriverCH14.getText().toString(),10);
        mBytes[157] = (byte)Integer.parseInt(edtDriverCH15.getText().toString(),10);
        mBytes[158] = (byte)Integer.parseInt(edtDriverCH16.getText().toString(),10);
        mBytes[159] = (byte)Integer.parseInt(edtDriverCH17.getText().toString(),10);
        mBytes[160] = (byte)Integer.parseInt(edtDriverCH18.getText().toString(),10);
        mBytes[161] = (byte)Integer.parseInt(edtDriverCH19.getText().toString(),10);
        mBytes[162] = (byte)Integer.parseInt(edtDriverCH20.getText().toString(),10);
        mBytes[163] = (byte)Integer.parseInt(edtDriverCH21.getText().toString(),10);
        mBytes[164] = (byte)Integer.parseInt(edtDriverCH22.getText().toString(),10);
        mBytes[165] = (byte)Integer.parseInt(edtDriverCH23.getText().toString(),10);
        mBytes[166] = (byte)Integer.parseInt(edtDriverCH24.getText().toString(),10);
        mBytes[167] = (byte)Integer.parseInt(edtDriverCH25.getText().toString(),10);
        mBytes[168] = (byte)Integer.parseInt(edtDriverCH26.getText().toString(),10);
        mBytes[169] = (byte)Integer.parseInt(edtDriverCH27.getText().toString(),10);
        mBytes[170] = (byte)Integer.parseInt(edtDriverCH28.getText().toString(),10);
        mBytes[171] = (byte)Integer.parseInt(edtDriverCH29.getText().toString(),10);
        mBytes[172] = (byte)Integer.parseInt(edtDriverCH30.getText().toString(),10);
        mBytes[173] = (byte)Integer.parseInt(edtDriverCH31.getText().toString(),10);
        mBytes[174] = (byte)Integer.parseInt(edtDriverCH32.getText().toString(),10);
        mBytes[175] = (byte)Integer.parseInt(edtDriverCH33.getText().toString(),10);
        mBytes[176] = (byte)Integer.parseInt(edtDriverCH34.getText().toString(),10);
        mBytes[177] = (byte)Integer.parseInt(edtDriverCH35.getText().toString(),10);
        mBytes[178] = (byte)Integer.parseInt(edtDriverCH36.getText().toString(),10);
        mBytes[179] = (byte)Integer.parseInt(edtDriverCH37.getText().toString(),10);
        mBytes[180] = (byte)Integer.parseInt(edtDriverCH38.getText().toString(),10);
        mBytes[181] = (byte)Integer.parseInt(edtDriverCH39.getText().toString(),10);
        mBytes[182] = (byte)Integer.parseInt(edtDriverCH40.getText().toString(),10);
        mBytes[183] = (byte)Integer.parseInt(edtDriverCH41.getText().toString(),10);

        int checksum = 0;
        for (int i = 0; i < 184; i++) {
            int k = mBytes[i] & 0xFF;
            checksum = checksum + k;
        }
        mBytes[184] = (byte)(256 - (checksum % 256));

        mBytes[185] = 1;

    }
    //======================================合并配置结束===========================================//

    @Override
    public void onClick(final View v) {
        byte starttemp;
        byte endtemp;
        byte revtemp;
        byte[] ichanneldata = new byte[44];
        StringBuilder configBuilder = new StringBuilder("");
        String[] stringArr;

        ByteBuffer buff= ByteBuffer.allocate(1024);

        byte bCfgEx = 0;  //扩展配置的标志

        switch (v.getId()) {
            case R.id.tvnormal:
                vpagerCfg.setCurrentItem(0);
                iChooseVPager = 0;
                break;
            case R.id.tvtxrx:
                vpagerCfg.setCurrentItem(1);
                iChooseVPager = 1;
                break;
            case R.id.tvmoduleswitch:
                vpagerCfg.setCurrentItem(2);
                iChooseVPager = 2;
                break;
            case R.id.tvother:
                vpagerCfg.setCurrentItem(3);
                iChooseVPager = 3;
                break;
            case R.id.tvselfsetting:
                vpagerCfg.setCurrentItem(4);
                iChooseVPager = 4;
                break;
            case R.id.tvexconfig:
                vpagerCfg.setCurrentItem(5);
                iChooseVPager = 5;
                break;
            case R.id.tvcfgram:
                vpagerCfg.setCurrentItem(6);
                iChooseVPager = 6;
                break;
            /*
            case R.id.btnsensorrev:
                configBuilder.append(edtSensorCH0.getText().toString()+",");
                configBuilder.append(edtSensorCH1.getText().toString()+",");
                configBuilder.append(edtSensorCH2.getText().toString()+",");
                configBuilder.append(edtSensorCH3.getText().toString()+",");
                configBuilder.append(edtSensorCH4.getText().toString()+",");
                configBuilder.append(edtSensorCH5.getText().toString()+",");
                configBuilder.append(edtSensorCH6.getText().toString()+",");
                configBuilder.append(edtSensorCH7.getText().toString()+",");
                configBuilder.append(edtSensorCH8.getText().toString()+",");
                configBuilder.append(edtSensorCH9.getText().toString()+",");
                configBuilder.append(edtSensorCH10.getText().toString()+",");
                configBuilder.append(edtSensorCH11.getText().toString()+",");
                configBuilder.append(edtSensorCH12.getText().toString()+",");
                configBuilder.append(edtSensorCH13.getText().toString()+",");
                configBuilder.append(edtSensorCH14.getText().toString()+",");
                configBuilder.append(edtSensorCH15.getText().toString()+",");
                configBuilder.append(edtSensorCH16.getText().toString()+",");
                configBuilder.append(edtSensorCH17.getText().toString()+",");
                configBuilder.append(edtSensorCH18.getText().toString()+",");
                configBuilder.append(edtSensorCH19.getText().toString()+",");
                configBuilder.append(edtSensorCH20.getText().toString()+",");
                configBuilder.append(edtSensorCH21.getText().toString()+",");
                configBuilder.append(edtSensorCH22.getText().toString()+",");
                configBuilder.append(edtSensorCH23.getText().toString()+",");
                configBuilder.append(edtSensorCH24.getText().toString()+",");
                configBuilder.append(edtSensorCH25.getText().toString()+",");
                configBuilder.append(edtSensorCH26.getText().toString()+",");
                configBuilder.append(edtSensorCH27.getText().toString()+",");
                configBuilder.append(edtSensorCH28.getText().toString()+",");
                configBuilder.append(edtSensorCH29.getText().toString()+",");
                configBuilder.append(edtSensorStart.getText().toString()+",");
                configBuilder.append(edtSensorEnd.getText().toString()+",");

                value = configBuilder.toString();
                stringArr = value.split(",");

                for (int b = 0; b < stringArr.length; b++) {
                    byte aByte = (byte) Integer.parseInt(stringArr[b], 10);
                    ichanneldata[b] = aByte;
                }

                starttemp = ichanneldata[30];
                endtemp = ichanneldata[31];
                if ((endtemp == 0) || (starttemp > endtemp)){
                    starttemp = 0;
                    if (bSensorNumber == 0){
                        endtemp = 29;
                    }else{
                        endtemp = (byte)(bSensorNumber - 1);
                    }
                }

                for(int i = starttemp,j = 0; i < (endtemp + 1) / 2; i++,j++){
                    revtemp = ichanneldata[i];
                    ichanneldata[i] = ichanneldata[endtemp - j];
                    ichanneldata[endtemp - j] = revtemp;
                }

                edtSensorCH0.setText(Integer.toString(ichanneldata[0] & 0xFF));
                edtSensorCH1.setText(Integer.toString(ichanneldata[1] & 0xFF));
                edtSensorCH2.setText(Integer.toString(ichanneldata[2] & 0xFF));
                edtSensorCH3.setText(Integer.toString(ichanneldata[3] & 0xFF));
                edtSensorCH4.setText(Integer.toString(ichanneldata[4] & 0xFF));
                edtSensorCH5.setText(Integer.toString(ichanneldata[5] & 0xFF));
                edtSensorCH6.setText(Integer.toString(ichanneldata[6] & 0xFF));
                edtSensorCH7.setText(Integer.toString(ichanneldata[7] & 0xFF));
                edtSensorCH8.setText(Integer.toString(ichanneldata[8] & 0xFF));
                edtSensorCH9.setText(Integer.toString(ichanneldata[9] & 0xFF));
                edtSensorCH10.setText(Integer.toString(ichanneldata[10] & 0xFF));
                edtSensorCH11.setText(Integer.toString(ichanneldata[11] & 0xFF));
                edtSensorCH12.setText(Integer.toString(ichanneldata[12] & 0xFF));
                edtSensorCH13.setText(Integer.toString(ichanneldata[13] & 0xFF));
                edtSensorCH14.setText(Integer.toString(ichanneldata[14] & 0xFF));
                edtSensorCH15.setText(Integer.toString(ichanneldata[15] & 0xFF));
                edtSensorCH16.setText(Integer.toString(ichanneldata[16] & 0xFF));
                edtSensorCH17.setText(Integer.toString(ichanneldata[17] & 0xFF));
                edtSensorCH18.setText(Integer.toString(ichanneldata[18] & 0xFF));
                edtSensorCH19.setText(Integer.toString(ichanneldata[19] & 0xFF));
                edtSensorCH20.setText(Integer.toString(ichanneldata[20] & 0xFF));
                edtSensorCH21.setText(Integer.toString(ichanneldata[21] & 0xFF));
                edtSensorCH22.setText(Integer.toString(ichanneldata[22] & 0xFF));
                edtSensorCH23.setText(Integer.toString(ichanneldata[23] & 0xFF));
                edtSensorCH24.setText(Integer.toString(ichanneldata[24] & 0xFF));
                edtSensorCH25.setText(Integer.toString(ichanneldata[25] & 0xFF));
                edtSensorCH26.setText(Integer.toString(ichanneldata[26] & 0xFF));
                edtSensorCH27.setText(Integer.toString(ichanneldata[27] & 0xFF));
                edtSensorCH28.setText(Integer.toString(ichanneldata[28] & 0xFF));
                edtSensorCH29.setText(Integer.toString(ichanneldata[29] & 0xFF));
                break;
            case R.id.allsensorchannels:
                edtSensorCH0.setText("00");edtSensorCH1.setText("01");edtSensorCH2.setText("02");edtSensorCH3.setText("03");edtSensorCH4.setText("04");
                edtSensorCH5.setText("05");edtSensorCH6.setText("06");edtSensorCH7.setText("07");edtSensorCH8.setText("08");edtSensorCH9.setText("09");
                edtSensorCH10.setText("10");edtSensorCH11.setText("11");edtSensorCH12.setText("12");edtSensorCH13.setText("13");edtSensorCH14.setText("14");
                edtSensorCH15.setText("15");edtSensorCH16.setText("16");edtSensorCH17.setText("17");edtSensorCH18.setText("18");edtSensorCH19.setText("19");
                edtSensorCH20.setText("20");edtSensorCH21.setText("21");edtSensorCH22.setText("22");edtSensorCH23.setText("23");edtSensorCH24.setText("24");
                edtSensorCH25.setText("25");edtSensorCH26.setText("26");edtSensorCH27.setText("27");edtSensorCH28.setText("28");edtSensorCH29.setText("29");
                break;
            case R.id.btndriverrev:
                configBuilder.append(edtDriverCH0.getText().toString()+",");
                configBuilder.append(edtDriverCH1.getText().toString()+",");
                configBuilder.append(edtDriverCH2.getText().toString()+",");
                configBuilder.append(edtDriverCH3.getText().toString()+",");
                configBuilder.append(edtDriverCH4.getText().toString()+",");
                configBuilder.append(edtDriverCH5.getText().toString()+",");
                configBuilder.append(edtDriverCH6.getText().toString()+",");
                configBuilder.append(edtDriverCH7.getText().toString()+",");
                configBuilder.append(edtDriverCH8.getText().toString()+",");
                configBuilder.append(edtDriverCH9.getText().toString()+",");
                configBuilder.append(edtDriverCH10.getText().toString()+",");
                configBuilder.append(edtDriverCH11.getText().toString()+",");
                configBuilder.append(edtDriverCH12.getText().toString()+",");
                configBuilder.append(edtDriverCH13.getText().toString()+",");
                configBuilder.append(edtDriverCH14.getText().toString()+",");
                configBuilder.append(edtDriverCH15.getText().toString()+",");
                configBuilder.append(edtDriverCH16.getText().toString()+",");
                configBuilder.append(edtDriverCH17.getText().toString()+",");
                configBuilder.append(edtDriverCH18.getText().toString()+",");
                configBuilder.append(edtDriverCH19.getText().toString()+",");
                configBuilder.append(edtDriverCH20.getText().toString()+",");
                configBuilder.append(edtDriverCH21.getText().toString()+",");
                configBuilder.append(edtDriverCH22.getText().toString()+",");
                configBuilder.append(edtDriverCH23.getText().toString()+",");
                configBuilder.append(edtDriverCH24.getText().toString()+",");
                configBuilder.append(edtDriverCH25.getText().toString()+",");
                configBuilder.append(edtDriverCH26.getText().toString()+",");
                configBuilder.append(edtDriverCH27.getText().toString()+",");
                configBuilder.append(edtDriverCH28.getText().toString()+",");
                configBuilder.append(edtDriverCH29.getText().toString()+",");
                configBuilder.append(edtDriverCH30.getText().toString()+",");
                configBuilder.append(edtDriverCH31.getText().toString()+",");
                configBuilder.append(edtDriverCH32.getText().toString()+",");
                configBuilder.append(edtDriverCH33.getText().toString()+",");
                configBuilder.append(edtDriverCH34.getText().toString()+",");
                configBuilder.append(edtDriverCH35.getText().toString()+",");
                configBuilder.append(edtDriverCH36.getText().toString()+",");
                configBuilder.append(edtDriverCH37.getText().toString()+",");
                configBuilder.append(edtDriverCH38.getText().toString()+",");
                configBuilder.append(edtDriverCH39.getText().toString()+",");
                configBuilder.append(edtDriverCH40.getText().toString()+",");
                configBuilder.append(edtDriverCH41.getText().toString()+",");
                configBuilder.append(edtDriverStart.getText().toString()+",");
                configBuilder.append(edtDriverEnd.getText().toString()+",");

                value = configBuilder.toString();
                stringArr = value.split(",");

                for (int b = 0; b < stringArr.length; b++) {
                    byte aByte = (byte) Integer.parseInt(stringArr[b], 10);
                    ichanneldata[b] = aByte;
                }

                starttemp = ichanneldata[42];
                endtemp = ichanneldata[43];
                if ((endtemp == 0) || (starttemp > endtemp)){
                    starttemp = 0;
                    if (bDriverNumber == 0){
                        endtemp = 41;
                    }else{
                        endtemp = (byte)(bDriverNumber - 1);
                    }
                }

                for(int i = starttemp,j = 0; i < (endtemp + 1) / 2; i++,j++){
                    revtemp = ichanneldata[i];
                    ichanneldata[i] = ichanneldata[endtemp - j];
                    ichanneldata[endtemp - j] = revtemp;
                }

                edtDriverCH0.setText(Integer.toString(ichanneldata[0] & 0xFF));
                edtDriverCH1.setText(Integer.toString(ichanneldata[1] & 0xFF));
                edtDriverCH2.setText(Integer.toString(ichanneldata[2] & 0xFF));
                edtDriverCH3.setText(Integer.toString(ichanneldata[3] & 0xFF));
                edtDriverCH4.setText(Integer.toString(ichanneldata[4] & 0xFF));
                edtDriverCH5.setText(Integer.toString(ichanneldata[5] & 0xFF));
                edtDriverCH6.setText(Integer.toString(ichanneldata[6] & 0xFF));
                edtDriverCH7.setText(Integer.toString(ichanneldata[7] & 0xFF));
                edtDriverCH8.setText(Integer.toString(ichanneldata[8] & 0xFF));
                edtDriverCH9.setText(Integer.toString(ichanneldata[9] & 0xFF));
                edtDriverCH10.setText(Integer.toString(ichanneldata[10] & 0xFF));
                edtDriverCH11.setText(Integer.toString(ichanneldata[11] & 0xFF));
                edtDriverCH12.setText(Integer.toString(ichanneldata[12] & 0xFF));
                edtDriverCH13.setText(Integer.toString(ichanneldata[13] & 0xFF));
                edtDriverCH14.setText(Integer.toString(ichanneldata[14] & 0xFF));
                edtDriverCH15.setText(Integer.toString(ichanneldata[15] & 0xFF));
                edtDriverCH16.setText(Integer.toString(ichanneldata[16] & 0xFF));
                edtDriverCH17.setText(Integer.toString(ichanneldata[17] & 0xFF));
                edtDriverCH18.setText(Integer.toString(ichanneldata[18] & 0xFF));
                edtDriverCH19.setText(Integer.toString(ichanneldata[19] & 0xFF));
                edtDriverCH20.setText(Integer.toString(ichanneldata[20] & 0xFF));
                edtDriverCH21.setText(Integer.toString(ichanneldata[21] & 0xFF));
                edtDriverCH22.setText(Integer.toString(ichanneldata[22] & 0xFF));
                edtDriverCH23.setText(Integer.toString(ichanneldata[23] & 0xFF));
                edtDriverCH24.setText(Integer.toString(ichanneldata[24] & 0xFF));
                edtDriverCH25.setText(Integer.toString(ichanneldata[25] & 0xFF));
                edtDriverCH26.setText(Integer.toString(ichanneldata[26] & 0xFF));
                edtDriverCH27.setText(Integer.toString(ichanneldata[27] & 0xFF));
                edtDriverCH28.setText(Integer.toString(ichanneldata[28] & 0xFF));
                edtDriverCH29.setText(Integer.toString(ichanneldata[29] & 0xFF));
                edtDriverCH30.setText(Integer.toString(ichanneldata[30] & 0xFF));
                edtDriverCH31.setText(Integer.toString(ichanneldata[31] & 0xFF));
                edtDriverCH32.setText(Integer.toString(ichanneldata[32] & 0xFF));
                edtDriverCH33.setText(Integer.toString(ichanneldata[33] & 0xFF));
                edtDriverCH34.setText(Integer.toString(ichanneldata[34] & 0xFF));
                edtDriverCH35.setText(Integer.toString(ichanneldata[35] & 0xFF));
                edtDriverCH36.setText(Integer.toString(ichanneldata[36] & 0xFF));
                edtDriverCH37.setText(Integer.toString(ichanneldata[37] & 0xFF));
                edtDriverCH38.setText(Integer.toString(ichanneldata[38] & 0xFF));
                edtDriverCH39.setText(Integer.toString(ichanneldata[39] & 0xFF));
                edtDriverCH40.setText(Integer.toString(ichanneldata[40] & 0xFF));
                edtDriverCH41.setText(Integer.toString(ichanneldata[41] & 0xFF));
                break;
            case R.id.alldriverchannels:
                edtDriverCH0.setText("00");edtDriverCH1.setText("01");edtDriverCH2.setText("02");edtDriverCH3.setText("03");edtDriverCH4.setText("04");
                edtDriverCH5.setText("05");edtDriverCH6.setText("06");edtDriverCH7.setText("07");edtDriverCH8.setText("08");edtDriverCH9.setText("09");
                edtDriverCH10.setText("10");edtDriverCH11.setText("11");edtDriverCH12.setText("12");edtDriverCH13.setText("13");edtDriverCH14.setText("14");
                edtDriverCH15.setText("15");edtDriverCH16.setText("16");edtDriverCH17.setText("17");edtDriverCH18.setText("18");edtDriverCH19.setText("19");
                edtDriverCH20.setText("20");edtDriverCH21.setText("21");edtDriverCH22.setText("22");edtDriverCH23.setText("23");edtDriverCH24.setText("24");
                edtDriverCH25.setText("25");edtDriverCH26.setText("26");edtDriverCH27.setText("27");edtDriverCH28.setText("28");edtDriverCH29.setText("29");
                edtDriverCH30.setText("30");edtDriverCH31.setText("31");edtDriverCH32.setText("32");edtDriverCH33.setText("33");edtDriverCH34.setText("34");
                edtDriverCH35.setText("35");edtDriverCH36.setText("36");edtDriverCH37.setText("37");edtDriverCH38.setText("38");edtDriverCH39.setText("39");
                edtDriverCH40.setText("40");edtDriverCH41.setText("41");
                break;
            */
            case R.id.sendcfg:   //send cfg
                bottonMode = 1;

                if (iChooseVPager == 8) {
                    configBuilder.append(mCfg8050.getText().toString() + ",");
                    configBuilder.append(mCfg8051.getText().toString() + ",");
                    configBuilder.append(mCfg8052.getText().toString() + ",");
                    configBuilder.append(mCfg8053.getText().toString() + ",");
                    configBuilder.append(mCfg8054.getText().toString() + ",");
                    configBuilder.append(mCfg8055.getText().toString() + ",");
                    configBuilder.append(mCfg8056.getText().toString() + ",");
                    configBuilder.append(mCfg8057.getText().toString() + ",");
                    configBuilder.append(mCfg8058.getText().toString() + ",");
                    configBuilder.append(mCfg8059.getText().toString() + ",");
                    configBuilder.append(mCfg805A.getText().toString() + ",");
                    configBuilder.append(mCfg805B.getText().toString() + ",");
                    configBuilder.append(mCfg805C.getText().toString() + ",");
                    configBuilder.append(mCfg805D.getText().toString() + ",");
                    configBuilder.append(mCfg805E.getText().toString() + ",");
                    configBuilder.append(mCfg805F.getText().toString() + ",");

                    configBuilder.append(mCfg8060.getText().toString() + ",");
                    configBuilder.append(mCfg8061.getText().toString() + ",");
                    configBuilder.append(mCfg8062.getText().toString() + ",");
                    configBuilder.append(mCfg8063.getText().toString() + ",");
                    configBuilder.append(mCfg8064.getText().toString() + ",");
                    configBuilder.append(mCfg8065.getText().toString() + ",");
                    configBuilder.append(mCfg8066.getText().toString() + ",");
                    configBuilder.append(mCfg8067.getText().toString() + ",");
                    configBuilder.append(mCfg8068.getText().toString() + ",");
                    configBuilder.append(mCfg8069.getText().toString() + ",");
                    configBuilder.append(mCfg806A.getText().toString() + ",");
                    configBuilder.append(mCfg806B.getText().toString() + ",");
                    configBuilder.append(mCfg806C.getText().toString() + ",");
                    configBuilder.append(mCfg806D.getText().toString() + ",");
                    configBuilder.append(mCfg806E.getText().toString() + ",");
                    configBuilder.append(mCfg806F.getText().toString() + ",");

                    configBuilder.append(mCfg8070.getText().toString() + ",");
                    configBuilder.append(mCfg8071.getText().toString() + ",");
                    configBuilder.append(mCfg8072.getText().toString() + ",");
                    configBuilder.append(mCfg8073.getText().toString() + ",");
                    configBuilder.append(mCfg8074.getText().toString() + ",");
                    configBuilder.append(mCfg8075.getText().toString() + ",");
                    configBuilder.append(mCfg8076.getText().toString() + ",");
                    configBuilder.append(mCfg8077.getText().toString() + ",");
                    configBuilder.append(mCfg8078.getText().toString() + ",");
                    configBuilder.append(mCfg8079.getText().toString() + ",");
                    configBuilder.append(mCfg807A.getText().toString() + ",");
                    configBuilder.append(mCfg807B.getText().toString() + ",");
                    configBuilder.append(mCfg807C.getText().toString() + ",");
                    configBuilder.append(mCfg807D.getText().toString() + ",");
                    configBuilder.append(mCfg807E.getText().toString() + ",");
                    configBuilder.append(mCfg807F.getText().toString() + ",");

                    configBuilder.append(mCfg8080.getText().toString() + ",");
                    configBuilder.append(mCfg8081.getText().toString() + ",");
                    configBuilder.append(mCfg8082.getText().toString() + ",");
                    configBuilder.append(mCfg8083.getText().toString() + ",");
                    configBuilder.append(mCfg8084.getText().toString() + ",");
                    configBuilder.append(mCfg8085.getText().toString() + ",");
                    configBuilder.append(mCfg8086.getText().toString() + ",");
                    configBuilder.append(mCfg8087.getText().toString() + ",");
                    configBuilder.append(mCfg8088.getText().toString() + ",");
                    configBuilder.append(mCfg8089.getText().toString() + ",");
                    configBuilder.append(mCfg808A.getText().toString() + ",");
                    configBuilder.append(mCfg808B.getText().toString() + ",");
                    configBuilder.append(mCfg808C.getText().toString() + ",");
                    configBuilder.append(mCfg808D.getText().toString() + ",");
                    configBuilder.append(mCfg808E.getText().toString() + ",");
                    configBuilder.append(mCfg808F.getText().toString() + ",");

                    configBuilder.append(mCfg8090.getText().toString() + ",");
                    configBuilder.append(mCfg8091.getText().toString() + ",");
                    configBuilder.append(mCfg8092.getText().toString() + ",");
                    configBuilder.append(mCfg8093.getText().toString() + ",");
                    configBuilder.append(mCfg8094.getText().toString() + ",");
                    configBuilder.append(mCfg8095.getText().toString() + ",");
                    configBuilder.append(mCfg8096.getText().toString() + ",");
                    configBuilder.append(mCfg8097.getText().toString() + ",");
                    configBuilder.append(mCfg8098.getText().toString() + ",");
                    configBuilder.append(mCfg8099.getText().toString() + ",");
                    configBuilder.append(mCfg809A.getText().toString() + ",");
                    configBuilder.append(mCfg809B.getText().toString() + ",");
                    configBuilder.append(mCfg809C.getText().toString() + ",");
                    configBuilder.append(mCfg809D.getText().toString() + ",");
                    configBuilder.append(mCfg809E.getText().toString() + ",");
                    configBuilder.append(mCfg809F.getText().toString() + ",");

                    configBuilder.append(mCfg80A0.getText().toString() + ",");
                    configBuilder.append(mCfg80A1.getText().toString() + ",");
                    configBuilder.append(mCfg80A2.getText().toString() + ",");
                    configBuilder.append(mCfg80A3.getText().toString() + ",");
                    configBuilder.append(mCfg80A4.getText().toString() + ",");
                    configBuilder.append(mCfg80A5.getText().toString() + ",");
                    configBuilder.append(mCfg80A6.getText().toString() + ",");
                    configBuilder.append(mCfg80A7.getText().toString() + ",");
                    configBuilder.append(mCfg80A8.getText().toString() + ",");
                    configBuilder.append(mCfg80A9.getText().toString() + ",");
                    configBuilder.append(mCfg80AA.getText().toString() + ",");
                    configBuilder.append(mCfg80AB.getText().toString() + ",");
                    configBuilder.append(mCfg80AC.getText().toString() + ",");
                    configBuilder.append(mCfg80AD.getText().toString() + ",");
                    configBuilder.append(mCfg80AE.getText().toString() + ",");
                    configBuilder.append(mCfg80AF.getText().toString() + ",");

                    configBuilder.append(mCfg80B0.getText().toString() + ",");
                    configBuilder.append(mCfg80B1.getText().toString() + ",");
                    configBuilder.append(mCfg80B2.getText().toString() + ",");
                    configBuilder.append(mCfg80B3.getText().toString() + ",");
                    configBuilder.append(mCfg80B4.getText().toString() + ",");
                    configBuilder.append(mCfg80B5.getText().toString() + ",");
                    configBuilder.append(mCfg80B6.getText().toString() + ",");
                    configBuilder.append(mCfg80B7.getText().toString() + ",");
                    configBuilder.append(mCfg80B8.getText().toString() + ",");
                    configBuilder.append(mCfg80B9.getText().toString() + ",");
                    configBuilder.append(mCfg80BA.getText().toString() + ",");
                    configBuilder.append(mCfg80BB.getText().toString() + ",");
                    configBuilder.append(mCfg80BC.getText().toString() + ",");
                    configBuilder.append(mCfg80BD.getText().toString() + ",");
                    configBuilder.append(mCfg80BE.getText().toString() + ",");
                    configBuilder.append(mCfg80BF.getText().toString() + ",");

                    configBuilder.append(mCfg80C0.getText().toString() + ",");
                    configBuilder.append(mCfg80C1.getText().toString() + ",");
                    configBuilder.append(mCfg80C2.getText().toString() + ",");
                    configBuilder.append(mCfg80C3.getText().toString() + ",");
                    configBuilder.append(mCfg80C4.getText().toString() + ",");
                    configBuilder.append(mCfg80C5.getText().toString() + ",");
                    configBuilder.append(mCfg80C6.getText().toString() + ",");
                    configBuilder.append(mCfg80C7.getText().toString() + ",");
                    configBuilder.append(mCfg80C8.getText().toString() + ",");
                    configBuilder.append(mCfg80C9.getText().toString() + ",");
                    configBuilder.append(mCfg80CA.getText().toString() + ",");
                    configBuilder.append(mCfg80CB.getText().toString() + ",");
                    configBuilder.append(mCfg80CC.getText().toString() + ",");
                    configBuilder.append(mCfg80CD.getText().toString() + ",");
                    configBuilder.append(mCfg80CE.getText().toString() + ",");
                    configBuilder.append(mCfg80CF.getText().toString() + ",");

                    configBuilder.append(mCfg80D0.getText().toString() + ",");
                    configBuilder.append(mCfg80D1.getText().toString() + ",");
                    configBuilder.append(mCfg80D2.getText().toString() + ",");
                    configBuilder.append(mCfg80D3.getText().toString() + ",");
                    configBuilder.append(mCfg80D4.getText().toString() + ",");
                    configBuilder.append(mCfg80D5.getText().toString() + ",");
                    configBuilder.append(mCfg80D6.getText().toString() + ",");
                    configBuilder.append(mCfg80D7.getText().toString() + ",");
                    configBuilder.append(mCfg80D8.getText().toString() + ",");
                    configBuilder.append(mCfg80D9.getText().toString() + ",");
                    configBuilder.append(mCfg80DA.getText().toString() + ",");
                    configBuilder.append(mCfg80DB.getText().toString() + ",");
                    configBuilder.append(mCfg80DC.getText().toString() + ",");
                    configBuilder.append(mCfg80DD.getText().toString() + ",");
                    configBuilder.append(mCfg80DE.getText().toString() + ",");
                    configBuilder.append(mCfg80DF.getText().toString() + ",");

                    configBuilder.append(mCfg80E0.getText().toString() + ",");
                    configBuilder.append(mCfg80E1.getText().toString() + ",");
                    configBuilder.append(mCfg80E2.getText().toString() + ",");
                    configBuilder.append(mCfg80E3.getText().toString() + ",");
                    configBuilder.append(mCfg80E4.getText().toString() + ",");
                    configBuilder.append(mCfg80E5.getText().toString() + ",");
                    configBuilder.append(mCfg80E6.getText().toString() + ",");
                    configBuilder.append(mCfg80E7.getText().toString() + ",");
                    configBuilder.append(mCfg80E8.getText().toString() + ",");
                    configBuilder.append(mCfg80E9.getText().toString() + ",");
                    configBuilder.append(mCfg80EA.getText().toString() + ",");
                    configBuilder.append(mCfg80EB.getText().toString() + ",");
                    configBuilder.append(mCfg80EC.getText().toString() + ",");
                    configBuilder.append(mCfg80ED.getText().toString() + ",");
                    configBuilder.append(mCfg80EE.getText().toString() + ",");
                    configBuilder.append(mCfg80EF.getText().toString() + ",");

                    configBuilder.append(mCfg80F0.getText().toString() + ",");
                    configBuilder.append(mCfg80F1.getText().toString() + ",");
                    configBuilder.append(mCfg80F2.getText().toString() + ",");
                    configBuilder.append(mCfg80F3.getText().toString() + ",");
                    configBuilder.append(mCfg80F4.getText().toString() + ",");
                    configBuilder.append(mCfg80F5.getText().toString() + ",");
                    configBuilder.append(mCfg80F6.getText().toString() + ",");
                    configBuilder.append(mCfg80F7.getText().toString() + ",");
                    configBuilder.append(mCfg80F8.getText().toString() + ",");
                    configBuilder.append(mCfg80F9.getText().toString() + ",");
                    configBuilder.append(mCfg80FA.getText().toString() + ",");
                    configBuilder.append(mCfg80FB.getText().toString() + ",");
                    configBuilder.append(mCfg80FC.getText().toString() + ",");
                    configBuilder.append(mCfg80FD.getText().toString() + ",");
                    configBuilder.append(mCfg80FE.getText().toString() + ",");
                    configBuilder.append(mCfg80FF.getText().toString() + ",");

                    configBuilder.append(mCfg8100.getText().toString() + ",");
                    configBuilder.append(mCfg8101.getText().toString() + ",");
                    configBuilder.append(mCfg8102.getText().toString() + ",");
                    configBuilder.append(mCfg8103.getText().toString() + ",");
                    configBuilder.append(mCfg8104.getText().toString() + ",");
                    configBuilder.append(mCfg8105.getText().toString() + ",");
                    configBuilder.append(mCfg8106.getText().toString() + ",");
                    configBuilder.append(mCfg8107.getText().toString() + ",");
                    configBuilder.append(mCfg8108.getText().toString() + ",");
                    configBuilder.append(mCfg8109.getText().toString() + ",");
                    configBuilder.append(mCfg810A.getText().toString() + ",");
                    configBuilder.append(mCfg810B.getText().toString() + ",");
                    configBuilder.append(mCfg810C.getText().toString() + ",");
                    configBuilder.append(mCfg810D.getText().toString() + ",");
                    configBuilder.append(mCfg810E.getText().toString() + ",");
                    configBuilder.append(mCfg810F.getText().toString() + ",");

                    configBuilder.append(mCfg8110.getText().toString() + ",");
                    configBuilder.append(mCfg8111.getText().toString() + ",");
                    configBuilder.append(mCfg8112.getText().toString() + ",");
                    configBuilder.append(mCfg8113.getText().toString() + ",");
                    configBuilder.append(mCfg8114.getText().toString() + ",");
                    configBuilder.append(mCfg8115.getText().toString() + ",");
                    configBuilder.append(mCfg8116.getText().toString() + ",");
                    configBuilder.append(mCfg8117.getText().toString() + ",");
                    configBuilder.append(mCfg8118.getText().toString() + ",");
                    configBuilder.append(mCfg8119.getText().toString() + ",");
                    configBuilder.append(mCfg811A.getText().toString() + ",");
                    configBuilder.append(mCfg811B.getText().toString() + ",");
                    configBuilder.append(mCfg811C.getText().toString() + ",");
                    configBuilder.append(mCfg811D.getText().toString() + ",");
                    configBuilder.append(mCfg811E.getText().toString() + ",");
                    configBuilder.append(mCfg811F.getText().toString() + ",");

                    configBuilder.append(mCfg8120.getText().toString() + ",");
                    configBuilder.append(mCfg8121.getText().toString() + ",");
                    configBuilder.append(mCfg8122.getText().toString() + ",");
                    configBuilder.append(mCfg8123.getText().toString() + ",");
                    configBuilder.append(mCfg8124.getText().toString() + ",");
                    configBuilder.append(mCfg8125.getText().toString() + ",");
                    configBuilder.append(mCfg8126.getText().toString() + ",");
                    configBuilder.append(mCfg8127.getText().toString() + ",");
                    configBuilder.append(mCfg8128.getText().toString() + ",");
                    configBuilder.append(mCfg8129.getText().toString() + ",");
                    configBuilder.append(mCfg812A.getText().toString() + ",");
                    configBuilder.append(mCfg812B.getText().toString() + ",");
                    configBuilder.append(mCfg812C.getText().toString() + ",");
                    configBuilder.append(mCfg812D.getText().toString() + ",");
                    configBuilder.append(mCfg812E.getText().toString() + ",");
                    configBuilder.append(mCfg812F.getText().toString() + ",");

                    configBuilder.append(mCfg8130.getText().toString() + ",");
                    configBuilder.append(mCfg8131.getText().toString() + ",");
                    configBuilder.append(mCfg8132.getText().toString() + ",");
                    configBuilder.append(mCfg8133.getText().toString() + ",");
                    configBuilder.append(mCfg8134.getText().toString() + ",");
                    configBuilder.append(mCfg8135.getText().toString() + ",");
                    configBuilder.append(mCfg8136.getText().toString() + ",");
                    configBuilder.append(mCfg8137.getText().toString() + ",");
                    configBuilder.append(mCfg8138.getText().toString() + ",");
                    configBuilder.append(mCfg8139.getText().toString() + ",");
                    configBuilder.append(mCfg813A.getText().toString() + ",");
                    configBuilder.append(mCfg813B.getText().toString() + ",");
                    configBuilder.append(mCfg813C.getText().toString() + ",");
                    configBuilder.append(mCfg813D.getText().toString() + ",");
                    //configBuilder.append(mCfg813E.getText().toString() + ",");
                    configBuilder.append("01" + ",");   //补上01
                    configBuilder.append("00" + ",");   //补上00，多加一个，补齐是偶数

                    //bCfgEx = (byte)Integer.parseInt(mCfg805A.getText().toString());
                    //if ((bCfgEx & 0x40) == 0x40)  //有扩展配置，则需要发送
                    {
                        //configBuilder.append(",");

                        configBuilder.append(mCfgBF7B.getText().toString() + ",");
                        configBuilder.append(mCfgBF7C.getText().toString() + ",");
                        configBuilder.append(mCfgBF7D.getText().toString() + ",");
                        configBuilder.append(mCfgBF7E.getText().toString() + ",");
                        configBuilder.append(mCfgBF7F.getText().toString() + ",");

                        configBuilder.append(mCfgBF80.getText().toString() + ",");
                        configBuilder.append(mCfgBF81.getText().toString() + ",");
                        configBuilder.append(mCfgBF82.getText().toString() + ",");
                        configBuilder.append(mCfgBF83.getText().toString() + ",");
                        configBuilder.append(mCfgBF84.getText().toString() + ",");
                        configBuilder.append(mCfgBF85.getText().toString() + ",");
                        configBuilder.append(mCfgBF86.getText().toString() + ",");
                        configBuilder.append(mCfgBF87.getText().toString() + ",");
                        configBuilder.append(mCfgBF88.getText().toString() + ",");
                        configBuilder.append(mCfgBF89.getText().toString() + ",");
                        configBuilder.append(mCfgBF8A.getText().toString() + ",");
                        configBuilder.append(mCfgBF8B.getText().toString() + ",");
                        configBuilder.append(mCfgBF8C.getText().toString() + ",");
                        configBuilder.append(mCfgBF8D.getText().toString() + ",");
                        configBuilder.append(mCfgBF8E.getText().toString() + ",");
                        configBuilder.append(mCfgBF8F.getText().toString() + ",");

                        configBuilder.append(mCfgBF90.getText().toString() + ",");
                        configBuilder.append(mCfgBF91.getText().toString() + ",");
                        configBuilder.append(mCfgBF92.getText().toString() + ",");
                        configBuilder.append(mCfgBF93.getText().toString() + ",");
                        configBuilder.append(mCfgBF94.getText().toString() + ",");
                        configBuilder.append(mCfgBF95.getText().toString() + ",");
                        configBuilder.append(mCfgBF96.getText().toString() + ",");
                        configBuilder.append(mCfgBF97.getText().toString() + ",");
                        configBuilder.append(mCfgBF98.getText().toString() + ",");
                        configBuilder.append(mCfgBF99.getText().toString() + ",");
                        configBuilder.append(mCfgBF9A.getText().toString() + ",");
                        configBuilder.append(mCfgBF9B.getText().toString() + ",");
                        configBuilder.append(mCfgBF9C.getText().toString() + ",");
                        configBuilder.append(mCfgBF9D.getText().toString() + ",");
                        configBuilder.append(mCfgBF9E.getText().toString() + ",");
                        configBuilder.append(mCfgBF9F.getText().toString() + ",");

                        configBuilder.append(mCfgBFA0.getText().toString() + ",");
                        configBuilder.append(mCfgBFA1.getText().toString() + ",");
                        configBuilder.append(mCfgBFA2.getText().toString() + ",");
                        configBuilder.append(mCfgBFA3.getText().toString() + ",");
                        configBuilder.append(mCfgBFA4.getText().toString() + ",");
                        configBuilder.append(mCfgBFA5.getText().toString() + ",");
                        configBuilder.append(mCfgBFA6.getText().toString() + ",");
                        configBuilder.append(mCfgBFA7.getText().toString() + ",");
                        configBuilder.append(mCfgBFA8.getText().toString() + ",");
                        configBuilder.append(mCfgBFA9.getText().toString() + ",");
                        configBuilder.append(mCfgBFAA.getText().toString() + ",");
                        configBuilder.append(mCfgBFAB.getText().toString() + ",");
                        configBuilder.append(mCfgBFAC.getText().toString() + ",");
                        configBuilder.append(mCfgBFAD.getText().toString() + ",");
                        configBuilder.append(mCfgBFAE.getText().toString() + ",");
                        configBuilder.append(mCfgBFAF.getText().toString() + ",");

                        configBuilder.append(mCfgBFB0.getText().toString() + ",");
                        configBuilder.append(mCfgBFB1.getText().toString() + ",");
                        configBuilder.append(mCfgBFB2.getText().toString() + ",");
                        configBuilder.append(mCfgBFB3.getText().toString() + ",");
                        configBuilder.append(mCfgBFB4.getText().toString() + ",");
                        configBuilder.append(mCfgBFB5.getText().toString() + ",");
                        configBuilder.append(mCfgBFB6.getText().toString() + ",");
                        configBuilder.append(mCfgBFB7.getText().toString() + ",");
                        configBuilder.append(mCfgBFB8.getText().toString() + ",");
                        configBuilder.append(mCfgBFB9.getText().toString() + ",");
                        configBuilder.append(mCfgBFBA.getText().toString() + ",");
                        configBuilder.append(mCfgBFBB.getText().toString() + ",");
                        configBuilder.append(mCfgBFBC.getText().toString() + ",");
                        configBuilder.append(mCfgBFBD.getText().toString() + ",");
                        configBuilder.append(mCfgBFBE.getText().toString() + ",");
                        configBuilder.append(mCfgBFBF.getText().toString() + ",");

                        configBuilder.append(mCfgBFC0.getText().toString() + ",");
                        configBuilder.append(mCfgBFC1.getText().toString() + ",");
                        configBuilder.append(mCfgBFC2.getText().toString() + ",");
                        configBuilder.append(mCfgBFC3.getText().toString() + ",");
                        configBuilder.append(mCfgBFC4.getText().toString() + ",");
                        configBuilder.append(mCfgBFC5.getText().toString() + ",");
                        configBuilder.append(mCfgBFC6.getText().toString() + ",");
                        configBuilder.append(mCfgBFC7.getText().toString() + ",");
                        configBuilder.append(mCfgBFC8.getText().toString() + ",");
                        configBuilder.append(mCfgBFC9.getText().toString() + ",");
                        configBuilder.append(mCfgBFCA.getText().toString() + ",");
                        configBuilder.append(mCfgBFCB.getText().toString() + ",");
                        configBuilder.append(mCfgBFCC.getText().toString() + ",");
                        configBuilder.append(mCfgBFCD.getText().toString() + ",");
                        configBuilder.append(mCfgBFCE.getText().toString() + ",");
                        configBuilder.append(mCfgBFCF.getText().toString() + ",");

                        configBuilder.append(mCfgBFD0.getText().toString() + ",");
                        configBuilder.append(mCfgBFD1.getText().toString() + ",");
                        configBuilder.append(mCfgBFD2.getText().toString() + ",");
                        configBuilder.append(mCfgBFD3.getText().toString() + ",");
                        configBuilder.append(mCfgBFD4.getText().toString() + ",");
                        configBuilder.append(mCfgBFD5.getText().toString() + ",");
                        configBuilder.append(mCfgBFD6.getText().toString() + ",");
                        configBuilder.append(mCfgBFD7.getText().toString() + ",");
                        configBuilder.append(mCfgBFD8.getText().toString() + ",");
                        configBuilder.append(mCfgBFD9.getText().toString() + ",");
                        configBuilder.append(mCfgBFDA.getText().toString() + ",");
                        configBuilder.append(mCfgBFDB.getText().toString() + ",");
                        configBuilder.append(mCfgBFDC.getText().toString() + ",");
                        configBuilder.append(mCfgBFDD.getText().toString() + ",");
                        configBuilder.append(mCfgBFDE.getText().toString() + ",");
                        configBuilder.append(mCfgBFDF.getText().toString() + ",");

                        configBuilder.append(mCfgBFE0.getText().toString() + ",");
                        configBuilder.append(mCfgBFE1.getText().toString() + ",");
                        configBuilder.append(mCfgBFE2.getText().toString() + ",");
                        configBuilder.append(mCfgBFE3.getText().toString() + ",");
                        configBuilder.append(mCfgBFE4.getText().toString() + ",");
                        configBuilder.append(mCfgBFE5.getText().toString() + ",");
                        configBuilder.append(mCfgBFE6.getText().toString() + ",");
                        configBuilder.append(mCfgBFE7.getText().toString() + ",");
                        configBuilder.append(mCfgBFE8.getText().toString() + ",");
                        configBuilder.append(mCfgBFE9.getText().toString() + ",");
                        configBuilder.append(mCfgBFEA.getText().toString() + ",");
                        configBuilder.append(mCfgBFEB.getText().toString() + ",");
                        configBuilder.append(mCfgBFEC.getText().toString() + ",");
                        configBuilder.append(mCfgBFED.getText().toString() + ",");
                        configBuilder.append(mCfgBFEE.getText().toString() + ",");
                        configBuilder.append(mCfgBFEF.getText().toString() + ",");

                        configBuilder.append(mCfgBFF0.getText().toString() + ",");
                        configBuilder.append(mCfgBFF1.getText().toString() + ",");
                        configBuilder.append(mCfgBFF2.getText().toString() + ",");
                        configBuilder.append(mCfgBFF3.getText().toString() + ",");
                        configBuilder.append(mCfgBFF4.getText().toString() + ",");
                        configBuilder.append(mCfgBFF5.getText().toString() + ",");
                        configBuilder.append(mCfgBFF6.getText().toString() + ",");
                        configBuilder.append(mCfgBFF7.getText().toString() + ",");
                        configBuilder.append(mCfgBFF8.getText().toString() + ",");
                        configBuilder.append(mCfgBFF9.getText().toString() + ",");
                        configBuilder.append(mCfgBFFA.getText().toString());
                    }
                    //configBuilder.append(mCfg813E.getText().toString() + ",");
                    //configBuilder.append(mCfg813F.getText().toString());
                }else{ //在其他界面则保存
                    CombineCfg();
                    for (int i = 0; i < 185; i++){
                        String hv = Integer.toHexString(mBytes[i] & 0xFF);
                        if (hv.length() < 2){
                            hv = "0" + hv;
                        }
                        configBuilder.append(hv + ",");
                    }

                    configBuilder.append("01");  //mBytes[185]，最后置上1

                    bCfgEx = mBytes[10];
                }
                //mShow.setText(configBuilder.toString());

                value = configBuilder.toString();
                //value = mMessage.getText().toString();
                stringArr = value.split(",");

                value = value.replace(',', ' '); //逗号转换为空格

                value = value.trim();  //去除空格
                value = value.replaceAll(" ", ""); //逗号转换为空格
                //char mTextData[] = value.toCharArray();
                //byte[] mBufferData = new byte[1024];

                for (int b = 0; b < stringArr.length; b++) {
                    byte aByte = (byte) Integer.parseInt(stringArr[b], 16);
                    buff.array()[b] = aByte;
                }

                buff.order(ByteOrder.BIG_ENDIAN);
                //mBufferData = value.getBytes();
                mSendData = new byte[1024];


                //重新计算checksum
                int checksum = 0;
                for (int i = 0; i < 236; i += 2) {

                    //int k = ((int)mBytes[i] << 8) + mBytes[i + 1];
                    int k = buff.asShortBuffer().get(i>>1);
                    checksum = checksum + k;

                    String hv = Integer.toHexString(buff.array()[i] & 0xff);
                    if (hv.length() < 2){
                        hv = "0" + hv;
                    }
                    mConfigShow[i] = hv;
                    hv = Integer.toHexString(buff.array()[i + 1] & 0xff);
                    if (hv.length() < 2){
                        hv = "0" + hv;
                    }
                    mConfigShow[i + 1] = hv;

                }

                //将checksum填入配置中
                //if (checksum % 256 == 0)  //校验和正确
                {
                    buff.array()[236] = (byte) ((0 - (short)checksum) >> 8);
                    buff.array()[237] = (byte) ((0 - (short)checksum) & 0xff);
                    // mShow.setText("Cfg Checksum  re-calculation!");
                }

                //更新配置标志位
                buff.array()[238] = 0x01;

                mConfigShow[236] = Integer.toString(buff.array()[236] & 0xff);
                mConfigShow[237] = Integer.toString(buff.array()[237] & 0xff);
                mConfigShow[238] = Integer.toString(buff.array()[238] & 0xff);


                checksum = 0;
                for (int i = (239 + 1); i < (239 + 1 + 126); i += 2) {  //要从偶数位开始，否则下面获取数据相加会出错

                    //int k = ((int)mBytes[i] << 8) + mBytes[i + 1];
                    int k = buff.asShortBuffer().get(i>>1);
                    checksum = checksum + k;

                    String hv = Integer.toHexString(buff.array()[i] & 0xff);
                    if (hv.length() < 2){
                        hv = "0" + hv;
                    }
                    mConfigShow[i - 1] = hv;   //因为前面多加了一个，从偶数开始，这里要减回来
                    hv = Integer.toHexString(buff.array()[i + 1] & 0xff);
                    if (hv.length() < 2){
                        hv = "0" + hv;
                    }
                    mConfigShow[i] = hv;

                }

                //将checksum填入配置
                buff.array()[239 + 1 + 126] = (byte) ((0 - (short)checksum) >> 8);  //多加了一个从偶数位开始
                buff.array()[239 + 1 + 127] = (byte) ((0 - (short)checksum) & 0xff);

                //mConfigShow[239 + 126] = Integer.toString((short)checksum >> 8);//Integer.toString(buff.array()[239 + 126] & 0xff);
                //mConfigShow[239 + 127] = Integer.toString((short)checksum & 0xff);//Integer.toString(buff.array()[239 + 127] & 0xff);


                byte addressH = (byte)0xBF;
                byte addressL = (byte)0x7B;
                iicWrite(addressH,addressL,buff.array(),239 + 1,128);
                if (!recallCheck(addressH, addressL,buff.array(),239 + 1,128)) {
                    mShow.setText("Recall check error,Send cfg failed");
                    return;
                }
                else{
                    mShow.setText("Recall check success,Send cfg success");
                }
                //扩展命令  0x03,0x01,0x0f,-128,0x47,0x00,0x39,
                addressH = (byte)0x80;
                addressL = (byte)0x50;
                iicWrite(addressH,addressL,buff.array(),0,239);
                if (!recallCheck(addressH, addressL,buff.array(),0,238)) {
                    mShow.setText("Recall check error,Send cfg failed");
                   // return false;
                }
                else{
                    mShow.setText("Recall check success,Send cfg success");
                }

                if (iChooseVPager == 8) {

                    ReadCfgRam(mConfigShow);

                    mCfg813C.setText(Integer.toHexString(buff.array()[236] & 0xff));
                    mCfg813D.setText(Integer.toHexString(buff.array()[237] & 0xff));

                    //if ((bCfgEx & 0x40) == 0x40)
                    {
                        mCfgBFF9.setText(Integer.toHexString(buff.array()[239 + 1 + 126] & 0xff));
                        mCfgBFFA.setText(Integer.toHexString(buff.array()[239 + 1 + 127] & 0xff));
                    }
                }
                break;
            case R.id.readcfg:  //read cfg
                bottonMode = 2;
                mSendData = mSendGetGt9ConfigData;

                iicWriteCommand((byte)0x12,(byte)0,(byte)0,0,0);
                while(true) {
                    SystemClock.sleep(100);

                    iicRead((byte) 0x81, (byte) 0x4e, mBytes, 1);
                    if (mBytes[0] == (byte)0)
                    {
                        break;
                    }

                    iicWriteCommand((byte) 0x0f, (byte) 0x81, (byte) 0x4e, 0, 1);
                }
                addressH = (byte)0x80;
                addressL = (byte)0x50;



                iicRead(addressH,addressL,buff.array(),239);
                buff.order(ByteOrder.BIG_ENDIAN);
                StringBuilder stringBuilder = new StringBuilder("");
                checksum = 0;
                for (int i = 0; i < 238; i += 2) {

                    //int k = ((int)mBytes[i] << 8) + mBytes[i + 1];
                    int k = buff.asShortBuffer().get(i>>1);
                    checksum = checksum + k;
                    String hv = Integer.toHexString(buff.array()[i] & 0xff);
                    if (hv.length() < 2){
                        hv = "0" + hv;
                    }
                    mConfigShow[i] = hv;
                    hv = Integer.toHexString(buff.array()[i + 1] & 0xff);
                    if (hv.length() < 2){
                        hv = "0" + hv;
                    }
                    mConfigShow[i + 1] = hv;
                    stringBuilder.append(hv);
                    stringBuilder.append(",");
                }
                if((short)checksum == 0)  //校验和正确
                {
                    //if ((buff.array()[10] & 0x40) == 0x40)  //有扩展配置，再做校验
                    {
                        addressH = (byte)0xBF;
                        addressL = (byte)0x7B;
                        iicRead(addressH,addressL,buff.array(),128);
                        checksum = 0;
                        for (int i = 0,j = 239; i < 128; i += 2,j += 2) {

                            int k = buff.asShortBuffer().get(i>>1);//((int)mBytes[i] << 8) + mBytes[i + 1];
                            checksum = checksum + k;
                            String hv = Integer.toHexString(buff.array()[i] & 0xff);
                            if (hv.length() < 2){
                                hv = "0" + hv;
                            }
                            mConfigShow[j] = hv;
                            hv = Integer.toHexString(buff.array()[i + 1] & 0xff);
                            if (hv.length() < 2){
                                hv = "0" + hv;
                            }
                            mConfigShow[j + 1] = hv;
                        }
                        if((short)checksum == 0)  //校验和正确
                        {
                            mShow.setText("Cfg Checksum is correct!");
                        }
                        else{
                            mShow.setText("Cfg Checksum is error!");
                        }

                    }
                    //else {
                    //    mShow.setText("Cfg Checksum is correct!");
                    //}
                }
                else {
                    mShow.setText("Cfg Checksum is error!");
                }

                //ReadCfgSample(mBytes);
                //ReadCfgModuleSwitch(mBytes);
                //ReadCfgNormalSetting(mBytes);
                //ReadCfgChannelSetting(mBytes);
                //ReadCfgPenSetting(mBytes);
                //ReadCfgPlamRestrain(mBytes);
                //ReadCfgKeySetting(mBytes);
                //ReadCfgHoppingSetting(mBytes);
                ReadCfgRam(mConfigShow);



                addressH = (byte)0x81;
                addressL = (byte)0x40;
                iicRead(addressH,addressL,mBytes,16);
                tvVenderID.setText("VenderID:"+Integer.toString(mBytes[10] & 0xFF));

                mSendCfg.setEnabled(true);

                btnsave.setEnabled(true);

                break;
            case R.id.savecfg:

                if (editname.getText().length() == 0){
                    Toast.makeText(this,"请输入文件名及文件格式",Toast.LENGTH_SHORT).show();
                }else{
                    ActivityCompat.requestPermissions(  Config.this, new String[]{android
                            .Manifest.permission.WRITE_EXTERNAL_STORAGE}, 1);

                    //String filePath = Environment.getExternalStorageDirectory() + "/saveconfig/";
                    //String fileName = editname.getText().toString();
                    //writeTxtToFile(editdetail.getText().toString().trim(), filePath, fileName);
                }

                break;
            default:
                break;
        }
    }

    @Override
    public void onPageSelected(int index) {

        Animation animation = null;
        switch (index) {
            case 0:
                /*
                if (currIndex == 1) {
                    animation = new TranslateAnimation(one, 0, 0, 0);
                } else if (currIndex == 2) {
                    animation = new TranslateAnimation(two, 0, 0, 0);
                }
                */
                animation = new TranslateAnimation(one * currIndex, 0, 0, 0);
                break;
            case 1:
                if (currIndex == 0) {
                    animation = new TranslateAnimation(offset, one, 0, 0);
                } else {// if (currIndex == 2) {
                    //animation = new TranslateAnimation(two, one, 0, 0);
                    animation = new TranslateAnimation(one * currIndex, one, 0, 0);
                }
                break;
            case 2:
                if (currIndex == 0) {
                    animation = new TranslateAnimation(offset, two, 0, 0);
                } else {//if (currIndex == 1) {
                    //animation = new TranslateAnimation(one, two, 0, 0);
                    animation = new TranslateAnimation(one * currIndex, two, 0, 0);
                }
                break;
            case 3:
                if (currIndex == 0) {
                    animation = new TranslateAnimation(offset, three, 0, 0);
                } else {//if (currIndex == 1) {
                    //animation = new TranslateAnimation(one, two, 0, 0);
                    animation = new TranslateAnimation(one * currIndex, three, 0, 0);
                }
                break;
            case 4:
                if (currIndex == 0) {
                    animation = new TranslateAnimation(offset, four, 0, 0);
                } else {//if (currIndex == 1) {
                    //animation = new TranslateAnimation(one, two, 0, 0);
                    animation = new TranslateAnimation(one * currIndex, four, 0, 0);
                }
                break;
            case 5:
                if (currIndex == 0) {
                    animation = new TranslateAnimation(offset, five, 0, 0);
                } else {//if (currIndex == 1) {
                    //animation = new TranslateAnimation(one, two, 0, 0);
                    animation = new TranslateAnimation(one * currIndex, five, 0, 0);
                }
                break;
            case 6:
                if (currIndex == 0) {
                    animation = new TranslateAnimation(offset, six, 0, 0);
                } else {//if (currIndex == 1) {
                    //animation = new TranslateAnimation(one, two, 0, 0);
                    animation = new TranslateAnimation(one * currIndex, six, 0, 0);
                }
                break;
            case 7:
                if (currIndex == 0) {
                    animation = new TranslateAnimation(offset, seven, 0, 0);
                } else {//if (currIndex == 1) {
                    //animation = new TranslateAnimation(one, two, 0, 0);
                    animation = new TranslateAnimation(one * currIndex, seven, 0, 0);
                }
                break;
            /*
            case 8:
                if (currIndex == 0) {
                    animation = new TranslateAnimation(offset, eight, 0, 0);
                } else {//if (currIndex == 1) {
                    //animation = new TranslateAnimation(one, two, 0, 0);
                    animation = new TranslateAnimation(one * currIndex, eight, 0, 0);
                }
                break;
            case 9:
                if (currIndex == 0) {
                    animation = new TranslateAnimation(offset, nine, 0, 0);
                } else {//if (currIndex == 1) {
                    //animation = new TranslateAnimation(one, two, 0, 0);
                    animation = new TranslateAnimation(one * currIndex, nine, 0, 0);
                }
                break;
            */
            default:
                break;
        }
        currIndex = index;
        animation.setFillAfter(true);// true表示图片停在动画结束位置
        animation.setDuration(300); //设置动画时间为300毫秒
        img_cursor.startAnimation(animation);//开始动画
        iChooseVPager = index; //获取当前Vpager的索引，以便知道在哪个pager
    }

    @Override
    public void onPageScrollStateChanged(int i) {
        switch (i){
            case 0:

                break;
            case 1:

                break;
            case 2:

                break;
        }
    }

    @Override
    public void onPageScrolled(int i, float v, int i1) {
        //edtshow3.setText("333");
        switch (i){
            case 0:

                break;
            case 1:

                break;
            case 2:
                break;
        }
    }

    private byte iicByteData[]={
            //0    1   2     3    4    5    6
            0x03,0x00,0x0f,0x00,0x00,0x00,0x01,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

    };
    private byte iicWriteData[]={
            //0    1   2     3    4    5    6
            0x03,0x00,0x0f,0x00,0x00,0x00,0x39,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

    };

    //发送命令，使得S818可以通过IIC向GT9的固定地址写任意bytes的数据
    private  boolean iicWriteCommand(byte command,byte addressHigh,byte addressLow,int offset,int length) {
        int i;

        iicWriteData[1] = 0x01; //write GT9PT command
        iicWriteData[2] = command; //command
        iicWriteData[3] = addressHigh;
        iicWriteData[4] = addressLow;
        iicWriteData[5] = 0x00;
        iicWriteData[6] = 0x39;  //length 57

        int address1 = ((addressHigh&0xff)<<8);
        int address2 = addressLow&0xff;
        int address = address1|address2;

        int sendTimes = length/57 + 1;  //预计是向下取整，所以+1

        for (int k = 0; k < sendTimes; k++) {
            int finalOffset = offset + k*57; //每次只能发57bytes数据

            if(length - (finalOffset -offset) < 57) {

                iicWriteData[6] = (byte) (length - (finalOffset -offset));  //length
            }
            else
            {
                iicWriteData[6] = 0x39;
            }

            for (int j = 7; j < 64; j++) {
                iicWriteData[j] = 0;//wBuffer[finalOffset + j -7];
            }
            i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointOut, iicWriteData, 0, 0x40, 100);

            if (i != 0x40) {
                //editname.setText("iicWrite Failed");
                return false;

            }

            address = address + 57;
            iicWriteData[3] = (byte)(address>>8);
            iicWriteData[4] = (byte)address;
        }

        return true;
    }

    //发送命令，使得S818可以通过IIC向GT9的固定地址读取任意bytes的数据
    private boolean iicRead(byte addressHigh,byte addressLow,byte[] wBuffer,int length) {

        int i;
        iicByteData[1] = 0x00; //read GT9 command
        iicByteData[2] = 0x0f; //no command
        iicByteData[3] = addressHigh;
        iicByteData[4] = addressLow;
        iicByteData[5] = (byte)(length>>8);
        iicByteData[6] = (byte)(length);// 一次接收63个数据

        //for (int j = 7; j < 64; j++) {
         //   iicWriteData[j] = 0x00;
        //}

        int address1 = ((addressHigh&0xff)<<8);
        int address2 = addressLow&0xff;
        int address = address1|address2;

        int sendTimes = length/63 + 1;  //预计是向下取整，所以+1

        i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointOut, iicByteData, 0x40, 100);

        if (i != 0x40) {
            editname.setText("iicWrite Failed");
            return false;
        }

        int offset = 0;
        for (int k = 0; k < sendTimes; k++) {
            //接收数据
            i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointIn, wBuffer, offset, 0x40, 3000);

            if (i != 0x40) {
                editname.setText("iicRead Failed");
                return false;
            }
            offset+=64;
            address = address + 63;
            iicByteData[3] = (byte)(address>>8);
            iicByteData[4] = (byte)address;
        }

        //将report id从数组中去除
        //byte[] temperBuffer =new byte[length];
        if(true) {
            int count1 = 0;
            for (int k = 0; k < length; k++) {
                if (k % 63 == 0) {
                    count1++;
                }

                wBuffer[k] = wBuffer[k + count1];

            }
        }
        return true;
    }
    //发送命令，使得S818可以通过IIC向GT9的固定地址写任意bytes的数据
    private  boolean iicWrite(byte addressHigh,byte addressLow,byte[] wBuffer,int offset,int length) {
        int i;

        iicWriteData[1] = 0x01; //write GT9 command
        iicWriteData[2] = 0x0f; //no command
        iicWriteData[3] = addressHigh;
        iicWriteData[4] = addressLow;
        iicWriteData[5] = 0x00;
        iicWriteData[6] = 0x39;  //length

        int address1 = ((addressHigh&0xff)<<8);
        int address2 = addressLow&0xff;
        int address = address1|address2;

        int sendTimes = length/57 + 1;  //预计是向下取整，所以+1

        for (int k = 0; k < sendTimes; k++) {
            int finalOffset = offset + k*57; //每次只能发57bytes数据

            if(length - (finalOffset -offset) < 57) {

                iicWriteData[6] = (byte) (length - (finalOffset -offset));  //length
            }
            else
            {
                iicWriteData[6] = 0x39;
            }

            for (int j = 7; j < 64; j++) {
                iicWriteData[j] = wBuffer[finalOffset + j -7];
            }
            i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointOut, iicWriteData, 0, 0x40, 100);

            if (i != 0x40) {
                editname.setText("iicWrite Failed");
                return false;

            }

            address = address + 57;
            iicWriteData[3] = (byte)(address>>8);
            iicWriteData[4] = (byte)address;
        }

        return true;
    }

    boolean memCmp(byte[] sBuffer,byte[] dBuffer,int offset,int length) {
        try {

            for (int i = 0; i < length; i++) {
                if (sBuffer[i] != dBuffer[offset + i]) {
                    // FwUpdateMessage(L"Recall frame data fail,not equal.", MSG_ERR);
                    // mError.setText("Recall frame data fail,not equal.");
                    return false;
                }
            }
        } catch (ArithmeticException e) {
            mShow.setText("ArithmeticException!");
            e.printStackTrace();
        } catch (ArrayIndexOutOfBoundsException e) {
            mShow.setText("ArrayIndexOutOfBoundsException!");
            e.printStackTrace();
        }

        return true;
    }

    boolean recallCheck(byte addressHigh,byte addressLow,byte[] wBuffer,int offset,int length)
    {
        //BYTE* pbBuf = new BYTE[wLen];
        byte[] pbBuf =new byte[length+0x3000];

        //if(false)
        {
            if (!iicRead(addressHigh, addressLow, pbBuf, length)) {
                //FwUpdateMessage(L"recall i2c error failed", MSG_ERR);
                mShow.setText("recall i2c error failed");
                return false;
            }
            if (!memCmp(pbBuf, wBuffer, offset, length)) {

                // FwUpdateMessage(L"Recall frame data fail,not equal.", MSG_ERR);
                //mMessage.setText("Recall frame data fail,not equal.");
                return false;
            }
        }
        return true;

    }

    @Override
    protected void onDestroy() {
        super.onDestroy();

        if (mUsbDeviceConnection != null) {
            mUsbDeviceConnection.releaseInterface(mUsbInterface);
            mUsbDeviceConnection.close();
            mUsbDeviceConnection = null;
        }
        mUsbEndpointIn = null;
        mUsbEndpointOut = null;
        isNeedFindDevice = false;
        mThreadPool.shutdownNow();
       // unregisterReceiver(mUsbDetachedReceiver);
        unregisterReceiver(cfgOpenDevicesReceiver);
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        switch (requestCode) {
            case 1:
                String filePath;// = Environment.getExternalStorageDirectory() + "/saveconfig/";
                String fileName;
                if (grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    //创建文件夹
                    if (Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)) {

                        StringBuilder configBuilder = new StringBuilder("");

                        if (iChooseVPager == 8){ //在ram cfg界面
                            configBuilder.append("0x"+mCfg8050.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8051.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8052.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8053.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8054.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8055.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8056.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8057.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8058.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8059.getText().toString()+",");
                            configBuilder.append("0x"+mCfg805A.getText().toString()+",");
                            configBuilder.append("0x"+mCfg805B.getText().toString()+",");
                            configBuilder.append("0x"+mCfg805C.getText().toString()+",");
                            configBuilder.append("0x"+mCfg805D.getText().toString()+",");
                            configBuilder.append("0x"+mCfg805E.getText().toString()+",");
                            configBuilder.append("0x"+mCfg805F.getText().toString()+",");

                            configBuilder.append("0x"+mCfg8060.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8061.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8062.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8063.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8064.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8065.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8066.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8067.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8068.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8069.getText().toString()+",");
                            configBuilder.append("0x"+mCfg806A.getText().toString()+",");
                            configBuilder.append("0x"+mCfg806B.getText().toString()+",");
                            configBuilder.append("0x"+mCfg806C.getText().toString()+",");
                            configBuilder.append("0x"+mCfg806D.getText().toString()+",");
                            configBuilder.append("0x"+mCfg806E.getText().toString()+",");
                            configBuilder.append("0x"+mCfg806F.getText().toString()+",");

                            configBuilder.append("0x"+mCfg8070.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8071.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8072.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8073.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8074.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8075.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8076.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8077.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8078.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8079.getText().toString()+",");
                            configBuilder.append("0x"+mCfg807A.getText().toString()+",");
                            configBuilder.append("0x"+mCfg807B.getText().toString()+",");
                            configBuilder.append("0x"+mCfg807C.getText().toString()+",");
                            configBuilder.append("0x"+mCfg807D.getText().toString()+",");
                            configBuilder.append("0x"+mCfg807E.getText().toString()+",");
                            configBuilder.append("0x"+mCfg807F.getText().toString()+",");

                            configBuilder.append("0x"+mCfg8080.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8081.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8082.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8083.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8084.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8085.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8086.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8087.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8088.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8089.getText().toString()+",");
                            configBuilder.append("0x"+mCfg808A.getText().toString()+",");
                            configBuilder.append("0x"+mCfg808B.getText().toString()+",");
                            configBuilder.append("0x"+mCfg808C.getText().toString()+",");
                            configBuilder.append("0x"+mCfg808D.getText().toString()+",");
                            configBuilder.append("0x"+mCfg808E.getText().toString()+",");
                            configBuilder.append("0x"+mCfg808F.getText().toString()+",");

                            configBuilder.append("0x"+mCfg8090.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8091.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8092.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8093.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8094.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8095.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8096.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8097.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8098.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8099.getText().toString()+",");
                            configBuilder.append("0x"+mCfg809A.getText().toString()+",");
                            configBuilder.append("0x"+mCfg809B.getText().toString()+",");
                            configBuilder.append("0x"+mCfg809C.getText().toString()+",");
                            configBuilder.append("0x"+mCfg809D.getText().toString()+",");
                            configBuilder.append("0x"+mCfg809E.getText().toString()+",");
                            configBuilder.append("0x"+mCfg809F.getText().toString()+",");

                            configBuilder.append("0x"+mCfg80A0.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80A1.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80A2.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80A3.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80A4.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80A5.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80A6.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80A7.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80A8.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80A9.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80AA.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80AB.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80AC.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80AD.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80AE.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80AF.getText().toString()+",");

                            configBuilder.append("0x"+mCfg80B0.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80B1.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80B2.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80B3.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80B4.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80B5.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80B6.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80B7.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80B8.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80B9.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80BA.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80BB.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80BC.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80BD.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80BE.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80BF.getText().toString()+",");

                            configBuilder.append("0x"+mCfg80C0.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80C1.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80C2.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80C3.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80C4.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80C5.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80C6.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80C7.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80C8.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80C9.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80CA.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80CB.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80CC.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80CD.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80CE.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80CF.getText().toString()+",");

                            configBuilder.append("0x"+mCfg80D0.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80D1.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80D2.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80D3.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80D4.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80D5.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80D6.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80D7.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80D8.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80D9.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80DA.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80DB.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80DC.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80DD.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80DE.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80DF.getText().toString()+",");

                            configBuilder.append("0x"+mCfg80E0.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80E1.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80E2.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80E3.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80E4.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80E5.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80E6.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80E7.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80E8.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80E9.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80EA.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80EB.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80EC.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80ED.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80EE.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80EF.getText().toString()+",");

                            configBuilder.append("0x"+mCfg80F0.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80F1.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80F2.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80F3.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80F4.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80F5.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80F6.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80F7.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80F8.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80F9.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80FA.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80FB.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80FC.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80FD.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80FE.getText().toString()+",");
                            configBuilder.append("0x"+mCfg80FF.getText().toString()+",");

                            configBuilder.append("0x"+mCfg8100.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8101.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8102.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8103.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8104.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8105.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8106.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8107.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8108.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8109.getText().toString()+",");
                            configBuilder.append("0x"+mCfg810A.getText().toString()+",");
                            configBuilder.append("0x"+mCfg810B.getText().toString()+",");
                            configBuilder.append("0x"+mCfg810C.getText().toString()+",");
                            configBuilder.append("0x"+mCfg810D.getText().toString()+",");
                            configBuilder.append("0x"+mCfg810E.getText().toString()+",");
                            configBuilder.append("0x"+mCfg810F.getText().toString()+",");

                            configBuilder.append("0x"+mCfg8110.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8111.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8112.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8113.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8114.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8115.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8116.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8117.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8118.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8119.getText().toString()+",");
                            configBuilder.append("0x"+mCfg811A.getText().toString()+",");
                            configBuilder.append("0x"+mCfg811B.getText().toString()+",");
                            configBuilder.append("0x"+mCfg811C.getText().toString()+",");
                            configBuilder.append("0x"+mCfg811D.getText().toString()+",");
                            configBuilder.append("0x"+mCfg811E.getText().toString()+",");
                            configBuilder.append("0x"+mCfg811F.getText().toString()+",");

                            configBuilder.append("0x"+mCfg8120.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8121.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8122.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8123.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8124.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8125.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8126.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8127.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8128.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8129.getText().toString()+",");
                            configBuilder.append("0x"+mCfg812A.getText().toString()+",");
                            configBuilder.append("0x"+mCfg812B.getText().toString()+",");
                            configBuilder.append("0x"+mCfg812C.getText().toString()+",");
                            configBuilder.append("0x"+mCfg812D.getText().toString()+",");
                            configBuilder.append("0x"+mCfg812E.getText().toString()+",");
                            configBuilder.append("0x"+mCfg812F.getText().toString()+",");

                            configBuilder.append("0x"+mCfg8130.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8131.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8132.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8133.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8134.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8135.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8136.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8137.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8138.getText().toString()+",");
                            configBuilder.append("0x"+mCfg8139.getText().toString()+",");
                            configBuilder.append("0x"+mCfg813A.getText().toString()+",");
                            configBuilder.append("0x"+mCfg813B.getText().toString()+",");
                            configBuilder.append("0x"+mCfg813C.getText().toString()+",");
                            configBuilder.append("0x"+mCfg813D.getText().toString()+",");
                            //configBuilder.append("0x"+mCfg813E.getText().toString()+",");
                            //configBuilder.append("0x"+mCfg813F.getText().toString()+",");

                            configBuilder.append("0x01"+",");

                            configBuilder.append("0x"+mCfgBF7B.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF7C.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF7D.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF7E.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF7F.getText().toString()+",");

                            configBuilder.append("0x"+mCfgBF80.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF81.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF82.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF83.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF84.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF85.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF86.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF87.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF88.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF89.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF8A.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF8B.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF8C.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF8D.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF8E.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF8F.getText().toString()+",");

                            configBuilder.append("0x"+mCfgBF90.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF91.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF92.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF93.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF94.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF95.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF96.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF97.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF98.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF99.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF9A.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF9B.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF9C.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF9D.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF9E.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBF9F.getText().toString()+",");

                            configBuilder.append("0x"+mCfgBFA0.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFA1.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFA2.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFA3.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFA4.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFA5.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFA6.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFA7.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFA8.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFA9.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFAA.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFAB.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFAC.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFAD.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFAE.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFAF.getText().toString()+",");

                            configBuilder.append("0x"+mCfgBFB0.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFB1.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFB2.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFB3.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFB4.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFB5.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFB6.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFB7.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFB8.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFB9.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFBA.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFBB.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFBC.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFBD.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFBE.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFBF.getText().toString()+",");

                            configBuilder.append("0x"+mCfgBFC0.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFC1.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFC2.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFC3.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFC4.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFC5.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFC6.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFC7.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFC8.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFC9.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFCA.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFCB.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFCC.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFCD.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFCE.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFCF.getText().toString()+",");

                            configBuilder.append("0x"+mCfgBFD0.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFD1.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFD2.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFD3.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFD4.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFD5.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFD6.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFD7.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFD8.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFD9.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFDA.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFDB.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFDC.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFDD.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFDE.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFDF.getText().toString()+",");

                            configBuilder.append("0x"+mCfgBFE0.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFE1.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFE2.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFE3.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFE4.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFE5.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFE6.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFE7.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFE8.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFE9.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFEA.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFEB.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFEC.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFED.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFEE.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFEF.getText().toString()+",");

                            configBuilder.append("0x"+mCfgBFF0.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFF1.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFF2.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFF3.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFF4.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFF5.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFF6.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFF7.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFF8.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFF9.getText().toString()+",");
                            configBuilder.append("0x"+mCfgBFFA.getText().toString());

                        }else{ //在其他界面则保存
                            CombineCfg();
                            for (int i = 0; i < 185; i++){
                                String hv = Integer.toHexString(mBytes[i] & 0xFF);
                                if (hv.length() < 2){
                                    hv = "0" + hv;
                                }
                                configBuilder.append("0x" + hv + ",");
                            }

                            configBuilder.append("0x01");  //mBytes[185]，最后置上1
                        }

                        filePath = Environment.getExternalStorageDirectory() + "/saveconfig/";
                        //File file = new File(filePath);
                        fileName = editname.getText().toString();
                        writeTxtToFile(configBuilder.toString().trim(), filePath, fileName);

                        mShow.setText(fileName + "  保存到："+ filePath.toString());

                    }
                }
                break;
            case 2:
                if (grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    //创建文件夹
                    if (Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)) {

                    }
                }
                break;
            default:
                break;
        }
    }
    // 将字符串写入到文本文件中
    public void writeTxtToFile(String strcontent, String filePath, String fileName) {
        // 生成文件夹之后，再生成文件，不然会出错
        makeFilePath(filePath, fileName);

        String strFilePath = filePath + fileName;
        // 每次写入时，都换行写
        String strContent = strcontent + "\r\n";
        try {
            File file = new File(strFilePath);
            if (!file.exists()) {
                Log.d("TestFile", "Create the file:" + strFilePath);
                file.getParentFile().mkdirs();
                file.createNewFile();
            }
            RandomAccessFile raf = new RandomAccessFile(file, "rwd");
            raf.seek(file.length());
            raf.write(strContent.getBytes());
            raf.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    // 生成文件
    public File makeFilePath(String filePath, String fileName) {
        File file = null;
        makeRootDirectory(filePath);
        try {
            file = new File(filePath + fileName);
            if (!file.exists()) {
                file.createNewFile();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return file;
    }

    // 生成文件夹
    public static void makeRootDirectory(String filePath) {
        File file = null;
        try {
            file = new File(filePath);
            if (!file.exists()) {
                file.mkdir();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

